/*
   Copyright (C) 2007-2008 contributors

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

function showLayer(layerID)
{
	var layer = document.getElementById(layerID);
	layer.style.visibility = 'visible';
}

function hideLayer(layerID)
{
	var layer = document.getElementById(layerID);
	layer.style.visibility = 'hidden';
}

function lineTop(obj, bShow)
{
  var tds = obj.parentNode.parentNode.getElementsByTagName("td");
  var length = obj.parentNode.cellIndex;
  for (i=1; i<length; i++)
  {
    if (bShow)
    {
      tds[i].style.borderTop = "2px solid #ffff00";
      tds[i].style.paddingTop = "0px";
    }
    else
    {
      tds[i].style.borderTop = "";
      tds[i].style.paddingTop = "";
    }
  }
}

function setTimes()
{
	var now = new Date();
	//alert("Test " + now.getMinutes());

	document.add.hour.value = now.getHours();
	document.add.min.value = now.getMinutes();
}

function isChannelSelected()
{
  if(document.add.channel.length == null)
  {
    if(document.add.channel.checked == true)
    {
  	  var inputs = document.getElementsByTagName('input');
  	  for (x=0; x<inputs.length; x++)
  	  {
  	    inputs[x].disabled = false;
      }
      return true;
    }
    else
    {
      alert("You must select a channel");
      return false;
    }
  }
   
	var selected = false;
	var x = 0;
	for(x = 0; x < document.add.channel.length; x++)
	{
		if(document.add.channel[x].checked == true)
		{
			selected = true;
			break;
		}
	}

	if(selected == true)
	{
	  var inputs = document.getElementsByTagName('input');
	  for (x=0; x<inputs.length; x++)
	  {
	    inputs[x].disabled = false;
    }
		return true;
	}
	else
	{
		alert("You must select a channel");
		return false;
	}
}
function openDetails(url)
{
   var w = screen.availWidth;
   var h = screen.availHeight;

   var popW = 650;
   var popH = 550;

   var leftPos = (w - popW) / 2;
   var topPos = (h - popH) / 2;

   var popupWin = window.open(url ,'popup','width=' + popW + ',height=' + popH + ',top=' + topPos + ',left=' + leftPos +',scrollbars=yes,resizable=yes');
   popupWin.focus();
}

function showHelp(name)
{
   var w = screen.availWidth;
   var h = screen.availHeight;

   var popW = 500;
   var popH = 300;

   var leftPos = (w - popW) / 2;
   var topPos = (h - popH) / 2;

   var fileName;
   if (name.indexOf('/') > -1)
      fileName = name;
   else
      fileName = "/?action=03&name=" + name;
      
   var popupWin = window.open(fileName ,'help_popup','width=' + popW + ',height=' + popH + ',top=' + topPos + ',left=' + leftPos +',scrollbars=yes,resizable=yes');
   popupWin.focus();
}

function changeImage(imageOvered, newImage)
{
   imageOvered.src = newImage
}

function scrollToPos(toThis)
{
   var layer = null;
   var framed = false;
   
   if(parent.frames["mainFrame"] != null)
   {
      framed = true;
      layer = parent.frames["mainFrame"].document.getElementById("hour" + toThis);
   }
   else
      layer = document.getElementById("hour" + toThis);
      
   var iW = document.body.clientWidth;
   var iH = document.body.clientHeight;

   if(layer != null)
   {
      var scrolTo = layer.offsetLeft - (iW/2);
      
      if(framed)
         parent.frames["mainFrame"].window.scroll(scrolTo,0);
      else
         window.scroll(scrolTo,0);
         
   }
   else
   {
      alert("Not Found");
   }
   
}

function setCookie(cookieName, cookieValue, nDays)
{
  var today = new Date();
  var expire = new Date();
  
  if (nDays==null || nDays==0)
     nDays=1;
  
  expire.setTime(today.getTime() + 3600000*24*nDays);
  
  //document.cookie = cookieName+"=" + encodeURIComponent(cookieValue) + ";expires="+expire.toGMTString();
  document.cookie = cookieName+"=" + encodeURIComponent(cookieValue);
  
}

function readCookie(cookieName)
{
  var theCookie=""+document.cookie;
  var ind=theCookie.indexOf(cookieName);
  
  if (ind==-1 || cookieName=="")
     return ""; 
     
  var ind1=theCookie.indexOf(';',ind);
  
  if (ind1==-1)
     ind1=theCookie.length; 
     
  return decodeURIComponent(theCookie.substring(ind+cookieName.length+1,ind1));
}

function tickAll()
{
  var ticked = document.getElementById("addAll").checked;
  var ticks = document.getElementsByTagName("input");
  
  for (i=0; i<ticks.length; i++)
  {
    if (ticks[i].type == 'checkbox')
      ticks[i].checked = ticked;
  }
}

function unTickAddAll()
{
  document.getElementById("addAll").checked = false;
}

var menuHierarchy = [
  ["<img border=0 src='/images/nav.png' align='absmiddle' width='16' height='16'>", '/', 
  	["<img border=0 src='/images/epg16.png' align='absmiddle' width='16' height='16'> EPG", '/servlet/EpgDataRes?action=12&scrollto=-1', 
  		['Search EPG', '/servlet/EpgDataRes?action=22'],
  		['Favorites', '/servlet/EpgDataRes?action=29&search=yes&flag=matched'],
  		['Show Now and Next', '/servlet/EpgDataRes?action=21'],
  		['Auto-Add List', '/servlet/EpgAutoAddDataRes?action=01'],
  		['Epg Match Lists', '/servlet/EpgAutoAddDataRes?action=05'],
  		['Refresh Favorites', '/servlet/EpgAutoAddDataRes?action=28'],
  		['Run Auto-Add Scan', "javascript:confirmMenuAction('/servlet/EpgAutoAddDataRes?action=15')"],
  		['Auto-Add Conflicts', '/servlet/EpgAutoAddDataRes?action=25'],
  		['Auto-Add Exclusions', '/servlet/EpgDataRes?action=30&search=yes&flag=excluded'],
  		['ReLoad Data', "javascript:confirmMenuAction('/servlet/EpgDataRes?action=03')"],
  		['Data Source Settings', '/servlet/EpgDataRes?action=16'],
  		['Channel Mapping', '/servlet/EpgDataRes?action=04'],
  		['EPG Data Report', '/servlet/EpgDataRes?action=02']
  	],
  	["<img border=0 src='/images/schedule16.png' align='absmiddle' width='16' height='16'> Schedules", '/servlet/ScheduleDataRes', 
  		['New Schedule', '/servlet/ScheduleDataRes?action=01' + '&dari=' + encodeURIComponent(document.location.href)],
  		['Channel Surf', '/servlet/ScheduleDataRes?action=22']
  	],
  	["<img border=0 src='/images/settings16.png' align='absmiddle' width='16' height='16'> System", '/settings.html',
  		['Select Devices', '/servlet/SystemDataRes?action=04'],
  		['Channel Settings', '/servlet/ChannelDataRes'],
  		['Surf Channel Order', '/servlet/ChannelDataRes?action=14'],
  		['Manage Files', "/servlet/FileManagementDataRes"],
  		['Auto Deletable File', '/servlet/SystemDataRes?action=06'],
  		['System Config', '/servlet/SystemDataRes?action=02'],
  		['System Info', '/servlet/SystemDataRes'],
  		['Edit Tasks', '/servlet/SystemDataRes?action=08'],
  		['Active Tasks', "/servlet/TaskManagementDataRes"],
  		['Keyboard Interface', "/servlet/ApplyTransformRes?xml=null&xsl=kb-root"],
  		['Interface Theme', '/servlet/SystemDataRes?action=19'],
  		['Suspend Computer', "javascript:confirmMenuAction('/servlet/SystemDataRes?action=37' + '&dari=' + encodeURIComponent(document.location.href))"],
  		['Hibernate Computer', "javascript:confirmMenuAction('/servlet/SystemDataRes?action=38 + '&dari=' + encodeURIComponent(document.location.href)')"],
  		['Shutdown Computer', "javascript:confirmMenuAction('/servlet/SystemDataRes?action=39 + '&dari=' + encodeURIComponent(document.location.href)')"]
  	]
	]
];

var menuConfig = [
{
	'height':  16,
	'width' : 16,
	'firstX' : 3,
	'firstY' : 3,
	'hideAfter' : 250,
	'css' : 'menulogo',
	'trace' : true
},
{
	'height':  23,
	'width' : 90,
	'firstY' : 16,
	'firstX' :  0,
	'nextX' : 1,
	'css' : 'menumain'
},
{
  'width' : 135,
	'firstX' : 0,
	'firstY' : 24,
	'nextY' : -1
}
];

function confirmMenuAction(url)
{
    if (confirm('Are you sure?'))
        document.location.href = url;
}

// Product title: Gurt JavaScript Menu
// Product version details: 1.1, 01-25-2006 (mm-dd-yyyy) [compressed version]
// Product URL: http://gurtom.com/products/menus/js
// Contact info: gurt-feedback@gurtom.com (specify product title in subject line)
// Notes: This script is free. Feel free to copy, use and change this script as 
// long as this head part remains unchanged. Visit official site for details.
// Copyright: (c) 2006 by Gurtom.Com

var menus=[],_m3=window.external?[' style="width:100%;height:100%"','div onclick="','div']:['','a href="javascript:','a'],_mC=document.getElementById?function(_mR){return document.getElementById(_mR)}:function(_mR){return document.all[_mR]};function menu(_m1,_mO){var _=this,i;_._m1=_m1;_._mO=_mO;_._mS='';_.id=menus.length;_._m0=[];_._m2=[];_._m4=[0,0];_._mO[-1]={'firstX':20,'firstY':20,'nextX':15,'nextY':15,'width':100,'height':22,'hideAfter':200,'target':'_self','trace':0,'css':''};for(i=0;i<_._m1.length;i++)if(_._m1[i])new _mE(0,_,_,_._m1[i]);for(i=0;i<_._m2.length;i++)_mA(_._m2[i],1);menus[_.id]=_;}function _mD(_mK){var i,a=menus[_mK]._m0;for(i=0;i<a.length;i++){_mA(a[i],0);_mB(a[i],'norm');}}function _mF(_mK,_mI){var m=menus[_mK],_=m._m0[_mI]._m1[1];_mB(m._m0[_mI],'clck');if(_)open(_,_m9(m._m0[_mI]._m8,m._mO,'target'));}function _mG(_mK,_mI){var m=menus[_mK];m._mL=setTimeout('_mD('+_mK+')',_m9(m._mN._m8,m._mO,'hideAfter'));if(m._mN.id==_mI)m._mN=null;}function _mH(_mK,_mI){var m=menus[_mK],_,_m7,i;m._mN=_=m._m0[_mI];if(m._mL)clearTimeout(m._mL);for(i=0;i<m._m0.length;i++){_=m._m0[i];_m7=!m._mN._mS.indexOf(_._mT);if(_m7)_mB(_,_==m._mN?'over':'norm');_mA(_,_m7);}if(m._mN._m6)for(i=m._mN;i&&i._m5;i=i._mP)_mB(i,'over');}function _mE(l,p,m,_m1){var _=this,i,c=p._m2.length,_mO=m._mO;_._m1=_m1;_._mP=p;_._mT=p._mS;_._mS=p._mS+c+':';_._m8=l;_.id=m._m0.length;m._m0[_.id]=_;p._m2[c]=_;var id=m.id+','+_.id,nX,nY;_._m6=_m9(l,_mO,'trace');for(i=l;i>=-1;i--){if(_mO[i]&&_mO[i]['nextX']!=null)nX=_mO[i]['nextX'];if(_mO[i]&&_mO[i]['nextY']!=null)nY=_mO[i]['nextY'];if(nX!=null||nY!=null)break;}_._m4=[p._m4[0]+_m9(l,_mO,'firstX')+(nX!=null?nX*c+_m9(l,_mO,'width')*c:0),p._m4[1]+_m9(l,_mO,'firstY')+(nY!=null?nY*c+_m9(l,_mO,'height')*c:0)];document.write('<',_m3[1],'_mF(',id,')" id="me',id,'" style="position:absolute;top:',_._m4[1],'px;left:',_._m4[0],'px;width:',_m9(l,_mO,'width'),'px;height:',_m9(l,_mO,'height'),'px;visibility:hidden;z-index:',l,';text-decoration:none" onmouseout="_mG(',id,')" onmouseover="_mH(',id,')"><div',_m3[0],' id="mi',id,'" class="',_m9(l,_mO,'css'),'norm">',_m1[0],'</div></',_m3[2],'>');_._m5=[_mC('me'+m.id+','+_.id),_mC('mi'+m.id+','+_.id),_m9(l,_mO,'css')];if(_m1.length>2){_._m2=[];for(i=2;i<_m1.length;i++)if(_m1[i])new _mE(l+1,_,m,_m1[i]);}}function _mA(_,_mJ){if(_._mQ==_mJ)return;_._mQ=_mJ;if(_mJ)_._m5[0].style.visibility='visible';else if(_._m8)_._m5[0].style.visibility='hidden';}function _mB(_,_mM){if(_._m5[3]==_mM)return;_._m5[3]=_mM;_._m5[1].className=_._m5[2]+_mM}function _m9(l,_mO,k){for(var i=l;i>=-1;i--)if(_mO[i]&&_mO[i][k]!=null)return _mO[i][k];}

new menu (menuHierarchy, menuConfig);
