<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp "&#160;"> ]>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

	<xsl:template match="/">
		<html>
			<link rel="stylesheet" href="/css/-epgPage.css" type="text/css" />
			<link rel="stylesheet" href="/css/colour.css" type="text/css" />
			<head>

<script src="/javascript/extra.js" />
<xsl:comment>[if lt IE 7.0]&gt;
&lt;script src="/javascript/iepng.js"&gt;&lt;/script&gt;
&lt;![endif]</xsl:comment>

<script src="/javascript/-epgPage.js" />

<title>EPG - (<xsl:value-of select="//@date" />/<xsl:value-of select="//@month" />/<xsl:value-of select="//@year" />)</title>
<script>
var cellHighlighted;
var bCellHighlighted = false;
var totalSchMinute, cellHeight, cellWidth, balloonDelay;
var timeDifference;

function saveVars()
{
  totalSchMinute = <xsl:value-of select="//@scheduledhour" />*60 + <xsl:value-of select="//@scheduledminute" />;
  
  cellHeight = <xsl:value-of select="//@height" />;
  cellWidth = <xsl:value-of select="//@width" />;
  balloonDelay = <xsl:value-of select="//@balloonDelay" />;
  var now = new Date();
  timeDifference = now.getHours() + now.getMinutes()/60.0 - <xsl:value-of select="//@nowHour" /> - <xsl:value-of select="//@nowMinute" /> / 60.0;
  
  if (document.attachEvent)
  {
    document.attachEvent("onmouseup", endResize);
    document.attachEvent("onmousemove", trackResize);
  }
  
  if (document.addEventListener)
  {
    document.addEventListener("mouseup", endResize, false);
    document.addEventListener("mousemove", trackResize, false);
  }
}

setInterval('timeline()', 60000);

function timeline()
{
  var mainDiv = document.getElementById("mainDiv");
  if (mainDiv == null) return;
  var timeline = document.getElementById('timeline');
  timeline.style.height = mainDiv.scrollHeight + 'px';
  var now = new Date();
  var adj = now.getHours() + now.getMinutes()/60.0 - timeDifference;
  if(adj &lt; 0)
    adj += 24;
  else if (adj &gt;= 24)
    adj -= 24;
  adj -= 6;
  if(adj &lt; 0)
    adj += 24;
  timeline.style.left = (adj * <xsl:value-of select="//@height" />) + 'px';
}

function epgFocus()
{
  document.getElementById("mainDiv").focus();
}

function highlightCell(oCell)
{
  if (bCellHighlighted == false)
  {
    oCell.style.backgroundColor = 'lightblue';
    //oCell.style.color = 'black';
    cellHighlighted = oCell;
    bCellHighlighted = true;
  }
}

function lowlightCell()
{
  if ( bCellHighlighted )
  {
    cellHighlighted.style.backgroundColor = '';
    //cellHighlighted.style.color = '';
    bCellHighlighted = false;
  }
}

function toggleScheduleCell(oCell, actionID)
{
  var itemIcons = document.getElementById(actionID+"A");
  if (itemIcons == null) return;
  
  if(itemIcons.style.visibility == "visible")
  {
    if (itemIcons.offsetTop == (oCell.offsetTop + 24))
      itemIcons.style.visibility = "hidden";
    else
    {
      itemIcons.style.left = oCell.offsetLeft &lt; 0 ? 0 : oCell.style.left;
      itemIcons.style.top = oCell.offsetTop + 24;
    }
  }
  else
  {
    itemIcons.style.left = oCell.offsetLeft &lt; 0 ? 0 : oCell.style.left;
    itemIcons.style.top = oCell.offsetTop + 24;
    itemIcons.style.visibility = "visible";                  
  }
}

function showTitle(obj)
{
  var id = obj.getAttribute('id');
  var channel = obj.getAttribute('channel');

  var w = screen.availWidth;
  var h = screen.availHeight;

  var popW = 650;
  var popH = 550;

  var leftPos = (w - popW) / 2;
  var topPos = (h - popH) / 2;

  var newWindow = window.open('/servlet/EpgDataRes?action=06&amp;id=' + id + '&amp;channel=' + encodeURIComponent(channel) ,'popup','width=' + popW + ',height=' + popH + ',top=' + topPos + ',left=' + leftPos +',scrollbars=yes,resizable=yes');
  newWindow.focus();
}

function onDownloadDone(s, bPreview)
{
  var place = document.getElementById("mainDiv");
  //alert(s);
  if ( (s.length &lt; 15) || (s.length != s.substr(0, 4)) || (s.substr(4, 11) != "EPGSchedule") )
  {
    alert("Error with DV Scheduler server connection");
    return;
  }
  
  var ss = s.split("|");
  
  if (ss[1] == 'ERROR:Already in list')
  {
    alert("Identical schedule already exists");
    return;
  }

  if ( ss[19] == '1' )
  {
    document.location.reload(true);
    return;
  }

  var fromTop = ss[9] * cellHeight / 60;
  var fromTop2 = (fromTop &lt; 0) ? 0 : fromTop;
  var height = ss[10] * cellHeight / 60;
  
  var html = "&lt;table class='epgScheduleProcess' cellpadding='0' cellspacing='0' type='ScheduleItem' " + 
	  "onMouseMove='highlightCell(this);showTip(event,this,balloonDelay);showResize(event,this);' " + 
	  "onMouseOut='lowlightCell();hideTip();hideMarker();' " +  
	  "onMouseDown='startResize(event,this);' " + 
	  "colNum='" + ss[8] + "' id='" + ss[7] + "' " + 
    "duration='" + ss[3] + "' stopHour='" + ss[17] + "' stopMinute='" + ss[18] + "' " + 
    "desc2='" + ss[1].substr(8,2) + ":" + ss[1].substr(10,2) + "-" + ss[2].substr(8,2) + ":" + ss[2].substr(10,2) + " (" + ss[3] + ") " + ss[6] + " (" + ss[4] + ")&lt;br&gt;" + ss[5] + "' " +
	  "onClick=\"toggleScheduleCell(this, '" + ss[7] + "');hideInput();\" " +
	  "onContextMenu=\"fnRightClick2(this, event); <xsl:if test="//@rightClick != 'No Action'">return false;</xsl:if>\" " +
	  "style='position:absolute;left:" + fromTop + ";width:" + height + ";' " + 
	  "&gt;&lt;tr&gt;&lt;td&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;" + 
	  "&lt;table cellpadding='0' cellspacing='0' class='scheduleItemActions' type='ScheduleItemActions' " +
	  "style='left:" + fromTop2 + ";' " + 
	  "colNum='" + ss[8] + "' id='" + ss[7] + "A' " + 
	  "&gt;&lt;tr&gt;" + 
	  "&lt;td style='text-align:center;width:30px;padding: 2px 2px 2px 2px;' " + 
	  "&gt;WA" + 
	  "&lt;a onClick='javascript:window.event.cancelBubble=true;' onMouseMove='savePosition(event);' href='/servlet/ScheduleDataRes?action=04&amp;id=" + ss[7] + "'&gt;&lt;img title='Delete' src='/images/delete.png' border='0' align='center' width='24' height='24'&gt;&lt;/a&gt;" + 
	  "&lt;a onClick='javascript:window.event.cancelBubble=true;' onMouseMove='savePosition(event);' href='/servlet/ScheduleDataRes?action=02&amp;id=" + ss[7] + "&amp;day=" + ss[11] + "&amp;month=" + ss[12] + "&amp;year=" + ss[13] + "'&gt;&lt;img title='Edit' src='/images/edit.png' border='0' align='center' width='24' height='24'&gt;&lt;/a&gt;" + 
	  "&lt;a onClick='javascript:window.event.cancelBubble=true;' onMouseMove='savePosition(event);' href=\"javascript:inputForm('" + ss[7] + "'," + ss[3] + "," + ss[17] + "," + ss[18] + ",-1)\"&gt;&lt;img title='Change Duration' src='/images/+52.png' border='0' align='center' width='24' height='24'&gt;&lt;/a&gt;" + 
	  "&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;";

  //alert(html);
  place.insertAdjacentHTML("beforeEnd", html);
  positionSchedules();
  
  var scheduledAmt = document.getElementById("scheduledAmt");
  totalSchMinute += parseInt(ss[3]);
  
  if (document.all)
    scheduledAmt.innerText = Math.floor(totalSchMinute / 60) + "h " + (totalSchMinute%60) + "m scheduled";
  else
    scheduledAmt.textContent = Math.floor(totalSchMinute / 60) + "h " + (totalSchMinute%60) + "m scheduled";
  
  if ( bPreview &amp;&amp; (ss[17].length > 0) )
    document.location.href = '/servlet/ScheduleDataRes?action=29&amp;scheduleId=' + ss[17];
}

var request = null;

function schedTitleCap(obj, captureType)
{
  var id = obj.getAttribute('id');
  var channel = obj.getAttribute('channel');

  request = new XMLHttpRequest(); //No conditionals necessary.
  request.open("POST", '/servlet/ScheduleDataRes?action=16&amp;id=' + id + '&amp;channel=' + encodeURIComponent(channel) + '&amp;captype=' + captureType + '&amp;page=<xsl:value-of select="//@page" />&amp;daysPerPage=<xsl:value-of select="//@daysPerPageActual" />&amp;channelsPerPage=<xsl:value-of select="//@channelsPerPageActual" />&amp;date=<xsl:value-of select="//@date" />&amp;month=<xsl:value-of select="//@monthn0" />&amp;year=<xsl:value-of select="//@year" />', true);

  request.onreadystatechange = function()
  {
    if (request.readyState == 4 &amp;&amp; request.status == 200)
    {
      if (request.responseText)
      {
        onDownloadDone(request.responseText, false);
      }
    }
    else if (request.readyState == 4)
    {
      alert("A network connection error occurred");
    }
  };
  request.send(null);
}

function schedTitle(obj)
{
  schedTitleCap(obj, "");
}

function newSchedule(obj)
{
  var id = obj.getAttribute('id');
  var channel = obj.getAttribute('channel');

  document.location.href = '/servlet/ScheduleDataRes?action=18&amp;id=' + id + '&amp;channel=' + encodeURIComponent(channel) + '&amp;dari=' + encodeURIComponent(document.location.href);
}

function autoAdd(obj)
{
  //if(confirm("Are you sure you want to add an Auto-Add item based on this show?"))
  {
    var id = obj.getAttribute('id');
    var channel = obj.getAttribute('channel');

    document.location.href = '/servlet/EpgAutoAddDataRes?action=14&amp;itemID=' + id + '&amp;chan=' + encodeURIComponent(channel) + '&amp;dari=' + encodeURIComponent(document.location.href);
  }
}

function onToggleExcludeDone(s)
{
  if ( (s.length &lt; 15) || (s.length != s.substr(0, 4)) || (s.substr(4, 11) != "EPGSchedule") )
  {
    alert("Error with DV Scheduler server connection");
    return;
  }
  var ss = s.split("|");
  var span = menuObj.getElementsByTagName('span')[0];
  
  if (ss[1] == '0')
  {
    span.className = span.className.replace(/programTitleExcluded/, "");
    span.className = span.className.replace(/programTitleMatched/, "");
  }
  else if (ss[1] == '1')
    span.className += " programTitleExcluded";
}
    
function toggleExcludeAutoAdd(obj)
{
  var id = obj.getAttribute('id');
  var channel = obj.getAttribute('channel');

  request = new XMLHttpRequest(); //No conditionals necessary.
  request.open("POST", '/servlet/EpgDataRes?action=28&amp;id=' + id + '&amp;channel=' + encodeURIComponent(channel), true);

  request.onreadystatechange = function()
  {
    if (request.readyState == 4 &amp;&amp; request.status == 200)
    {
      if (request.responseText)
      {
        onToggleExcludeDone(request.responseText);
      }
    }
    else if (request.readyState == 4)
    {
      alert("A network connection error occurred");
    }
  };
  request.send(null);
}

function fnLeftClick(obj, event)
{
  var id = obj.getAttribute('id');
  var channel = obj.getAttribute('channel');
  if ( (id == null) || (id.length == 0) || (channel == null) || (channel.length == 0) )
    return;

  <xsl:if test="//@leftClick = 'Add Schedule'">schedTitle(obj);</xsl:if>
  <xsl:if test="//@leftClick = 'New Schedule'">newSchedule(obj);</xsl:if>
  <xsl:if test="//@leftClick = 'Show Detail'">showTitle(obj);</xsl:if>
  <xsl:if test="//@leftClick = 'Show Menu'">showMenu(obj, event);</xsl:if>
}

function fnRightClick(obj, event)
{
  var id = obj.getAttribute('id');
  var channel = obj.getAttribute('channel');
  if ( (id == null) || (id.length == 0) || (channel == null) || (channel.length == 0) )
    return;

  <xsl:if test="//@rightClick = 'Add Schedule'">schedTitle(obj);</xsl:if>
  <xsl:if test="//@rightClick = 'New Schedule'">newSchedule(obj);</xsl:if>
  <xsl:if test="//@rightClick = 'Show Detail'">showTitle(obj);</xsl:if>
  <xsl:if test="//@rightClick = 'Show Menu'">showMenu(obj, event);</xsl:if>
  <xsl:if test="//@rightClick != 'No Action'">return false;</xsl:if>
}

function fnLeftClick2(obj, event)
{
  var id = obj.getAttribute('id');
  if ( (id == null) || (id.length == 0) )
    return;
}

function fnRightClick2(obj, event)
{
  var id = obj.getAttribute('id');
  if ( (id == null) || (id.length == 0) )
    return;

  showMenu2(obj, event);
}

function showPreview(obj)
{
  var channel = obj.getAttribute('channel');
  document.location.href = '/servlet/ScheduleDataRes?action=17&amp;channel=' + encodeURIComponent(channel);
  /*
  request = new XMLHttpRequest();
  request.open("POST", '/servlet/ScheduleDataRes?action=26&amp;channel=' + encodeURIComponent(channel), true);
  request.onreadystatechange = function()
  {
    if (request.readyState == 4 &amp;&amp; request.status == 200)
    {
      if (request.responseText)
      {
        onDownloadDone(request.responseText, true);
      }
    }
    else if (request.readyState == 4)
    {
      alert("A network connection error occurred");
    }
  };
  request.send(null);
  epgFocus();
  */
}

function positionSchedules()
{
  var scrollBar = 18;
     
  var totalColNum = <xsl:value-of select="count(//channel)" />;
  var minWidth = <xsl:value-of select="//@width" />;
  var mainTable = document.getElementById("mainTable");
  var width = (mainTable.clientHeight - 20 - scrollBar) / totalColNum
  
  if(width &lt; minWidth)
    width = minWidth;
               
  var mainDiv = document.getElementById("mainDiv");                                    
  var cell = document.getElementsByTagName("table");
  var x = 0;
  while(cell[x] != null)
  {
     if(cell[x].getAttribute("type") == "ScheduleItem")
     {
        var colNum = cell[x].getAttribute("colNum");
        var leftOffset = (width * colNum) - cell[x].clientHeight - 1;
        
        cell[x].style.top = leftOffset;
     }
     else if(cell[x].getAttribute("type") == "ScheduleItemActions")
     {
        var colNum = cell[x].getAttribute("colNum");
        var leftOffset = (width * colNum);
        
        cell[x].style.top = leftOffset + 5;                   
     }
     
     x++;
  }
  
  var mainDiv0 = document.getElementById("mainDiv0");
  mainDiv0.style.height = window.document.body.clientHeight - (mainTable.clientHeight + 2);
  mainDiv.style.height = mainDiv0.style.height;
  mainDiv.style.width = mainTable.clientWidth - 80;
}

function positionHeaders()
{
  var mainDiv = document.getElementById("mainDiv");
  var colHeader = document.getElementById("colHeader");
  var rowHeader = document.getElementById("rowHeader");
  
  colHeader.style.left = -mainDiv.scrollLeft;
  rowHeader.style.top = -mainDiv.scrollTop;
}

function saveScrollPosition()
{
  var item = document.getElementById("mainDiv");

  setCookie("EpgScrollTop", item.scrollTop, 32);
  setCookie("EpgScrollLeft", item.scrollLeft, 32);
}

function scrollTo(hour, offset, colNum)
{
  var width = <xsl:value-of select="//@height" />;
  var mainDiv = document.getElementById("mainDiv");
  var adj = hour - 6;
    if(adj &lt; 0)
  adj += 24;
  if (offset)
    mainDiv.scrollLeft = adj * width - mainDiv.clientWidth / 3;
  else
    mainDiv.scrollLeft = adj * width;
  if (colNum > 0)
  {
    var scrollBar = 18;
    var totalColNum = <xsl:value-of select="count(//channel)" />;
    var minWidth = <xsl:value-of select="//@width" />;
    var mainTable = document.getElementById("mainTable");
    var width = (mainTable.clientHeight - 20 - scrollBar) / totalColNum;
    
    if(width &lt; minWidth)
      width = minWidth;
    mainDiv.scrollTop = width * (colNum - 1);
  }
  epgFocus();
}

function scrollToNow()
{
  var now = new Date();
  var adj = now.getHours() + now.getMinutes()/60.0 - timeDifference;
  if(adj &lt; 0)
    adj += 24;
  else if (adj &gt;= 24)
    adj -= 24;
  scrollTo(adj, true, -1);
}

function loadScrollPosition()
{
  var scrollTo2 = <xsl:value-of select="//@scrollto2" />;
  var scrollChannel = <xsl:value-of select="//@scrolltoChannel" />;

  if(scrollTo2 == -2)
  {
    var item = document.getElementById("mainDiv");
    scrollTo2 = parseInt(readCookie("EpgScrollTop"));
    if (!isNaN(scrollTo2))
      item.scrollTop = scrollTo2;
    scrollTo2 = parseInt(readCookie("EpgScrollLeft"));
    if (!isNaN(scrollTo2))
      item.scrollLeft = scrollTo2;
  }
  else if (scrollTo2 == -1)
  {
    scrollToNow();
  }
  else
  {
    scrollTo(scrollTo2, false, scrollChannel);
  }

  //saveChannelsDaysPerPage();
}

function displayWarnings()
{
  <xsl:if test="//@warningDevice = '1'">//alert('Warning: No capture device selected');</xsl:if>
}

function saveChannelsDaysPerPage()
{
  var daysPerPage = document.getElementById("daysPerPage");
  setCookie("EpgDaysPerPage", daysPerPage.value, 32);
  var channelsPerPage = document.getElementById("channelsPerPage");
  setCookie("EpgChannelsPerPage", channelsPerPage.value, 32);
}

function inputChannelsDaysPerPage()
{
  //saveChannelsDaysPerPage();
  //document.location.reload(true);

  var daysPerPage = document.getElementById("daysPerPage");
  var channelsPerPage = document.getElementById("channelsPerPage");
  var channel = '<xsl:value-of select="//@startChannel" />';
  document.location.href = '/servlet/EpgDataRes?action=12&amp;year=<xsl:value-of select="//@year" />&amp;month=<xsl:value-of select="//@monthn1" />&amp;day=<xsl:value-of select="//@date" />&amp;channelsPerPage=' + channelsPerPage.value + '&amp;daysPerPage=' + daysPerPage.value + '&amp;channel=' + encodeURIComponent(channel);
}

function changePage(obj)
{
  document.location.href = obj.value;
}

function checkNumberInput(e, obj)
{
  var keyCode = window.event ? e.keyCode : e.which;
  if ( (keyCode == 13) &amp;&amp; !isNaN(obj.value) )
  {
    inputChannelsDaysPerPage();
    return true;
  }
  else if ( (((keyCode &gt;= 32) &amp;&amp; (keyCode &lt;= 47)) || ((keyCode &gt;= 58) &amp;&amp; (keyCode != 127) &amp;&amp; (keyCode &lt;= 255))) &amp;&amp; !e.ctrlKey &amp;&amp; !e.altKey )
    return false;
  
  return true;
}
</script>
</head>
	<body scroll="no"
		onResize="positionSchedules();hideAllTip();positionHeaders();timeline();"
		onLoad="displayWarnings();saveVars();positionSchedules();loadScrollPosition();timeline();epgFocus();"
		onUnload="saveScrollPosition();">

		<table id="mainTable" cellpadding="0" cellspacing="0"
			style="TABLE-LAYOUT: Fixed; Border:0px solid black; border-collapse:collapse;width:100%">
			<tr>
				<td align="center">

					<div align="left" style="position:absolute;">
						<font size="4">
							<a title="Home" target="_top" href="/"
								style="text-decoration: none; color: #FFFFFF;">
								<img id="home" src="/images/home.png" align="absmiddle"
									border="0" width="24" height="24" />
								<b></b>
							</a>
						</font>
        &nbsp;&nbsp;
						<font size="4">
							<a title="Schedules" target="_top" href="/servlet/ScheduleDataRes"
								style="text-decoration: none; color: #FFFFFF;">
								<img src="/images/schedule24.png" align="absmiddle" border="0"
									width="24" height="24" />
								<b></b>
							</a>
						</font>
        &nbsp;
						<font size="4">
							<a title="Search EPG" target="_top" href="/servlet/EpgDataRes?action=22"
								style="text-decoration: none; color: #FFFFFF;">
								<img src="/images/search24.png" align="absmiddle" border="0"
									width="24" height="24" />
								<b></b>
							</a>
						</font>
        &nbsp;
						<font size="4">
							<a title="Reload EPG Data" target="_top"
								href="/servlet/EpgDataRes?action=03" style="text-decoration: none; color: #FFFFFF;"
								onClick="return confirm('Are you sure?')">
								<img src="/images/reload.png" align="absmiddle" border="0"
									width="24" height="24" />
								<b></b>
							</a>
						</font>
<div>
<select name="channelsPerPage" id='channelsPerPage' title='Channels per page'>
<xsl:apply-templates select="//channelsPerPage" mode="list" />
</select>
<select name="daysPerPage" id='daysPerPage' title='Days per page'>
<xsl:apply-templates select="//daysPerPage" mode="list" />
</select>
<!--input name='channelsPerPage' id='channelsPerPage' title='Channels per page' type='text'	value="{//@channelsPerPage}" size="1" onkeypress="return checkNumberInput(event, this);" /> channel
<input name='daysPerPage' id='daysPerPage' title='Days per page' type='text' value="{//@daysPerPage}" size="1" onkeypress="return checkNumberInput(event, this);" /> day-->
<button onclick="inputChannelsDaysPerPage();" type="button">Go</button></div>
					</div>

					<table class="epgTable" cellspacing='0' cellpadding='0'>
						<th width="140" align="left"></th>
						<th style="font-size:140%">
							<a class="under" href="/servlet/EpgDataRes?action=02#epgAge"><img src="/images/help2_24.png" border="0" align="top" width="24"
								height="24" onMouseOut="hideTip();" desc2="what">
								<xsl:attribute name="onMouseMove">showTip(event,this,<xsl:value-of
									select="//@balloonDelay" />);</xsl:attribute>
								<xsl:attribute name="desc2"><xsl:value-of
									select="//@epgLoadDesc" /></xsl:attribute>
							</img></a>
							<xsl:value-of select="//@day" />
							(<xsl:value-of select="//@date" />&#160;<xsl:value-of select="//@month" />)
<xsl:if test="//@pageCount > 1">
<xsl:choose>
  <xsl:when test="//@channelsPerPageActual > 1">
		<!--xsl:apply-templates select="//page" mode="number" /-->
    <select name="showChannel" onChange='changePage(this)'>
    <xsl:apply-templates select="//page" mode="list" />
    </select>
  </xsl:when>
  <xsl:otherwise>
    <select name="showChannel" onChange='changePage(this)'>
    <xsl:apply-templates select="//page" mode="list" />
    </select>
  </xsl:otherwise>
</xsl:choose>
</xsl:if>
						</th>
						<th id="scheduledAmt" width="140" align="right" style="font-weight: normal;">
							<xsl:value-of select="//@scheduledhour" />
							h
							<xsl:value-of select="//@scheduledminute" />
							m scheduled
						</th>
					</table>
					<table class="epgTable">
            <th width="200" align="left" />
						<th style="font-weight: normal; font-size: 95%;">
							<xsl:apply-templates select="//days" mode="title" />
						</th>
						<th width="200" align="right" style="font-weight: normal">
						  Jump: <a class="dayList" href="javascript:scrollToNow();">Now</a>
							<xsl:apply-templates select="//timeLabel" mode="jumper" />
						</th>
					</table>
					<div id="colHeaderDiv" style="overflow:hidden;">
						<table id="colHeader" class="epgTable"
							style="font-size:75%;position:relative;" cellspacing='0'
							cellpadding='0'>
							<tr>
								<th width="81"></th>
								<xsl:apply-templates select="//timeLabel"
									mode="header" />
								<th width="18"></th>
							</tr>
						</table>
					</div>
				</td>
			</tr>
		</table>

		<div id="mainDiv0" style="height:10px;overflow:hidden;">
			<table border='0' cellspacing='0' cellpadding='0'>
				<tr valign="top">
					<td valign="top" width="80">
						<table id="rowHeader" class='epgTable'
							style="position:relative; left:0px; top:0px;" border='0'
							cellspacing='0' cellpadding='0' name='epgtable'>
							<xsl:apply-templates select="//channel" mode="header" />
						</table>
					</td>
					<td>
						<div id="mainDiv"
							onScroll="lowlightCell();hideAllTip();positionHeaders();endResize(event);"
							style="height:10px;overflow:auto;position:relative;">
							<div id="timeline"
								style="border-left:4px solid #77FF77; filter:alpha(opacity=55);KHTMLOpacity:0.55;MozOpacity:0.55;opacity:0.55; position:absolute; overflow:visible;" />
							<xsl:apply-templates select="//channel" mode="body" />
						</div>
					</td>
				</tr>
			</table>
		</div>
		<script language="JavaScript">
			new menu (menuHierarchy, menuConfig);
		</script>
		<div id="balloon_tooltip" align="left"
			style="font-family: Tahoma, Verdana, Arial, Helvetica; font-size: 90%; font-weight:normal; filter:alpha(opacity=95);KHTMLOpacity:0.95;MozOpacity:0.95;opacity:0.95; position:absolute; overflow:visible; BACKGROUND-COLOR: #306800; padding:5px; display:none; top:1px; left:1px;" />
		<div id="balloon_tooltip2" align="left"
			style="font-family: Tahoma, Verdana, Arial, Helvetica; font-size: 90%; font-weight:normal; filter:alpha(opacity=95);KHTMLOpacity:0.95;MozOpacity:0.95;opacity:0.95; position:absolute; overflow:visible; BACKGROUND-COLOR: #306800; padding:5px; visibility:hidden; top:1px; left:1px;" />
		<div id="balloon_lineTop"
			style="border-left:1px solid #FFFFFF; filter:alpha(opacity=55);KHTMLOpacity:0.55;MozOpacity:0.55;opacity:0.55; position:absolute; overflow:visible; display:none; top:56" />
		<div id="balloon_lineBottom"
			style="border-right:1px solid #FFFFFF; filter:alpha(opacity=55);KHTMLOpacity:0.55;MozOpacity:0.55;opacity:0.55; position:absolute; overflow:visible; display:none; top:56" />
		<div id="balloon_input" style="position:absolute; display:none">
			<input name="duration" title="Duration in minutes" type="text"
				id="duration" size="1" maxlength="4" />
			<button onclick="inputOk();" type="button">Ok</button>
			<br />
			<input name="stopHour" title="Stop hour" type="text" id="stopHour"
				size="1" maxlength="2" />
			:
			<input name="stopMinute" title="Stop minute" type="text" id="stopMinute"
				size="1" maxlength="2" />
			<button onclick="inputOkStopTime();" type="button">Ok</button>
		</div>
		<div id="menu" style="position:absolute; visibility:hidden; top:1px; left:1px;"
			onMouseOver="cancelHideMenu()" onMouseOut="hideMenuDelay()">
			<table cellpadding="0" cellspacing="0">
				<tr>
					<td class="menunormal" nowrap="1"
						onClick="hideMenu(); showTitle(menuObj); className='menunormal'; "
						onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
						<img src="/images/blank.gif" border="0" align="absmiddle"
							width="16" height="16" />
						Show Detail
					</td>
				</tr>
				<tr>
					<td class="menunormal" nowrap="1"
						onClick="hideMenu(); newSchedule(menuObj); className='menunormal';"
						onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
						<img src="/images/addsch16.png" border="0" align="absmiddle"
							width="16" height="16" />
						New Schedule
					</td>
				</tr>
				<tr>
					<td class="menunormal" nowrap="1"
						onClick="hideMenu(); schedTitle(menuObj); className='menunormal';"
						onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
						<img src="/images/add16.png" border="0" align="absmiddle"
							width="16" height="16" />
						Add Schedule
					</td>
				</tr>
				<tr>
					<td class="menunormal" nowrap="1"
						onClick="hideMenu(); autoAdd(menuObj); className='menunormal';"
						onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
						<img src="/images/reload16.png" border="0" align="absmiddle"
							width="16" height="16" />
						Create Auto-Add Item
					</td>
				</tr>
				<tr>
					<td class="menunormal" nowrap="1"
						onClick="hideMenu(); toggleExcludeAutoAdd(menuObj); className='menunormal';"
						onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
						<img src="/images/toggleExclusion16.png" border="0" align="absmiddle"
							width="16" height="16" />
						Toggle Auto-Add Exclusion
					</td>
				</tr>
				<tr>
					<td height="5px">
					</td>
				</tr>
				<xsl:apply-templates select="//captureType" />
			</table>
		</div>
		<div id="menu2" style="position:absolute; visibility:hidden; top:1px; left:1px;"
			onMouseOver="cancelHideMenu2()" onMouseOut="hideMenuDelay2()">
			<table cellpadding="0" cellspacing="0">
				<tr>
					<td id="menu2ShowLogSchedule" class="menunormal" nowrap="1"
						onClick="hideMenu2(); showLogSchedule(); className='menunormal'; "
						onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
						<img src="/images/log.png" border="0" align="absmiddle" width="16"
							height="16" />
						Show Log
					</td>
				</tr>
				<tr>
					<td id="menu2DelSchedule" class="menunormal" nowrap="1"
						onClick="hideMenu2(); delSchedule(); className='menunormal'; "
						onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
						<img src="/images/delete.png" border="0" align="absmiddle"
							width="16" height="16" />
						Delete
					</td>
				</tr>
				<tr>
					<td id="menu2ChangeDateSchedule" class="menunormal" nowrap="1"
						onClick="hideMenu2(); changeDateSchedule(); className='menunormal'; "
						onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
						<img src="/images/editdate.png" border="0" align="absmiddle"
							width="16" height="16" />
						Change Date
					</td>
				</tr>
				<tr>
					<td id="menu2EditSchedule" class="menunormal" nowrap="1"
						onClick="hideMenu2(); editSchedule(menuObj2); className='menunormal'; "
						onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
						<img src="/images/edit.png" border="0" align="absmiddle"
							width="16" height="16" />
						Edit
					</td>
				</tr>
				<tr>
					<td id="menu2ChangeDurationSchedule" class="menunormal" nowrap="1"
						onClick="hideMenu2(); changeDurationSchedule(menuObj2); className='menunormal'; "
						onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
						<img src="/images/+52.png" border="0" align="absmiddle" width="16"
							height="16" />
						Change Duration
					</td>
				</tr>
				<tr>
					<td id="menu2AddTimeSchedule" class="menunormal" nowrap="1"
						onClick="hideMenu2(); addTimeSchedule(menuObj2); className='menunormal'; "
						onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
						<img src="/images/+5.png" border="0" align="absmiddle" width="16"
							height="16" />
						Add Time
					</td>
				</tr>
			</table>
		</div>
		<div id="menu2b" style="position:absolute; visibility:hidden; top:1px; left:1px;"
			onMouseOver="cancelHideMenu2()" onMouseOut="hideMenuDelay2()">
			<table cellpadding="0" cellspacing="0">
				<tr>
					<td id="menu2ShowLogSchedule" class="menunormal" nowrap="1"
						onClick="hideMenu2(); showLogSchedule(); className='menunormal'; "
						onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
						<img src="/images/log.png" border="0" align="absmiddle" width="16"
							height="16" />
						Show Log
					</td>
				</tr>
				<tr>
					<td id="menu2DelSchedule" class="menunormal" nowrap="1"
						onClick="hideMenu2(); delSchedule(); className='menunormal'; "
						onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
						<img src="/images/delete.png" border="0" align="absmiddle"
							width="16" height="16" />
						Delete
					</td>
				</tr>
				<tr>
					<td id="menu2ChangeDateSchedule" class="menunormal" nowrap="1"
						onClick="hideMenu2(); changeDateSchedule(); className='menunormal'; "
						onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
						<img src="/images/editdate.png" border="0" align="absmiddle"
							width="16" height="16" />
						Change Date
					</td>
				</tr>
				<tr>
					<td id="menu2EditSchedule" class="menunormal" nowrap="1"
						onClick="hideMenu2(); editSchedule(menuObj2); className='menunormal'; "
						onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
						<img src="/images/edit.png" border="0" align="absmiddle"
							width="16" height="16" />
						Edit
					</td>
				</tr>
				<tr>
					<td id="menu2ChangeDurationSchedule" class="menunormal" nowrap="1"
						onClick="hideMenu2(); changeDurationSchedule(menuObj2); className='menunormal'; "
						onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
						<img src="/images/+52.png" border="0" align="absmiddle" width="16"
							height="16" />
						Change Duration
					</td>
				</tr>
				<tr>
					<td id="menu2AddTimeSchedule" class="menunormal" nowrap="1"
						onClick="hideMenu2(); addTimeSchedule(menuObj2); className='menunormal'; "
						onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
						<img src="/images/+5.png" border="0" align="absmiddle" width="16"
							height="16" />
						Add Time
					</td>
				</tr>
				<tr>
					<td id="menu2SkipToNextSchedule" class="menunormal" nowrap="1"
						onClick="hideMenu2(); skipToNextSchedule(menuObj2); className='menunormal'; "
						onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
						<img src="/images/skip.png" border="0" align="absmiddle"
							width="16" height="16" />
						Skip To Next
					</td>
				</tr>
			</table>
		</div>
		<div id="menu3" style="position:absolute; visibility:hidden; top:1px; left:1px;"
			onMouseOver="cancelHideMenu2()" onMouseOut="hideMenuDelay2()">
			<table cellpadding="0" cellspacing="0">
				<tr>
					<td id="menu2ShowLogSchedule" class="menunormal" nowrap="1"
						onClick="hideMenu2(); showLogSchedule(); className='menunormal'; "
						onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
						<img src="/images/log.png" border="0" align="absmiddle" width="16"
							height="16" />
						Show Log
					</td>
				</tr>
				<tr>
					<td id="menu2StopSchedule" class="menunormal" nowrap="1"
						onClick="hideMenu2(); stopSchedule(); className='menunormal'; "
						onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
						<img src="/images/stop.png" border="0" align="absmiddle"
							width="16" height="16" />
						Stop
					</td>
				</tr>
				<tr>
					<td id="menu2StopScheduleDelFile" class="menunormal" nowrap="1"
						onClick="hideMenu2(); stopScheduleDelFile(); className='menunormal'; "
						onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
						<img src="/images/stopDelete.png" border="0" align="absmiddle"
							width="16" height="16" />
						Stop and Delete File
					</td>
				</tr>
				<tr>
					<td id="menu2EditSchedule" class="menunormal" nowrap="1"
						onClick="hideMenu2(); editSchedule(menuObj2); className='menunormal'; "
						onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
						<img src="/images/edit.png" border="0" align="absmiddle"
							width="16" height="16" />
						Edit
					</td>
				</tr>
				<tr>
					<td id="menu2ChangeDurationSchedule" class="menunormal" nowrap="1"
						onClick="hideMenu2(); changeDurationSchedule(menuObj2); className='menunormal'; "
						onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
						<img src="/images/+52.png" border="0" align="absmiddle" width="16"
							height="16" />
						Change Duration
					</td>
				</tr>
				<tr>
					<td id="menu2AddTimeSchedule" class="menunormal" nowrap="1"
						onClick="hideMenu2(); addTimeSchedule(menuObj2); className='menunormal'; "
						onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
						<img src="/images/+5.png" border="0" align="absmiddle" width="16"
							height="16" />
						Add Time
					</td>
				</tr>
			</table>
		</div>
	</body>	
		</html>
	</xsl:template>	

    <xsl:template match="page" mode="number">
      <a class="dayList">
      <xsl:attribute name="href">
         <xsl:value-of select="url" />
      </xsl:attribute>
      <xsl:attribute name="title">
         <xsl:value-of select="@title" />
      </xsl:attribute>
        <xsl:value-of select="@name" /></a>
      <xsl:if test="position() != count(../page)">&nbsp;&nbsp;</xsl:if>
    </xsl:template>

    <xsl:template match="page" mode="list">
      <option value="{url}"><xsl:if test="@selected = 1"><xsl:attribute name="selected" /></xsl:if><xsl:value-of select="@title" /></option>
    </xsl:template>

    <xsl:template match="channelsPerPage" mode="list">
      <option value="{@value}"><xsl:if test="@selected = '1'"><xsl:attribute name="selected" /></xsl:if><xsl:value-of select="@name" /></option>
    </xsl:template>

    <xsl:template match="daysPerPage" mode="list">
      <option value="{@value}"><xsl:if test="@selected = '1'"><xsl:attribute name="selected" /></xsl:if><xsl:value-of select="@name" /></option>
    </xsl:template>

	<xsl:template match="days" mode="title">
    <a class="dayList" href="{url}" title="{@title}">
		<xsl:value-of select="@name" /></a> &nbsp;
	</xsl:template>
   
	<xsl:template match="channel" mode="header">
		<tr><xsl:attribute name="height"><xsl:value-of select="../@width" /></xsl:attribute>
			<th class='epgChannel'>
      <xsl:if test="(//@channelsPerPageActual > 1)">
      <xsl:choose>
        <xsl:when test="../@preview = '0'">
<xsl:if test="(@show = 1) or (@show = 2)">
          <img style="border:0px"><xsl:attribute name="title"><xsl:value-of select="display-name" /></xsl:attribute><xsl:attribute name="src"><xsl:value-of select="@image-file" /></xsl:attribute><xsl:attribute name="width"><xsl:value-of select="@image-width" /></xsl:attribute></img>
</xsl:if>
<xsl:if test="(@show = 2)"><br/></xsl:if>
<xsl:if test="(@show = 0) or (@show = 2)">
          <xsl:value-of select="display-name" />
</xsl:if>
        </xsl:when>
        <xsl:otherwise>
<xsl:if test="(@show = 1) or (@show = 2)">
          <img style="border:0px;cursor:hand;cursor:pointer;" channel="{display-name}" onClick="showPreview(this)"><xsl:attribute name="title">Live Preview - <xsl:value-of select="display-name" /></xsl:attribute><xsl:attribute name="src"><xsl:value-of select="@image-file" /></xsl:attribute><xsl:attribute name="width"><xsl:value-of select="@image-width" /></xsl:attribute></img>
</xsl:if>
<xsl:if test="(@show = 2)"><br/></xsl:if>
<xsl:if test="(@show = 0) or (@show = 2)">
          <span title="Live Preview" style="border:0px;cursor:hand;cursor:pointer;" channel="{display-name}" onClick="showPreview(this)"><xsl:value-of select="display-name" /></span>
</xsl:if>
        </xsl:otherwise>
      </xsl:choose>
      <xsl:if test="(//@daysPerPageActual > 1)"><br/></xsl:if>
      </xsl:if>
      <xsl:if test="(//@daysPerPageActual > 1)"><span title="Live Preview - {display-name}" style="border:0px;cursor:hand;cursor:pointer;" channel="{display-name}" onClick="showPreview(this)"><xsl:value-of select="@day-week" />&nbsp;<xsl:value-of select="@date" /></span></xsl:if>      </th>
		</tr>
	</xsl:template>
   
	<xsl:template match="channel" mode="body">
      <xsl:variable name="filter" select="@channel-day"/>
      <xsl:variable name="colNum" select="position()"/>
			<table class='epgTable2' border='0' cellspacing='0' cellpadding='0'>
			  <tr><xsl:attribute name="height"><xsl:value-of select="../@width" /></xsl:attribute>
			  <td style="width:0px"></td>
				<xsl:apply-templates select="//programme[@channel-day=$filter]" />
			<td></td>
        </tr>
			</table>
			<xsl:apply-templates select="//schedule[@channel-day=$filter]">
				<xsl:with-param name="position" select="$colNum" />
			</xsl:apply-templates>
	</xsl:template>
   
<xsl:template match="programme">
<td valign="Top" onMouseMove="highlightCell(this);" onMouseOut="lowlightCell();" onContextMenu="return fnRightClick(this, event);" onClick="fnLeftClick(this, event)">
<xsl:attribute name="class">epgProgram <xsl:value-of select="category2" /></xsl:attribute>
<xsl:attribute name="width"><xsl:value-of select="length * ../@height div 60" /></xsl:attribute>
<xsl:attribute name="id"><xsl:value-of select="@id" /></xsl:attribute>
<xsl:attribute name="channel"><xsl:value-of select="@channel" /></xsl:attribute>
<!--xsl:attribute name="title"><xsl:value-of select="desc" /></xsl:attribute-->
<div class="epgProgram" onMouseMove="showTip(event,this,balloonDelay);" onMouseOut="hideTip();">
<xsl:attribute name="style">OVERFLOW: hidden; height:<xsl:value-of select="../@width - 2" />px</xsl:attribute>
<span>
<xsl:attribute name="class">programTitle 
<xsl:if test="@matchedAA = '1'">programTitleMatched </xsl:if>
<xsl:if test="@excludedAA = '1'">programTitleExcluded </xsl:if>
<xsl:if test="contains(desc, '~Err~ ')">programTitleError </xsl:if>
</xsl:attribute>
<xsl:value-of select="title" /></span><br/>
<span class="programTime">
<xsl:value-of select="@start3" />-<xsl:value-of select="@stop2" /> (<xsl:value-of select="length/@real" />)<br/><xsl:if test="sub-title"><xsl:value-of select="sub-title" /><br/></xsl:if></span>
<span class="programDesc">
<xsl:if test="../@displayDescription != 'All'"><xsl:attribute name="style">display:none</xsl:attribute></xsl:if>
<xsl:value-of select="desc" /></span></div>
</td>
</xsl:template>

    <xsl:template match="schedule">
        <xsl:param name="position"/>
        <xsl:variable name="filter" select="id"/>
        <table cellpadding="0" cellspacing="0" type="ScheduleItem" class="epgSchedule" onMouseMove="highlightCell(this);showTip(event,this,balloonDelay);showResize(event,this);" onMouseOut="lowlightCell();hideTip();hideMarker();" onMouseDown="startResize(event,this);">
            <xsl:attribute name="style">position:absolute;left:<xsl:value-of select="from_top * ../@height div 60" />;width:<xsl:value-of select="@duration * ../@height div 60" />;</xsl:attribute>
				   <xsl:attribute name="onClick">fnLeftClick2(this, event);toggleScheduleCell(this, '<xsl:value-of select="id" />');hideInput();</xsl:attribute>	
<xsl:attribute name="onContextMenu">fnRightClick2(this, event); <xsl:if test="../@rightClick != 'No Action'">return false;</xsl:if></xsl:attribute>
                 <xsl:attribute name="desc2"><xsl:value-of select="@start2" />-<xsl:value-of select="@stop2" /> (<xsl:value-of select="@duration" />) <xsl:value-of select="@channel" /> (<xsl:value-of select="@type" />)&lt;br&gt;<xsl:value-of select="@name" /></xsl:attribute>
                 <xsl:if test="@desc"><xsl:attribute name="desc3"><xsl:value-of select="@desc" /></xsl:attribute></xsl:if>			
            <xsl:if test="itemState = 2">
                  <xsl:attribute name="class">epgScheduleRunning</xsl:attribute>
            </xsl:if> 
            <xsl:if test="itemState = 1 or itemState = 3">
               <xsl:attribute name="class">epgScheduleFinished</xsl:attribute>
            </xsl:if>                
            <xsl:attribute name="colNum">
                <xsl:value-of select="$position"/>
            </xsl:attribute>		
            <xsl:attribute name="id">
                <xsl:value-of select="id" />
            </xsl:attribute>
            <xsl:attribute name="duration">
                <xsl:value-of select="@duration" />
            </xsl:attribute>
            <xsl:attribute name="state">
                <xsl:value-of select="itemState" />
            </xsl:attribute>
            <xsl:attribute name="skip">
                <xsl:value-of select="@skip" />
            </xsl:attribute>
            <tr><td></td></tr>
		</table>
		
		<table cellpadding="0" cellspacing="0" class="scheduleItemActions" type="ScheduleItemActions">
<xsl:choose>
  <xsl:when test="from_top &lt; 0">
			<xsl:attribute name="style">
				left:0;
			</xsl:attribute>	
  </xsl:when>
  <xsl:otherwise>
			<xsl:attribute name="style">
				left:<xsl:value-of select="from_top * ../@height div 60" />;
			</xsl:attribute>	
  </xsl:otherwise>
</xsl:choose>
			
			<xsl:attribute name="colNum">
				<xsl:value-of select="$position"/>
			</xsl:attribute>				
			
         <xsl:attribute name="id"><xsl:value-of select="id" />A</xsl:attribute>

			<tr>	
			   <td style="text-align:center;width:30px;padding: 2px 2px 2px 2px;">					
               
               <xsl:if test="itemState = 0">WA</xsl:if>

               <xsl:if test="itemState = 1">SK</xsl:if>

               <xsl:if test="itemState = 2">RN</xsl:if>

               <xsl:if test="itemState = 3">FN</xsl:if>

               <xsl:if test="itemState = 4">AB</xsl:if>

               <xsl:if test="itemState = 5">ER</xsl:if>

               <xsl:apply-templates select="//actionUrl[@item_id=$filter]" />
               
			   </td>
			</tr>
		</table>
		
	</xsl:template>
   
   <xsl:template match="actionUrl">
      <a onClick="javascript:window.event.cancelBubble=true;" onMouseMove="savePosition(event);">
      <xsl:attribute name="href">
         <xsl:value-of select="url" />
      </xsl:attribute>
      <xsl:if test="@name = 'D'"><img title="Delete" src="/images/delete.png" border="0" align="center" width="24" height="24" /></xsl:if>
      <xsl:if test="@name = 'E2'"><img title="Edit" src="/images/edit.png" border="0" align="center" width="24" height="24" /></xsl:if>
      <xsl:if test="@name = '+2'"><img title="Change Duration" src="/images/+52.png" border="0" align="center" width="24" height="24" /></xsl:if>
      <xsl:if test="@name = 'S'"><img title="Stop" src="/images/stop.png" border="0" align="center" width="24" height="24" /></xsl:if>
      </a>
   </xsl:template>

	<xsl:template match="captureType">
	  <tr><td class="menunormal" nowrap="1" onMouseOver="className='menuover'" onMouseOut="className='menunormal'">
     <xsl:attribute name="onClick">hideMenu(); className='menunormal'; schedTitleCap(menuObj, '<xsl:value-of select="@name" />')</xsl:attribute>
     <img src="/images/blank.gif" border="0" align="absmiddle" width="16" height="16" /> <xsl:value-of select="@name" />
		</td></tr>
	</xsl:template>

	<xsl:template match="timeLabel" mode="header">
	  <th class='epgTimes'><xsl:attribute name="width"><xsl:value-of select="../@height" /></xsl:attribute><div class='epgTimes'><xsl:value-of select="@hour2" /></div></th>
	</xsl:template>

	<xsl:template match="timeLabel" mode="jumper">
    <xsl:if test="(position() mod 12 = 1)"> &nbsp;<a class="dayList"><xsl:attribute name="href">javascript:scrollTo(<xsl:value-of select="@hour" />, false, -1)</xsl:attribute><xsl:value-of select="@hour2" /></a></xsl:if>
	</xsl:template>	
</xsl:stylesheet>
