<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

  <xsl:template match="/">
   
   <html>
   <head>
   <title>Timer Control</title>
   
   <script src="/javascript/jumpBack.js"></script>
         
   <style type="text/css">
   
   body
   {
      font-family: Arial, Helvetica, sans-serif;
      background-color: #386EB8;
      color: #DDDDFF;
      margin: 0; 
      text-decoration: none;  
   }
   
   a.ButtonText
   {
      font-size: 16px;
   	color: #DDDDFF;
   	text-decoration: none;
   }
   
   td.week
   {
      padding: 1px;
   }
   
   td.day
   {
      background-color: #0E3AB8;
      
      font-weight: bold;
      padding: 2px;
      
      border: 1px solid #8E8EE8;
   	
      vertical-align: top;
   }
   
   td.daySelect
   {
      background-color: #3E88f8;
      
      font-weight: bold;
      padding: 2px;
      
      border: 1px solid #8E8EE8;
   	
      vertical-align: top;
   }
   
   td.title
   {
      font-weight: bold;
      text-align: center;
      padding: 2px;
   }
   
   </style>    

   </head>
   <body>

   
   <table>
   <tr><td>
   
   <table class='calendartable' border='0' cellspacing='5' cellpadding='0' >

   <tr>
   <td class='title' colspan='7'>
   <table border='0' width="100%"> 
   <tr>
   <td><a class="ButtonText" href="javascript:jumpBack();">BACK</a></td>
   <td><div align="right"><b><xsl:value-of select="//@description" /></b></div></td>
   </tr>
   </table>
   
   </td>
   </tr>

   <tr>
   <td class='week'>SUN</td>
   <td class='week'>MON</td>
   <td class='week'>TUE</td>
   <td class='week'>WED</td>
   <td class='week'>THU</td>
   <td class='week'>FRI</td>
   <td class='week'>SAT</td>
   </tr>
   
   <tr>
   <xsl:apply-templates select="//day[@week=1]" mode="cells" />
   </tr>
   <tr>
   <xsl:apply-templates select="//day[@week=2]" mode="cells" />
   </tr>
   <tr>
   <xsl:apply-templates select="//day[@week=3]" mode="cells" />
   </tr>
   <tr>
   <xsl:apply-templates select="//day[@week=4]" mode="cells" />
   </tr>
   <tr>
   <xsl:apply-templates select="//day[@week=5]" mode="cells" />
   </tr>   
   <tr>
   <xsl:apply-templates select="//day[@week=6]" mode="cells" />
   </tr>    
   
   
   <tr><td colspan="7">
   
   <table border="0" width="100%">
   <tr>
   <td align="left">
   <a class="ButtonText">
   <xsl:attribute name="href">/servlet/KBScheduleDataRes?action=01&amp;day=<xsl:value-of select="//@selectedDay" />&amp;month=<xsl:value-of select="//@prevMonth" />&amp;year=<xsl:value-of select="//@prevYear" />&amp;id=<xsl:value-of select="//@itemID" />&amp;url=<xsl:value-of select="//backURL" />
   </xsl:attribute>
   Prev</a>   
   </td> 
   <td>
   <div align="right">
   <a class="ButtonText">
   <xsl:attribute name="href">/servlet/KBScheduleDataRes?action=01&amp;day=<xsl:value-of select="//@selectedDay" />&amp;month=<xsl:value-of select="//@nextMonth" />&amp;year=<xsl:value-of select="//@nextYear" />&amp;id=<xsl:value-of select="//@itemID" />&amp;url=<xsl:value-of select="//backURL" />
   </xsl:attribute>
   Next</a></div>
   </td>
   </tr>
   </table>
   
   </td></tr>
   </table>
      
      
   </td></tr></table>
   
   </body>
   </html>   
   
	</xsl:template>

   
   
	<xsl:template match="day" mode="cells">

   <td class="day">
      <xsl:if test="@date != 0">
      <xsl:attribute name="id">date_<xsl:value-of select="@date" /></xsl:attribute>
      <xsl:attribute name="value"><xsl:value-of select="url" /></xsl:attribute>
      
      <xsl:if test="@date = //@selectedDay">
         <xsl:attribute name="class">daySelect</xsl:attribute>
      </xsl:if>
      
      </xsl:if>

      <a class="ButtonText">
      <xsl:attribute name="href"><xsl:value-of select="url" /></xsl:attribute>

         <xsl:if test="@date != 0">
         <xsl:value-of select="@date" />
         </xsl:if>
         
         <xsl:if test="@date = 0">
         &#160;
         </xsl:if>
         
     </a>

   </td>
   
	</xsl:template>
   
</xsl:stylesheet>

