<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

<xsl:variable name="imageHeight">20</xsl:variable>

	<xsl:template match="/">
   
   <html>
   <head>
   <title>Timer Control</title>
   
<style type="text/css">

body
{
   font-family: Arial, Helvetica, sans-serif;
   background-color: #386EB8;
   color: #DDDDFF;
   text-decoration: none;
   margin:0px;
}

</style>   
   
   </head>
   <body>
   
   <table cellpadding="0" cellspacing="0">   
   <tr>
   <xsl:apply-templates select="//navigation" />
   </tr>
   </table>


   <table cellpadding="0" cellspacing="0">
   <tr><td><img src="/servlet/ImageDataRes?action=01&amp;width=60&amp;height={$imageHeight}&amp;bg=3698360&amp;bb=932536&amp;text=blank" width="60" height="{$imageHeight}" alt="" border="0"/><xsl:apply-templates select="//time" mode="cols" /></td></tr>   
   </table>
   
   <table cellpadding="0" cellspacing="0">
      
   <xsl:apply-templates select="//channel" mode="rows" />
      
   </table>
   
   </body>
   </html>
   
	</xsl:template>

	<xsl:template match="time" mode="cols">
   
      <img src="" width="90" height="{$imageHeight}" border="0">
         <xsl:attribute name="src">/servlet/ImageDataRes?action=01&amp;width=90&amp;height=<xsl:value-of select="$imageHeight"/>&amp;bg=3698360&amp;bb=932536&amp;bo=6597375&amp;bt=16777215&amp;ft=1&amp;text=<xsl:value-of select="." /></xsl:attribute>
         <xsl:attribute name="alt"><xsl:value-of select="." /></xsl:attribute>
      </img>
      
	</xsl:template>


   <xsl:template match="channel" mode="rows">
      <xsl:variable name="filter" select="display-name"/>
      
      <tr>
      <td>
      <img src="" width="60" height="{$imageHeight}" border="0">
      <xsl:attribute name="src">/servlet/ImageDataRes?action=01&amp;width=60&amp;height=<xsl:value-of select="$imageHeight"/>&amp;bg=3698360&amp;bb=932536&amp;bo=6597375&amp;bt=16777215&amp;ft=1&amp;text=<xsl:value-of select="display-name" /></xsl:attribute>
      <xsl:attribute name="alt"><xsl:value-of select="substring(display-name, 0, 7)" /></xsl:attribute>
      </img>

      <xsl:apply-templates select="//programme[@channel=$filter]" />
      
	  </td>
      </tr>		
		
      		
	  <xsl:if test="count(//schedule[@channel=$filter and @overlapCount=0]) > 0">
   	     <tr>
   	     <td>
   	        <img src="/servlet/ImageDataRes?action=01&amp;width=60&amp;height={$imageHeight}&amp;bg=3698360&amp;text=blank" width="60" height="{$imageHeight}" alt="" border="0"/>
   	        <xsl:apply-templates select="//schedule[@channel=$filter and @overlapCount=0]" />
         </td>
         </tr>
      </xsl:if>  
      
	  <xsl:if test="count(//schedule[@channel=$filter and @overlapCount=1]) > 0">
   	     <tr>
   	     <td>
   	        <img src="/servlet/ImageDataRes?action=01&amp;width=60&amp;height={$imageHeight}&amp;bg=3698360&amp;text=blank" width="60" height="{$imageHeight}" alt="" border="0"/>
   	        <xsl:apply-templates select="//schedule[@channel=$filter and @overlapCount=1]" />
         </td>
         </tr>
      </xsl:if>       
      
	  <xsl:if test="count(//schedule[@channel=$filter and @overlapCount=2]) > 0">
   	     <tr>
   	     <td>
   	        <img src="/servlet/ImageDataRes?action=01&amp;width=60&amp;height={$imageHeight}&amp;bg=3698360&amp;text=blank" width="60" height="{$imageHeight}" alt="" border="0"/>
   	        <xsl:apply-templates select="//schedule[@channel=$filter and @overlapCount=2]" />
         </td>
         </tr>
      </xsl:if>         
      
	  <xsl:if test="count(//schedule[@channel=$filter and @overlapCount=3]) > 0">
   	     <tr>
   	     <td>
   	        <img src="/servlet/ImageDataRes?action=01&amp;width=60&amp;height={$imageHeight}&amp;bg=3698360&amp;text=blank" width="60" height="{$imageHeight}" alt="" border="0"/>
   	        <xsl:apply-templates select="//schedule[@channel=$filter and @overlapCount=3]" />
         </td>
         </tr>
      </xsl:if>         
      
	</xsl:template>
	
	
	
   <xsl:template match="programme">
      
      <a border="0">
      <xsl:attribute name="href"><xsl:value-of select="showDetails" /></xsl:attribute>   
   
      <img src="" height="{$imageHeight}" border="0">
      <xsl:attribute name="src">/servlet/ImageDataRes?action=01&amp;width=<xsl:value-of select="length * 3" />&amp;height=<xsl:value-of select="$imageHeight"/>&amp;fits=<xsl:value-of select="length/@fits"/>&amp;bg=3698360&amp;bb=932536&amp;bo=6597375&amp;bt=16777215&amp;text=<xsl:value-of select="title" /></xsl:attribute>
      <xsl:attribute name="width"><xsl:value-of select="length * 3" /></xsl:attribute>
      
      <xsl:attribute name="alt">
         <xsl:value-of select="title" />   
      </xsl:attribute>

      <xsl:attribute name="title">
         <xsl:value-of select="length" />
      </xsl:attribute>      

      </img>
      </a>      

   </xsl:template>
	

   <xsl:template match="schedule">

      <xsl:variable name="bgColour">16724787</xsl:variable>
      
      <xsl:if test="itemState = 2">
         <xsl:variable name="bgColour">932536</xsl:variable>
      </xsl:if>  



      <xsl:if test="@prePadding > 0">
         <img src="" height="{$imageHeight}" alt="clear" border="0">
         <xsl:attribute name="src">/servlet/ImageDataRes?action=01&amp;width=<xsl:value-of select="@prePadding * 3" />&amp;height=<xsl:value-of select="$imageHeight"/>&amp;bg=3698360&amp;text=blank</xsl:attribute>
         <xsl:attribute name="width"><xsl:value-of select="@prePadding * 3" /></xsl:attribute>
         </img>
      </xsl:if> 


      <a border="0">
      <xsl:attribute name="href"><xsl:value-of select="progEdit" /></xsl:attribute>
      
      <img src="" height="{$imageHeight}" border="0">
      <xsl:attribute name="src">/servlet/ImageDataRes?action=01&amp;width=<xsl:value-of select="@span * 3" />&amp;height=<xsl:value-of select="$imageHeight"/>&amp;fits=<xsl:value-of select="@fits"/>&amp;bg=3698360&amp;bb=<xsl:value-of select="$bgColour"/>&amp;bo=6597375&amp;bt=16777215&amp;text=<xsl:value-of select="title" />(<xsl:value-of select="itemStatus" />)</xsl:attribute>
      
      <xsl:attribute name="alt"><xsl:value-of select="title" /> (<xsl:value-of select="itemStatus" />)</xsl:attribute>
      <xsl:attribute name="width"><xsl:value-of select="@span * 3" /></xsl:attribute>      
      
      <xsl:if test="@fits = 1">
         <xsl:attribute name="style2">border-right: 2px solid #FFFFFF; border-left: 2px solid #ff47f9;</xsl:attribute>
         
         <xsl:if test="itemState = 2">
            <xsl:attribute name="style2">border-right: 2px solid #FFFFFF; border-left: 2px solid #ff47f9;</xsl:attribute>
         </xsl:if>
      </xsl:if>

      <xsl:if test="@fits = 2">
         <xsl:attribute name="style2">border-left: 2px solid #FFFFFF;</xsl:attribute>
         
         <xsl:if test="itemState = 2">
            <xsl:attribute name="style2">border-left: 2px solid #FFFFFF;</xsl:attribute>
         </xsl:if>                  
      </xsl:if>

      <xsl:if test="@fits = 3">
         <xsl:attribute name="style2">border-right: 2px solid #FFFFFF;</xsl:attribute>
         
         <xsl:if test="itemState = 2">
            <xsl:attribute name="style2">border-right: 2px solid #FFFFFF;</xsl:attribute>
         </xsl:if>          
      </xsl:if>

      <xsl:if test="itemState = 2">
         <xsl:attribute name="class2">epgScheduleRunning</xsl:attribute>
      </xsl:if>
      
      </img>
      </a>    
    
   </xsl:template>	


	
	<xsl:template match="navigation">

      <td>
      
      <img src="" height="{$imageHeight}" width="180" border="0">
      <xsl:attribute name="src">/servlet/ImageDataRes?action=01&amp;width=180&amp;height=<xsl:value-of select="$imageHeight"/>&amp;bg=3698360&amp;bb=932536&amp;bo=6597375&amp;bt=16777215&amp;ft=1&amp;text=<xsl:value-of select="//@title" /></xsl:attribute>
      </img>  
            
      <a class="ButtonText" href="/servlet/ApplyTransformRes?xml=epg-index&amp;xsl=kb-buttons">
      <img src="/servlet/ImageDataRes?action=01&amp;width=60&amp;height={$imageHeight}&amp;bg=3698360&amp;bb=932536&amp;bo=6597375&amp;bt=16777215&amp;ft=1&amp;text=Back" width="60" height="{$imageHeight}" alt="" border="0"/>
      </a>
      
      <a class="ButtonText">
      <xsl:attribute name="href"><xsl:value-of select="previous" /></xsl:attribute>
      <img src="/servlet/ImageDataRes?action=01&amp;width=60&amp;height={$imageHeight}&amp;bg=3698360&amp;bb=932536&amp;bo=6597375&amp;bt=16777215&amp;ft=1&amp;text=Prev" width="60" height="{$imageHeight}" alt="" border="0"/>
      </a> 

      <a class="ButtonText">
      <xsl:attribute name="href"><xsl:value-of select="next" /></xsl:attribute>
      <img src="/servlet/ImageDataRes?action=01&amp;width=60&amp;height={$imageHeight}&amp;bg=3698360&amp;bb=932536&amp;bo=6597375&amp;bt=16777215&amp;ft=1&amp;text=Next" width="60" height="{$imageHeight}" alt="" border="0"/>
      </a>
      
      </td>

   </xsl:template>  
	
	   
</xsl:stylesheet>

