<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

   <xsl:template match="/">
     
     
      <html>
      <head>
      <title>Timer Control</title>
      
      
<style type="text/css">

body
{
   font-family: Arial, Helvetica, sans-serif;
   background-color: #386EB8;
   color: #DDDDFF;
   margin: 0; 
   text-decoration: none;  
}

a.ButtonText
{
	color: #FFFFFF;
	text-decoration: none;
}

td.itemRow
{
   font-size: 12px;
   background-color: #0E3AB8;
   padding: 1px;
   text-align: left;
   border: 1px solid #8E8EE8;
}
div.title
{
   font-size: 14px;
}
</style> 

      </head>
      
      <body>
      
      <table>
      <tr><td>
      
      <xsl:if test="//@total = 0">
      <div class="title">
       
        <xsl:if test="//@filter = 0">
        No Pending Schedules
        </xsl:if>

        <xsl:if test="//@filter = 1">
        No Past Schedules
        </xsl:if>      

      </div>
      </xsl:if>
      
      <xsl:if test="//@total > 0">
      <div class="title"> <xsl:value-of select="//@start + 1" /> to <xsl:value-of select="//@end" /> of <xsl:value-of select="//@total" />
      
        <xsl:if test="//@filter = 0">
        Pending Schedules
        </xsl:if>

        <xsl:if test="//@filter = 1">
        Past Schedules
        </xsl:if>
      
      </div>
      </xsl:if>
      
        <table width='100%' border='0' cellspacing='1' cellpadding='0' >
        
        
         <xsl:if test="//@start = 0">
                 
            <tr>
            <td class='itemRow'>
            
            <a>
            <xsl:attribute name="href">/servlet/ApplyTransformRes?xml=sub-sch&amp;xsl=kb-buttons</xsl:attribute>
            <xsl:attribute name="class">ButtonText</xsl:attribute>
            Back</a>
            
            </td>
                        
            
            </tr>
      
         </xsl:if>     
         
         <xsl:if test="//@start > 0">
                 
            <tr>
            <td class='itemRow'>
            
            <a>
            <xsl:attribute name="href">/servlet/KBScheduleDataRes?start=<xsl:value-of select="//@start - //@show" />&amp;show=<xsl:value-of select="//@show" />&amp;filter=<xsl:value-of select="//@filter" /></xsl:attribute>
            <xsl:attribute name="class">ButtonText</xsl:attribute>
            Back</a>
                        
            </td>
            
            </tr>
      
         </xsl:if>
        
        
        <xsl:apply-templates select="//schedule" mode="rows" />
        
        
         <xsl:if test="//@end != //@total">
                 
            <tr>
            <td class='itemRow'>
            
            <a>
            <xsl:attribute name="href">/servlet/KBScheduleDataRes?start=<xsl:value-of select="//@end" />&amp;show=<xsl:value-of select="//@show" />&amp;filter=<xsl:value-of select="//@filter" /></xsl:attribute>
            <xsl:attribute name="class">ButtonText</xsl:attribute>
            Next</a>            
            
            </td>
            
            </tr>
      
         </xsl:if>          
        
        
        </table>
        
        
        
      </td></tr></table>  
      </body>
      </html>     
     
   </xsl:template>

   
   
   <xsl:template match="schedule" mode="rows">

      <tr>
      <td class='itemRow' style="padding-left:10;">

      <a>
      <xsl:attribute name="href"><xsl:value-of select="action" /></xsl:attribute>
      <xsl:attribute name="title"><xsl:value-of select="schName" /></xsl:attribute>
      <xsl:attribute name="class">ButtonText</xsl:attribute>
      <xsl:value-of select="@start" /> (<xsl:value-of select="schDur" />): <xsl:value-of select="schStatus" />
      
      <xsl:variable name="maxSize" select="25" />
      <xsl:choose> 
      <xsl:when test="string-length(schName) &lt; $maxSize">
         (<xsl:value-of select="schName" />)
      </xsl:when>
      <xsl:otherwise>
         (<xsl:value-of select="substring(schName, 0, number($maxSize)-2)" />...)
      </xsl:otherwise>     
      </xsl:choose>

      </a>       
      
      </td>
      </tr>

   
	</xsl:template>
   
</xsl:stylesheet>

