<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

	<xsl:template match="/">
   
   <html>
   <head>
   <title>program Details</title>
   <script src="/javascript/jumpBack.js"></script>
   <style type="text/css">
   
   table.detailsTable
   {
      margin: 0px;
      padding: 1px;
      border: 0px none #000000;
   }
   
   body
   {
      font-family: Arial, Helvetica, sans-serif;
      background-color: #386EB8;
      color: #DDDDFF;
      text-decoration: none;
      margin:0px;
   }   
   td.program
   {
      font-size:13px;
      background-color: #0E3AB8;
      padding: 2px;
      border: 1px solid #FFFFFF;
   }  
   a.navText
   {
      color: #DDDDFF;
      font-weight: BOLD;
      text-decoration: none;
   }   
   td.itemText
   {
      font-size:13px;
   }     
   </style>
   
   </head>
   <body>
   
   <table border="0" class="detailsTable">

   <tr>
   <td align="right" class="program">Title</td>
   <td class="itemText">
   <xsl:apply-templates select="//title" mode="cols" />
   <xsl:if test="string-length(//sub-title) > 0"> : <xsl:apply-templates select="//sub-title" mode="cols" />
   </xsl:if>
   </td>
   </tr>
   
   <tr>
   <td align="right" class="program">Time</td>
   <td class="itemText">
   <xsl:value-of select="//start" />
   </td>
   </tr>   
   
   <tr>
   <td align="right" class="program">Lenth</td>
   <td class="itemText">
   <xsl:value-of select="//duration" /> min
   </td>
   </tr>    
   
   <xsl:if test="string-length(//channel) > 0">
      <tr>
      <td align="right" class="program">Channel</td>
      <td class="itemText">
      <xsl:value-of select="//channel" />
      </td>
      </tr>  
   </xsl:if>     
   
   <tr>
   <td colspan="2" class="program">Description:<br/>
   <xsl:value-of select="//description" />
   <p/>
   <a class="navText">
   <xsl:attribute name="onClick">return confirm(&quot;Are you sure you want to add this to the schedule list?&quot;);</xsl:attribute>
   <xsl:attribute name="href"><xsl:value-of select="//addURL" /></xsl:attribute> 
   - Add to Schedule List</a>
   <br/>
   
   <xsl:if test="string-length(//url-source) > 5">
      <a class="navText">
      <xsl:attribute name="href"><xsl:value-of select="//url-source" /></xsl:attribute> 
      - Show Source URL
      </a><br/>
   </xsl:if>
   
   <xsl:if test="string-length(//autoAddURL) > 0">
      <a class="navText">
      <xsl:attribute name="href"><xsl:value-of select="//autoAddURL" /></xsl:attribute> 
      - Create Auto-Add Item
      </a><br/>
   </xsl:if>   
   
   <a class="navText">
   <xsl:attribute name="href">/servlet/KBEpgDataRes?action=01&amp;year=<xsl:value-of select="//@year" />&amp;month=<xsl:value-of select="//@month" />&amp;day=<xsl:value-of select="//@day" />&amp;start=<xsl:value-of select="//@hour" />&amp;selected=<xsl:value-of select="//title" /></xsl:attribute>
   - Show in EPG</a>
   <br/> 
   
   <a class="navText" href="/servlet/ApplyTransformRes?xml=epg-index&amp;xsl=kb-buttons">
   - Main Epg Menu</a> 
      
   </td>
   </tr>   
     

   </table>
   
   </body>
   </html>
   
   </xsl:template>


</xsl:stylesheet>