<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

	<xsl:template match="/">
   
      <html>
      <head>
      <title>DV Scheduler System Status</title>
<script>
function showTitle(obj)
{
  var id = obj.getAttribute('scheduleId');
  var channel = obj.getAttribute('channel');
  var w = screen.availWidth;
  var h = screen.availHeight;

  var popW = 650;
  var popH = 550;

  var leftPos = (w - popW) / 2;
  var topPos = (h - popH) / 2;

  var newWindow = window.open('/servlet/EpgDataRes?action=06&amp;id=' + id + '&amp;channel=' + encodeURIComponent(channel) ,'popup','width=' + popW + ',height=' + popH + ',top=' + topPos + ',left=' + leftPos +',scrollbars=yes,resizable=yes');
  newWindow.focus();
}
</script>
      <link rel="stylesheet" href="/css/main.css" type="text/css"/>
      <xsl:comment>[if lt IE 7.0]&gt;
      &lt;script src="/javascript/iepng.js"&gt;&lt;/script&gt;
      &lt;![endif]</xsl:comment>
      <script src="/javascript/main.js"></script>
      </head>
      <body>
      <center>
      <br/><br/>
      <img border="0" src="/images/logo.png" align="absmiddle" width="64" height="64"/> 
      <span class="pageTitle"> DV Scheduler</span>
      <br/>
      <br/>
      <table cellpadding="5" border="0">
      <tr>
      <td valign="top" nowrap="1" rowspan="1">
      
      <a href="/servlet/ScheduleDataRes" class="noUnder">
      <img border="0" src="/images/schedule.png" align="absmiddle" width="48" height="48"/> 
      <span class="areaTitle">Schedules</span>
      </a>
      <p/>
      
      <p/>
      <a class="noUnder" href="/servlet/EpgDataRes?action=12&amp;scrollto=-1"> 
      <img border="0" src="/images/epg.png" align="absmiddle" width="48" height="48"/> 
      <span class="areaTitle">Show EPG</span>
      </a>
      <p/>      
      
      <p/>
      <a class="noUnder" href="/servlet/EpgDataRes?action=22">
      <img border="0" src="/images/search.png" align="absmiddle" width="48" height="48"/> 
      <span class="areaTitle">Search EPG</span>
      </a>
      <p/>     
           
      <p/> 
      <a class="noUnder" href="/servlet/EpgDataRes?action=21"> 
      <img border="0" src="/images/now_next.png" align="absmiddle" width="48" height="48"/> 
      <span class="areaTitle">Now &amp; Next</span>      
      </a>
      <p/>
      
      <p/>
      <a href="/settings.html" class="noUnder">
      <img border="0" src="/images/settings.png" align="absmiddle" width="48" height="48"/> 
      <span class="areaTitle">System</span>
      </a>
      <p/>
      
      </td>
      <td valign="top">
      
      <table width="100%">
      <tr><td>
      
      <table width="100%">
	   <tr>
      <td colspan="3" style="border: solid #FFFFFF 1px;">
      <b>Now Running:</b>     
      </td>
      </tr>	
      
      <xsl:if test="count(//now_running/item) > 0">
         <xsl:apply-templates select="//now_running/item" />
      </xsl:if>
      <xsl:if test="count(//now_running/item) = 0">
	      <tr>
         <td colspan="3">
         No running captures
         </td>
         </tr>	
      </xsl:if>
      
      </table>
      <p/>
      
      <table width="100%">
	   <tr>
      <td colspan="3" style="border: solid #FFFFFF 1px;">
      <b>Next Schedule:</b>     
      </td>
      </tr>	
      
      <xsl:if test="count(//next/item) > 0">
         <xsl:apply-templates select="//next/item" />
      </xsl:if>
      <xsl:if test="count(//next/item) = 0">
	      <tr>
         <td colspan="3">
         No pending schedules
         </td>
         </tr>	
      </xsl:if>
      
      </table>
      <p/>      
      
      
      
      <table width="100%">
      
	   <tr>
      <td colspan="1" style="border: solid #FFFFFF 1px;">  
      <b>EPG:</b>  
      </td>	   
      <td colspan="2" style="border: solid #FFFFFF 1px;">    
      <b>Now</b>
      </td>
      <td colspan="2" style="border: solid #FFFFFF 1px;">    
      <b>Next</b>
      </td>      
      </tr>  
    
      
      <xsl:if test="count(//now_and_next/channel) > 0">
         <xsl:apply-templates select="//now_and_next/channel" />
      </xsl:if>
      <xsl:if test="count(//now_and_next/channel) = 0">
	      <tr>
         <td colspan="4">
         No EPG items
         </td>
         </tr>	
      </xsl:if>
      
      </table>
      <p/>   
      
      </td></tr>
      </table>
      
      
      </td></tr>
      <tr><td colspan="2" valign="bottom" align="right">
      <table>
      
      <xsl:apply-templates select="//version" />
      <xsl:apply-templates select="//time" />
      
      </table>      
      
      </td>
      </tr>
      
      
      </table>
      </center>
      </body>
      </html>
   
	</xsl:template>
	
	<xsl:template match="now_and_next/channel" >
	   <tr>
      <td nowrap="1">
      <xsl:value-of select="@ws_channel" />
      </td>	   
      <td nowrap="1">
      <b><span style="cursor: pointer; cursor: hand;" scheduleId="{now/id}" channel="{@ws_channel}" onClick="showTitle(this)">
      <xsl:if test="string-length(now/name) > 20">
         <xsl:value-of select="substring(now/name, 0, 20)" />...
      </xsl:if>
      <xsl:if test="string-length(now/name) &lt;= 20">
         <xsl:value-of select="now/name" />
      </xsl:if>      
      </span></b>
      </td>
      <td nowrap="1">
      <xsl:if test="string-length(now/start/@hour_12) &gt; 0">    
	      <xsl:value-of select="now/start/@hour_12" />:<xsl:value-of select="now/start/@minute" /><xsl:value-of select="now/start/@am_pm" /> (<xsl:value-of select="now/duration" />)
      </xsl:if>
      </td>
      <td nowrap="1">
      <b><span style="cursor: pointer; cursor: hand;" scheduleId="{next/id}" channel="{@ws_channel}" onClick="showTitle(this)">
      <xsl:if test="string-length(next/name) > 20">
         <xsl:value-of select="substring(next/name, 0, 20)" />...
      </xsl:if>
      <xsl:if test="string-length(next/name) &lt;= 20">
         <xsl:value-of select="next/name" />
      </xsl:if> 
      </span></b>
      </td>
      <td nowrap="1">  
      <xsl:if test="string-length(next/start/@hour_12) &gt; 0">    
         <xsl:value-of select="next/start/@hour_12" />:<xsl:value-of select="next/start/@minute" /><xsl:value-of select="next/start/@am_pm" /> (<xsl:value-of select="next/duration" />)
      </xsl:if>
      </td>    
      </tr>	
	</xsl:template>		
	
	
	<xsl:template match="next/item" >
	   <tr>
      <td nowrap="1">
      <xsl:value-of select="start/@hour_12" />:<xsl:value-of select="start/@minute" /><xsl:value-of select="start/@am_pm" /> (<xsl:value-of select="duration" />)
      </td>
      <td nowrap="1" width="100%">      
      <xsl:value-of select="name" />
      </td>
      <td nowrap="1"> 
      <xsl:value-of select="time_to_action/@days" /> d, <xsl:value-of select="time_to_action/@hours" /> h, <xsl:value-of select="time_to_action/@minutes" /> m, <xsl:value-of select="time_to_action/@seconds" /> s
      </td>
      </tr>	
	</xsl:template>		

	<xsl:template match="now_running/item" >
	   <tr>
      <td nowrap="1">
      <xsl:value-of select="start/@hour_12" />:<xsl:value-of select="start/@minute" /><xsl:value-of select="start/@am_pm" /> (<xsl:value-of select="duration" />)
      </td>
      <td nowrap="1" width="100%">      
      <xsl:value-of select="name" />
      </td>
      <td nowrap="1"> 
      <xsl:value-of select="status" />
      </td>
      </tr>	
	</xsl:template>	

   
	<xsl:template match="version" >
   
 
      <tr><td>Scheduler Version</td><td>: <xsl:value-of select="@scheduler" /></td></tr>
      <tr><td>Capture Engine</td><td>: <xsl:value-of select="@capture_engine" /></td></tr>
   
	</xsl:template>
	
	<xsl:template match="time" >
   
 
      <tr><td>Server Time</td><td>: <xsl:value-of select="@hour_12" />:<xsl:value-of select="@minute" /><xsl:value-of select="@am_pm" /></td></tr>
   
	</xsl:template>	
   
</xsl:stylesheet>

