<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:template match="/">
    <html>
    <head>
    <title>Channel Setting</title>
    <link rel="stylesheet" href="/css/main.css" type="text/css"/>
<style>
div.listTitle
{
  background: #789AFF;
  width: 145px;
}
</style>
<script src="/javascript/main.js"></script>
<xsl:comment>[if lt IE 7.0]&gt;
&lt;script src="/javascript/iepng.js"&gt;&lt;/script&gt;
&lt;![endif]</xsl:comment>

<script language="JavaScript">
function addDefaultValues(type)
{
  if ( type.indexOf('DVB-S') &gt; -1 )
  {
    document.getElementById('lowOsc').value = 9750000;
    document.getElementById('highOsc').value = 10600000;
    document.getElementById('lnbSwitch').value = 11700000;
  }
}

function checkFrequency(value)
{
  var type = document.getElementsByName('networkType')[0].value;

  if ( ( type.indexOf('DVB-S') > -1 ) &amp;&amp; (value > 0) &amp;&amp; ((value &lt; 2000000) || (value &gt; 20000000)) )
    alert('Please check the value entered\r\nValue should be in kiloHertz (kHz)\r\nE.g. 11700 MHz = 11700000 kHz');
}

function checkBandwidth(value)
{
  if ( (value) &amp;&amp; ((value &lt; 6) || (value &gt; 8)) )
    alert('Please check the value entered\r\nValue should be in MegaHertz (MHz)\r\nCommon values are 6, 7, 8 MHz');
}

function isChannelSelection()
{
  var selectionAll = document.getElementById("selectionAll");
  var selectionProgramID = document.getElementById("selectionProgramID");
  var selectionCustomPIDs = document.getElementById("selectionCustomPIDs");
  if (!selectionAll.checked &amp;&amp; !selectionProgramID.checked &amp;&amp; !selectionCustomPIDs.checked)
  {
    alert("You must choose a Channel Selection");
    return false;
  }
  if (selectionProgramID.checked &amp;&amp; !document.getElementById("programid").value)
  {
    alert("You must enter a Program ID in Channel Selection")
    return false;
  } 
  else if (selectionCustomPIDs.checked)
  {
    if (!document.getElementById("videoid").value &amp;&amp; !document.getElementById("audioid").value &amp;&amp; !document.getElementById("pmtid").value &amp;&amp; !document.getElementById("pcrid").value &amp;&amp; !document.getElementById("teletextid").value &amp;&amp; !document.getElementById("pid").value)
    {
      alert("You must enter at least one PID in Channel Selection");
      return false;
    }
    else if (document.getElementById("customRebuildPat").checked &amp;&amp; (!document.getElementById("customProgramid").value || !document.getElementById("pmtid").value))
    {
      alert("To Rebuild PAT, you must enter a Program ID and a PMT PID in Channel Selection");
      return false;
    }
  }
  else
  {
    return true;
  }
}

function showProgramID()
{
  document.getElementById("divProgID").style.height = "";
  document.getElementById("divCustom").style.height = "1px";
}

function showAll()
{
  document.getElementById("divProgID").style.height = "1px";
  document.getElementById("divCustom").style.height = "1px";
}

function showCustomPID()
{
  document.getElementById("divProgID").style.height = "1px";
  document.getElementById("divCustom").style.height = "";
}

function setup()
{
  if (document.getElementById("selectionProgramID").checked)
    showProgramID();
  else if (document.getElementById("selectionAll").checked)
    showAll();
  else if (document.getElementById("selectionCustomPIDs").checked)
    showCustomPID();
}

function checkCustomRebuildPat()
{
  var customRebuildPat = document.getElementById("customRebuildPat");
  if (customRebuildPat.checked == false)
    return;
    
  if ( document.getElementById("customProgramid").value.length &lt;= 0 )
  {
    alert('Please fill in the Program ID field first');
    customRebuildPat.checked = false;
  }
  else if ( document.getElementById("pmtid").value.length &lt;= 0 )
  {
    alert('Please fill in the PMT PID field first');
    customRebuildPat.checked = false;
  }
}

function checkDisabledPids()
{
  var disabledpid = document.getElementById("disabledpid");
  if (!disabledpid.value)
    return;
  
  if ( document.getElementById("pmtid").value.length &lt;= 0 )
  {
    alert('Please fill in the PMT PID field first');
    disabledpid.value = "";
  }
}
</script>
</head>
<body onLoad="setup()">
<center>
<br/><br/>
<a href='/' class="noUnder"><img border='0' src='/images/logo.png' align='absmiddle' width='64' height='64'/> <span class='pageTitle'> DV Scheduler</span></a><br/>
<br/>
<br/>
<a href='/servlet/ChannelDataRes' class="noUnder"> <img border='0' src='/images/back.png' align='absmiddle' width='24' height='24'/> 
Channel Setup</a>
<p/>

<form action='/servlet/ChannelDataRes' method='POST' accept-charset="UTF-8">
<input type='hidden' name='action' value='13'/>
<input type='hidden' name='oldName' value='{//@name}'/>

<table cellspacing="4" class='channelScanResult'>
<tr><td colspan="2" style="border: solid #FFFFFF 1px;"><strong>Demodulator Setting</strong></td></tr>
<tr><td>(Leave blank for default values)</td></tr>
<tr><td width="280" align="right">Alias</td><td><input type='text' name='demodulatorName' value='{//demodulatorname}'/>
<xsl:text> </xsl:text><img class='hand' border='0' src='/images/help24.png' alt='help' align='absmiddle' onClick="showHelp('demodulatorName');" width='24' height='24'/></td></tr>
<tr><td align="right">Type</td><td><select name='networkType' onChange='addDefaultValues(value)'><xsl:apply-templates select="//allNetworkTypes/item" /></select></td></tr>
<tr><td align="right">Carrier Frequency</td><td><input size="6" type='text' name='freq' value='{//frequency}' onChange="checkFrequency(value)"/> kHz</td></tr>
<tr><td align="right">Modulation</td><td>
      <select name="modulation">
      <option value=""></option>
      <option value="16QAM"><xsl:if test="//modulation='16QAM'"><xsl:attribute name="selected"/></xsl:if>16QAM</option>
      <option value="32QAM"><xsl:if test="//modulation='32QAM'"><xsl:attribute name="selected"/></xsl:if>32QAM</option>
      <option value="80QAM"><xsl:if test="//modulation='80QAM'"><xsl:attribute name="selected"/></xsl:if>80QAM</option>
      <option value="96QAM"><xsl:if test="//modulation='96QAM'"><xsl:attribute name="selected"/></xsl:if>96QAM</option>
      <option value="112QAM"><xsl:if test="//modulation='112QAM'"><xsl:attribute name="selected"/></xsl:if>112QAM</option>
      <option value="128QAM"><xsl:if test="//modulation='128QAM'"><xsl:attribute name="selected"/></xsl:if>128QAM</option>
      <option value="160QAM"><xsl:if test="//modulation='160QAM'"><xsl:attribute name="selected"/></xsl:if>160QAM</option>
      <option value="192QAM"><xsl:if test="//modulation='192QAM'"><xsl:attribute name="selected"/></xsl:if>192QAM</option>
      <option value="224QAM"><xsl:if test="//modulation='224QAM'"><xsl:attribute name="selected"/></xsl:if>224QAM</option>
      <option value="256QAM"><xsl:if test="//modulation='256QAM'"><xsl:attribute name="selected"/></xsl:if>256QAM</option>
      <option value="320QAM"><xsl:if test="//modulation='320QAM'"><xsl:attribute name="selected"/></xsl:if>320QAM</option>
      <option value="384QAM"><xsl:if test="//modulation='384QAM'"><xsl:attribute name="selected"/></xsl:if>384QAM</option>
      <option value="448QAM"><xsl:if test="//modulation='448QAM'"><xsl:attribute name="selected"/></xsl:if>448QAM</option>
      <option value="512QAM"><xsl:if test="//modulation='512QAM'"><xsl:attribute name="selected"/></xsl:if>512QAM</option>
      <option value="640QAM"><xsl:if test="//modulation='640QAM'"><xsl:attribute name="selected"/></xsl:if>640QAM</option>
      <option value="768QAM"><xsl:if test="//modulation='768QAM'"><xsl:attribute name="selected"/></xsl:if>768QAM</option>
      <option value="896QAM"><xsl:if test="//modulation='896QAM'"><xsl:attribute name="selected"/></xsl:if>896QAM</option>
      <option value="1024QAM"><xsl:if test="//modulation='1024QAM'"><xsl:attribute name="selected"/></xsl:if>1024QAM</option>
      <option value="QPSK" ><xsl:if test="//modulation='QPSK'"><xsl:attribute name="selected"/></xsl:if>QPSK</option>
      <option value="BPSK"><xsl:if test="//modulation='BPSK'"><xsl:attribute name="selected"/></xsl:if>BPSK</option>
      <option value="OQPSK"><xsl:if test="//modulation='OQPSK'"><xsl:attribute name="selected"/></xsl:if>OQPSK</option>
      <option value="8VSB"><xsl:if test="//modulation='8VSB'"><xsl:attribute name="selected"/></xsl:if>8VSB</option>
      <option value="16VSB"><xsl:if test="//modulation='16VSB'"><xsl:attribute name="selected"/></xsl:if>16VSB</option>
      <option value="8PSK"><xsl:if test="//modulation='8PSK'"><xsl:attribute name="selected"/></xsl:if>8PSK</option>
      <option value="16APSK"><xsl:if test="//modulation='16APSK'"><xsl:attribute name="selected"/></xsl:if>16APSK</option>
      <option value="32APSK"><xsl:if test="//modulation='32APSK'"><xsl:attribute name="selected"/></xsl:if>32APSK</option>
      <option value="NBC_QPSK"><xsl:if test="//modulation='NBC_QPSK'"><xsl:attribute name="selected"/></xsl:if>NBC_QPSK</option>
      <option value="NBC_8PSK"><xsl:if test="//modulation='NBC_8PSK'"><xsl:attribute name="selected"/></xsl:if>NBC_8PSK</option>
      <option value="DIRECTV"><xsl:if test="//modulation='DIRECTV'"><xsl:attribute name="selected"/></xsl:if>DIRECTV</option>
      </select>
<xsl:text> </xsl:text><img class='hand' border='0' src='/images/help24.png' alt='help' align='absmiddle' onClick="showHelp('modulation');" width='24' height='24'/>
</td></tr>
<tr><td align="right">Symbol Rate</td><td><input size="6" type='text' name='symbolRate' value='{//symbolrate}'/> kbauds</td></tr>
<tr><td align="right">ATSC Physical Channel Number</td><td><input size="6" type='text' name='physicalChannel' value='{//physicalchannel}'/><xsl:text> </xsl:text><img class='hand' border='0' src='/images/help24.png' alt='help' align='absmiddle' onClick="showHelp('AtscPhysicalChannelNumber');" width='24' height='24'/>
</td></tr>
<tr><td align="right">DVB-T Bandwidth</td><td><input size="6" type='text' name='band' value='{//bandwidth}' onChange="checkBandwidth(value)"/> MHz</td></tr>
<tr><td align="right">DVB-S2 Pilot</td><td>
      <select name="pilot">
      <option value=""></option>
      <option value="ON"><xsl:if test="//pilot='ON'"><xsl:attribute name="selected"/></xsl:if>ON</option>
      <option value="OFF"><xsl:if test="//pilot='OFF'"><xsl:attribute name="selected"/></xsl:if>OFF</option>
      </select>
<xsl:text> </xsl:text><img class='hand' border='0' src='/images/help24.png' alt='help' align='absmiddle' onClick="showHelp('pilot');" width='24' height='24'/>
</td></tr>
<tr><td align="right">DVB-S2 Roll-off</td><td>
      <select name="rollOff">
      <option value=""></option>
      <option value="0.2"><xsl:if test="//rollOff='0.2'"><xsl:attribute name="selected"/></xsl:if>0.2</option>
      <option value="0.25"><xsl:if test="//rollOff='0.25'"><xsl:attribute name="selected"/></xsl:if>0.25</option>
      <option value="0.35"><xsl:if test="//rollOff='0.35'"><xsl:attribute name="selected"/></xsl:if>0.35</option>
      </select>
<xsl:text> </xsl:text><img class='hand' border='0' src='/images/help24.png' alt='help' align='absmiddle' onClick="showHelp('rollOff');" width='24' height='24'/>
</td></tr>
<tr><td align="right">DVB-S Polarization</td><td>
      <select name="polarization">
      <option value=""></option>
      <option value="H"><xsl:if test="//polarization='H'"><xsl:attribute name="selected"/></xsl:if>Linear Horizontal</option>
      <option value="V"><xsl:if test="//polarization='V'"><xsl:attribute name="selected"/></xsl:if>Linear Vertical</option>
      <option value="L"><xsl:if test="//polarization='L'"><xsl:attribute name="selected"/></xsl:if>Circular Left</option>
      <option value="R"><xsl:if test="//polarization='R'"><xsl:attribute name="selected"/></xsl:if>Circular Right</option>
      </select>
</td></tr>
<tr><td align="right">DVB-S LNB Low Oscillator Frequency</td><td><input size="6" type='text' id='lowOsc' name='lowOsc' value='{//lowosc}' onChange="checkFrequency(value)"/> kHz</td></tr>
<tr><td align="right">DVB-S LNB High Oscillator Frequency</td><td><input size="6" type='text' id='highOsc' name='highOsc' value='{//highosc}' onChange="checkFrequency(value)"/> kHz</td></tr>
<tr><td align="right">DVB-S LNB Switch Frequency</td><td><input size="6" type='text' id='lnbSwitch' name='lnbSwitch' value='{//lnbswitch}' onChange="checkFrequency(value)"/> kHz</td></tr>
<tr><td align="right">DVB-S Longitude</td><td><input size="6" type='text' name='longitude' value='{//longitude}'/> degrees
      <select name="westLongitude">
      <option value=""></option>
      <option value="1"><xsl:if test="//westlongitude='1'"><xsl:attribute name="selected"/></xsl:if>WEST</option>
      <option value="0"><xsl:if test="//westlongitude='0'"><xsl:attribute name="selected"/></xsl:if>EAST</option>
      </select>
</td></tr>
<tr><td align="right">DVB-S Azimuth</td><td><input size="6" type='text' name='azimuth' value='{//azimuth}'/> degrees</td></tr>
<tr><td align="right">DVB-S Elevation</td><td><input size="6" type='text' name='elevation' value='{//elevation}'/> degrees</td></tr>
<tr><td align="right">DVB-S Input Range (DiSEqC, etc)</td><td><input type='text' name='inputRange' value='{//inputrange}'/><xsl:text> </xsl:text><img class='hand' border='0' src='/images/help24.png' alt='help' align='absmiddle' onClick="showHelp('inputRange');" width='24' height='24'/></td></tr>
<tr><td align="right">DVB-S DiSEqC</td><td><input type='text' name='diseqc' value='{//diseqc}'/><xsl:text> </xsl:text><img class='hand' border='0' src='/images/help24.png' alt='help' align='absmiddle' onClick="showHelp('diseqc');" width='24' height='24'/></td></tr>
<tr> 
  <td align="right">Demodulator Data<br/><a href='/servlet/ChannelDataRes?action=14'><img class='hand' border='0' src='/images/RunTaskSmall.png' alt='Set up default values' title='Set up default values' align='absmiddle' width='24' height='24'/></a></td>
  <td><textarea name='demodulatorData' wrap='off' style="overflow:auto; height:80; width:240;" xml:space="preserve">
<xsl:value-of select="//demodulatordata"/></textarea></td>
</tr>
<tr><td colspan='2'><hr/></td></tr>
<tr><td align="right">Original Network ID</td><td><input size="6" type='text' id='originalNetworkId' name='originalNetworkId' value='{//originalNetworkId}'/></td></tr>
<tr><td align="right">Transport Stream ID</td><td><input size="6" type='text' id='transportStreamId' name='transportStreamId' value='{//transportStreamId}'/></td></tr>
<tr><td align="right">Default Character Set</td><td>
      <select name="characterSet">
      <option value=""></option>
      <option value="AUTO"><xsl:if test="//characterSet='AUTO'"><xsl:attribute name="selected"/></xsl:if>AUTO (apply known fixes)</option>
      <option value="DVB"><xsl:if test="//characterSet='DVB'"><xsl:attribute name="selected"/></xsl:if>DVB (default DVB character set)</option>
      <option value="ISO8859-1"><xsl:if test="//characterSet='ISO8859-1'"><xsl:attribute name="selected"/></xsl:if>ISO8859-1 (West European)</option>
      <option value="ISO8859-2"><xsl:if test="//characterSet='ISO8859-2'"><xsl:attribute name="selected"/></xsl:if>ISO8859-2 (Central and East European)</option>
      <option value="ISO8859-3"><xsl:if test="//characterSet='ISO8859-3'"><xsl:attribute name="selected"/></xsl:if>ISO8859-3 (South European)</option>
      <option value="ISO8859-4"><xsl:if test="//characterSet='ISO8859-4'"><xsl:attribute name="selected"/></xsl:if>ISO8859-4 (North European)</option>
      <option value="ISO8859-5"><xsl:if test="//characterSet='ISO8859-5'"><xsl:attribute name="selected"/></xsl:if>ISO8859-5 (Cyrillic)</option>
      <option value="ISO8859-6"><xsl:if test="//characterSet='ISO8859-6'"><xsl:attribute name="selected"/></xsl:if>ISO8859-6 (Arabic)</option>
      <option value="ISO8859-7"><xsl:if test="//characterSet='ISO8859-7'"><xsl:attribute name="selected"/></xsl:if>ISO8859-7 (Greek)</option>
      <option value="ISO8859-8"><xsl:if test="//characterSet='ISO8859-8'"><xsl:attribute name="selected"/></xsl:if>ISO8859-8 (Hebrew)</option>
      <option value="ISO8859-9"><xsl:if test="//characterSet='ISO8859-9'"><xsl:attribute name="selected"/></xsl:if>ISO8859-9 (Turkish)</option>
      <option value="ISO8859-10"><xsl:if test="//characterSet='ISO8859-10'"><xsl:attribute name="selected"/></xsl:if>ISO8859-10 (Nordic)</option>
      <option value="ISO8859-11"><xsl:if test="//characterSet='ISO8859-11'"><xsl:attribute name="selected"/></xsl:if>ISO8859-11 (Thai)</option>
      <option value="ISO8859-13"><xsl:if test="//characterSet='ISO8859-13'"><xsl:attribute name="selected"/></xsl:if>ISO8859-13 (Baltic)</option>
      <option value="ISO8859-14"><xsl:if test="//characterSet='ISO8859-14'"><xsl:attribute name="selected"/></xsl:if>ISO8859-14 (Celtic)</option>
      <option value="ISO8859-15"><xsl:if test="//characterSet='ISO8859-15'"><xsl:attribute name="selected"/></xsl:if>ISO8859-15 (West European updated)</option>
      </select>
<xsl:text> </xsl:text><img class='hand' border='0' src='/images/help24.png' alt='help' align='absmiddle' onClick="showHelp('characterSet');" width='24' height='24'/>
</td></tr>
<tr><td></td><td align="left"><input type='submit' name='scan' value='Scan'/>
<xsl:if test="//@update='1'"><input type='submit' name='update' value='Update'/>
<input type='submit' name='update' value='Update All'/>
<xsl:text> </xsl:text><img class='hand' border='0' src='/images/help24.png' alt='help' align='absmiddle' onClick="showHelp('updateDemodulator');" width='24' height='24'/></xsl:if><br/><br/></td></tr>
<tr><td colspan="2" style="border: solid #FFFFFF 1px;"><strong>Channel Setting</strong></td></tr>
    <tr> 
      <td align="right">Name</td>
      <td><input type='text' name='name' value='{//@name}'/></td>
    </tr>
    <tr> 
      <td align="right">Number</td>
      <td><input type='text' name='number' value='{//@number}'/></td>
    </tr>
    <tr> 
      <td align="right">Access</td>
      <td>
      <select name="access">
      <option value="0"><xsl:if test="//access='0'"><xsl:attribute name="selected"/></xsl:if>FTA</option>
      <option value="1"><xsl:if test="//access='1'"><xsl:attribute name="selected"/></xsl:if>CA</option>
      </select>
      </td>
    </tr>    
<tr><td align="right">Source ID</td><td><input size="6" type='text' id='sourceId' name='sourceId' value='{//sourceId}'/></td></tr>
    <tr> 
      <td align="right"><span class="scanChannelHeadingData">Default Capture Type</span></td>
      <td><select id='capturetype' name='capturetype'>
<option value='*UNDEFINED*'>(Please select one):</option>
  <xsl:apply-templates select="//allCaptureTypes/item" />
</select>
      <xsl:text> </xsl:text><img class='hand' border='0' src='/images/help24.png' alt='help' align='absmiddle' onClick="showHelp('/servlet/SystemDataRes?action=28');" width='24' height='24'/></td>
    </tr>
    <tr> 
      <td align="right"><span class="scanChannelHeadingData">Default Local Preview Type</span></td>
      <td><select id='previewtype' name='previewtype'>
<option value='*UNDEFINED*'>(Please select one):</option>
  <xsl:apply-templates select="//allPreviewTypes/item" />
</select>
      <xsl:text> </xsl:text><img class='hand' border='0' src='/images/help24.png' alt='help' align='absmiddle' onClick="showHelp('/servlet/SystemDataRes?action=30');" width='24' height='24'/></td>
    </tr>
    <tr> 
      <td align="right"><span class="scanChannelHeadingData">Default Remote Preview Type</span></td>
      <td><select id='previewremotetype' name='previewremotetype'>
<option value='*UNDEFINED*'>(Please select one):</option>
  <xsl:apply-templates select="//allPreviewRemoteTypes/item" />
</select>
      <xsl:text> </xsl:text><img class='hand' border='0' src='/images/help24.png' alt='help' align='absmiddle' onClick="showHelp('/servlet/SystemDataRes?action=33');" width='24' height='24'/></td>
    </tr>
    <tr> 
      <td align="right"><span class="scanChannelHeadingData">Default Local Surf Type</span></td>
      <td><select id='surftype' name='surftype'>
<option value='*UNDEFINED*'>(Please select one):</option>
  <xsl:apply-templates select="//allSurfTypes/item" />
</select>
      <xsl:text> </xsl:text><img class='hand' border='0' src='/images/help24.png' alt='help' align='absmiddle' onClick="showHelp('/servlet/SystemDataRes?action=32');" width='24' height='24'/></td>
    </tr>
    <tr> 
      <td align="right"><span class="scanChannelHeadingData">Default Remote Surf Type</span></td>
      <td><select id='surfremotetype' name='surfremotetype'>
<option value='*UNDEFINED*'>(Please select one):</option>
  <xsl:apply-templates select="//allSurfRemoteTypes/item" />
</select>
      <xsl:text> </xsl:text><img class='hand' border='0' src='/images/help24.png' alt='help' align='absmiddle' onClick="showHelp('/servlet/SystemDataRes?action=34');" width='24' height='24'/></td>
    </tr>
    <tr>
      <td align="right"><span class="scanChannelHeadingData">Default Capture Path</span></td>
      <td><SELECT id='capturePath' NAME='capturePath'>
<option value='*UNDEFINED*'>(Please select one):</option>
<xsl:apply-templates select="//allCapturePaths/item" />
</SELECT></td>
    </tr>
    <tr> 
      <td align="right"><span class="scanChannelHeadingData">User Data<br/><a href='/servlet/ChannelDataRes?action=14'><img class='hand' border='0' src='/images/RunTaskSmall.png' alt='Set up default values' title='Set up default values' align='absmiddle' width='24' height='24'/></a></span></td>
      <td><textarea name='userdata' wrap='off' style="overflow:auto; height:80; width:240;" xml:space="preserve">
<xsl:value-of select="//userdata" /></textarea></td>
    </tr>
    <tr><td align="right"><b>Channel Selection:</b></td></tr>
    <tr><td align="right"><div class="listTitle"><b>Program ID</b><input type='radio' onClick="showProgramID()" id='selectionProgramID' name='selection' value='0'><xsl:if test="//selection='0'"><xsl:attribute name="checked"/></xsl:if></input></div></td><td><font size='-1'>(slower channel change)</font></td></tr>
    <tr><td colspan="2"><div id="divProgID" style="overflow:hidden"><table>
    <tr id="progID1"><td width="279" align="right">Program ID</td><td><input size="5" name='programid' type='text' id="programid" value='{//program_id}'/></td></tr>

    <!--tr id="progID2"><td align="right">Real-time teletext timing</td><td><input name="programIdRealtimeTeletext" id="programIdRealtimeTeletext" type="checkbox" value="1"><xsl:if test="//teletext_id/@realtime='true'"><xsl:attribute name="checked"/></xsl:if></input><xsl:text> </xsl:text><font size='-1'>(option depends on broadcaster)</font></td></tr-->
    <input type='hidden' name='programIdRealtimeTeletext' value='{//teletext_id/@realtime}'/>

    <tr id="progID3"><td align="right">Rebuild PAT</td><td><input name="programIdRebuildPat" type="checkbox" value="1"><xsl:if test="//build_pat='true'"><xsl:attribute name="checked"/></xsl:if></input> <font size='-1'>(necessary for some media players)</font></td></tr>
    <tr id="progID4"><td align="right">Include only Video, Audio, Subtitles</td><td><input name="programIdVasOnly" type="checkbox" value="1"><xsl:if test="//program_id/@video_audio_subtitle_only='true'"><xsl:attribute name="checked"/></xsl:if></input> <font size='-1'>(some streams contain other data)</font></td></tr>

    <!--tr id="progID5"><td align="right">Include these PIDs</td><td><input name='includePidsProgId' type='text' id="includePidsProgId" value='{//other_id}'/></td></tr>
    <tr id="progID6"><td></td><td><font size='-1'>(include other PIDs not in the Program ID;<br/>Use comma for multiple PIDs)</font></td></tr-->
    <input type='hidden' name='includePidsProgId' value='{//other_id}'/>

    <tr id="progID7"><td align="right">Exclude these PIDs</td><td><input name='disabledpidProgId' type='text' id="disabledpidProgId" value='{//disabled_id}'/><xsl:text> </xsl:text><font size='-1'>(e.g. 53,988)</font></td></tr>
    <tr id="progID8"><td></td><td><font size='-1'>(exclude some PIDs in the Program ID;<br/>e.g. to remove an audio add its PID;<br/>this will also disable the PIDs in the PMT)</font></td></tr>
    </table></div></td></tr>

    <tr><td align="right"><div class="listTitle"><b>All</b><input type='radio' onClick="showAll()" id='selectionAll' name='selection' value='1'><xsl:if test="//selection='1'"><xsl:attribute name="checked"/></xsl:if></input></div></td></tr>
    <tr><td colspan="2"><div id="divAll" style="overflow:hidden;height:1px"><table>
    </table></div></td></tr>
    
    <tr><td align="right"><div class="listTitle"><b>Custom PIDs</b><input type='radio' onClick="showCustomPID()" id='selectionCustomPIDs' name='selection' value='2'><xsl:if test="//selection='2'"><xsl:attribute name="checked"/></xsl:if></input></div></td><td><font size='-1'>(faster channel change, depending on option)</font></td></tr>
    <tr><td colspan="2"><div id="divCustom" style="overflow:hidden"><table>
    <tr id="custom1"><td width="279" align="right">Program ID</td><td><input size="5" name='customProgramid' type='text' id="customProgramid" value='{//program_id}'/></td></tr>
    <tr id="custom2"><td align="right">PMT PID</td><td align="left" ><input size="5" type='text' name='pmtid' id='pmtid' value='{//pmt_id}'/></td></tr>
    <tr id="custom3"><td align="right">PCR PID</td><td align="left" ><input size="5" type='text' name='pcrid' id='pcrid' value='{//pcr_id}'/></td></tr>
    <tr id="custom4"><td align="right">Video PID</td><td><input size="5" type='text' name='videoid' id='videoid' value='{//video_id}'/>
    <select name="videoType">
  <xsl:apply-templates select="//allVideoTypes/item" />
    </select>
    </td></tr>
    <tr id="custom11"><td align="right">Set Video type in PMT</td><td><input name="customPatchPmtVideo" id="customPatchPmtVideo" type="checkbox" value="1"><xsl:if test="//video_id/@patch_pmt='true'"><xsl:attribute name="checked"/></xsl:if></input> <font size='-1'>(enable for unknown video; slower channel change)</font></td></tr>
    <tr id="custom5"><td align="right">Audio PID</td><td align="left" ><input size="5" type='text' name='audioid' id='audioid' value='{//audio_id}'/>
    <select name="audioType">
  <xsl:apply-templates select="//allAudioTypes/item" />
    </select>
    </td></tr>
    <tr id="custom12"><td align="right">Set Audio type in PMT</td><td><input name="customPatchPmtAudio" id="customPatchPmtAudio" type="checkbox" value="1"><xsl:if test="//audio_id/@patch_pmt='true'"><xsl:attribute name="checked"/></xsl:if></input> <font size='-1'>(enable for unknown audio; slower channel change)</font></td></tr>
    <tr id="custom6"><td align="right">Teletext PID</td><td align="left" ><input size="5" type='text' name='teletextid' id='teletextid' value='{//teletext_id}'/> Page <input size="5" type='text' name='teletextpage' value='{//teletext_id/@subtitle_page}'/></td></tr>

    <!--tr id="custom7"><td align="right">Real-time teletext timing</td><td><input name="customRealtimeTeletext" id="customRealtimeTeletext" type="checkbox" value="1"><xsl:if test="//teletext_id/@realtime='true'"><xsl:attribute name="checked"/></xsl:if></input><xsl:text> </xsl:text><font size='-1'>(option depends on broadcaster)</font></td></tr-->
    <input type='hidden' name='customRealtimeTeletext' value='{//teletext_id/@realtime}'/>

    <tr id="custom8"><td align="right">Other PIDs</td><td><input name='pid' type='text' id="pid" value='{//other_id}'/><xsl:text> </xsl:text><font size='-1'>(e.g. 25,783)</font></td></tr>
    <tr id="custom10"><td align="right">Disable these PIDs</td><td><input name='disabledpid' type='text' id="disabledpid" onChange="checkDisabledPids()" value='{//disabled_id}'/><xsl:text> </xsl:text><font size='-1'>(e.g. 53,988)</font></td></tr>
    <tr id="custom13"><td></td><td><font size='-1'>(exclude and disable some PIDs,<br/>e.g. to remove an audio add its PID (don't delete "Audio PID");<br/>slower channel change)</font></td></tr>
    <tr id="custom14"><td align="right">Rebuild PAT</td><td><input name="customRebuildPat" id="customRebuildPat" type="checkbox" onClick="checkCustomRebuildPat()" value="1"><xsl:if test="(//build_pat='true') and (//@update='1')"><xsl:attribute name="checked"/></xsl:if></input> <font size='-1'>(necessary for some media players)</font></td></tr>
    </table></div></td></tr>
<tr><td></td><td align="left"><input type='submit' name='add' value='Add' onClick="return isChannelSelection();"/>
<xsl:if test="//@update='1'"><input type='submit' name='update' value='Update' onClick="return isChannelSelection();"/></xsl:if><br/><br/></td></tr>
</table>
</form>
</center>
</body>
</html>
</xsl:template>

<xsl:template match="allNetworkTypes/item">
<option><xsl:attribute name="value"><xsl:value-of select="@name" /></xsl:attribute><xsl:if test="//networktype=@name"><xsl:attribute name="selected"/></xsl:if><xsl:value-of select="@name" /></option>
</xsl:template>

<xsl:template match="allCaptureTypes/item">
<option><xsl:if test="//capturetype=@value"><xsl:attribute name="selected"/></xsl:if><xsl:attribute name="value"><xsl:value-of select="@value" /></xsl:attribute><xsl:value-of select="@name" /></option>
</xsl:template>

<xsl:template match="allPreviewTypes/item">
<option><xsl:if test="//previewtype=@value"><xsl:attribute name="selected"/></xsl:if><xsl:attribute name="value"><xsl:value-of select="@value" /></xsl:attribute><xsl:value-of select="@name" /></option>
</xsl:template>

<xsl:template match="allPreviewRemoteTypes/item">
<option><xsl:if test="//previewremotetype=@value"><xsl:attribute name="selected"/></xsl:if><xsl:attribute name="value"><xsl:value-of select="@value" /></xsl:attribute><xsl:value-of select="@name" /></option>
</xsl:template>

<xsl:template match="allSurfTypes/item">
<option><xsl:if test="//surftype=@value"><xsl:attribute name="selected"/></xsl:if><xsl:attribute name="value"><xsl:value-of select="@value" /></xsl:attribute><xsl:value-of select="@name" /></option>
</xsl:template>

<xsl:template match="allSurfRemoteTypes/item">
<option><xsl:if test="//surfremotetype=@value"><xsl:attribute name="selected"/></xsl:if><xsl:attribute name="value"><xsl:value-of select="@value" /></xsl:attribute><xsl:value-of select="@name" /></option>
</xsl:template>

<xsl:template match="allCapturePaths/item">
<option><xsl:if test="//capturepath=@value"><xsl:attribute name="selected"/></xsl:if><xsl:attribute name="value"><xsl:value-of select="@value" /></xsl:attribute><xsl:value-of select="@name" /></option>
</xsl:template>

<xsl:template match="allVideoTypes/item">
<option><xsl:if test="//video_id/@type=@value"><xsl:attribute name="selected"/></xsl:if><xsl:attribute name="value"><xsl:value-of select="@value" /></xsl:attribute><xsl:value-of select="@name" /></option>
</xsl:template>

<xsl:template match="allAudioTypes/item">
<option><xsl:if test="//audio_id/@type=@value"><xsl:attribute name="selected"/></xsl:if><xsl:attribute name="value"><xsl:value-of select="@value" /></xsl:attribute><xsl:value-of select="@name" /></option>
</xsl:template>

</xsl:stylesheet>
