<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:template match="/">
    <html>
    <head>
    <title>DV Scheduler Channel Grouping</title>
    <link rel="stylesheet" href="/css/main.css" type="text/css"/>
    <link rel="stylesheet" href="/css/colour.css" type="text/css" />
<script src="/javascript/extra.js"></script>
<script src="/javascript/main.js"></script>
<xsl:comment>[if lt IE 7.0]&gt;
&lt;script src="/javascript/iepng.js"&gt;&lt;/script&gt;
&lt;![endif]</xsl:comment>
<script>
</script>
  </head>
  <body>
  <center>
  <br/><br/>
  <a href='/' class="noUnder"><img border="0" src="/images/logo.png" align="absmiddle" width="64" height="64"/><span class="pageTitle"> DV Scheduler</span></a>
  <br/>
  <br/>
  <a href='/servlet/ChannelDataRes' class="noUnder"> <img border='0' src='/images/back.png' align='absmiddle' width='24' height='24' /> 
Channel Setup</a>
  <br/><br/>
<form action='/servlet/ChannelDataRes' method='POST' accept-charset="UTF-8" name="settings" onSubmit='listSubmit()'>
<table>
<tr> 
  <td align="right">Name</td>
  <td><input type='text' name='channelName'><xsl:attribute name="value"><xsl:value-of select="//@channelName" /></xsl:attribute></input></td>
</tr>
<tr> 
  <td align="right">Number</td>
  <td><input type='text' name='channelNumber'><xsl:attribute name="value"><xsl:value-of select="//@channelNumber" /></xsl:attribute></input></td>
</tr>
</table>
<table cellspacing="6" cellpadding="6">
<tr>
<td>
Available Channels<br/>
<select name='chanAll' type='test' id="chanAll" multiple="True" size='16' style="width:200px">
  <xsl:apply-templates select="//orders/channelorder" />
</select>
<br/>
<font size='-1'>(Hold down CTRL to select<br/>multiple items)</font>
</td>
<td align="center">
<button type="button" onclick="listItemsAdd();" style="width:60px">-&gt;</button><br/><br/>
<button type="button" onclick="listItemsRemove();" style="width:60px">&lt;-</button><br/><br/><br/><br/>
<button type="button" onclick="listItemsUp();" style="width:60px">Up</button><br/><br/>
<button type="button" onclick="listItemsDown();" style="width:60px">Down</button>
</td>
<td>
Selected Channels<br/>
<select name='chanSelected' type='test' id="chanSelected" multiple="True" size='16' style="width:200px">
  <xsl:apply-templates select="//selected/channelorder" />
</select>
<br/>
<font size='-1'>(Hold down CTRL to select<br/>multiple items)</font>
</td>
</tr>
</table>
<input type="submit" name="add" value="Add"/>
<xsl:if test="//@channelName"><input type='submit' name='update' value='Update'/></xsl:if> 
<input name="action" type="hidden" id="action" value="20" />
<input type='hidden' name='oldChannelName'><xsl:attribute name="value"><xsl:value-of select="//@channelName" /></xsl:attribute></input>
<input type='hidden' name='chanMatch' id='chanMatch'/>
</form>
  </center>
If a channel is broadcasted for example on both DVB-S and DVB-T, then you can add the two channels into a channel group, creating a new virtual channel.

When a scheduled recording for a channel group is about to start, DV Scheduler will choose a device and channel that minimizes immediate conflicting overlapping schedules, follows channel priority and device priority, and checks for previous failures of the devices (skips a device if it has failed previously).
  </body>
  </html>

</xsl:template>
<xsl:template match="orders/channelorder">
<xsl:if test="not(@selected)"><option><xsl:attribute name="value"><xsl:value-of select="@name" /></xsl:attribute><xsl:value-of select="@name" /></option></xsl:if>
</xsl:template>
<xsl:template match="selected/channelorder">
<option><xsl:attribute name="value"><xsl:value-of select="@name" /></xsl:attribute><xsl:value-of select="@name" /></option>
</xsl:template>
</xsl:stylesheet>
