<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:template match="/">
    <html>
    <head>
    <title>Auto-Add</title>
    <link rel="stylesheet" href="/css/main.css" type="text/css"/>
<script src="/javascript/main.js"></script>
<xsl:comment>[if lt IE 7.0]&gt;
&lt;script src="/javascript/iepng.js"&gt;&lt;/script&gt;
&lt;![endif]</xsl:comment>
<script language="JavaScript">
function delEpgMatch(obj)
{
  var path = obj.parentNode.getAttribute('path');
  if ( confirm("Are you sure you want to delete this match item?") )
  {
    document.location.href = '/servlet/EpgAutoAddDataRes?action=17&amp;index=<xsl:value-of select="//@index"/>&amp;name=' + encodeURIComponent(path) + '&amp;dari=' + encodeURIComponent(document.location.href);
  }
}

function editEpgMatch(obj)
{
  var path = obj.parentNode.getAttribute('path');
  document.location.href = '/servlet/EpgAutoAddDataRes?action=08&amp;name=' + encodeURIComponent(path) + '&amp;dari=' + encodeURIComponent(document.location.href);
}

function addEpgMatch(obj)
{
  var epgMatchList = document.getElementById("epgMatchList");
  document.location.href = '/servlet/EpgAutoAddDataRes?action=16&amp;index=<xsl:value-of select="//@index"/>&amp;name=' + encodeURIComponent(epgMatchList.value) + '&amp;dari=' + encodeURIComponent(document.location.href);
}
</script>
  </head>
<body>
<center>
<a href='/' class="noUnder"><img border="0" src="/images/logo.png" align="absmiddle" width="64" height="64"/><span class="pageTitle"> DV Scheduler</span></a><br/>
<br/>
<a class="noUnder"><xsl:attribute name="href"><xsl:value-of select="//@dari" /></xsl:attribute>
<img border='0' src='/images/back.png' align='absmiddle' width='24' height='24' /> Back
</a>
<p/>
<form action='/servlet/EpgAutoAddDataRes' method='POST' accept-charset="UTF-8">
<input type="hidden" name="action" value="04" /><input type="hidden" name="oldAlias" value="{//@name}" />
  <table border="0" cellspacing="2" cellpadding="2">
  <tr><td align="right"><strong>Name</strong></td><td><input name="alias" type="text" id="alias" size="20"><xsl:attribute name="value"><xsl:value-of select="//@name" /></xsl:attribute></input></td></tr>
  <tr><td colspan="2" align="right"><br/></td></tr>
    <tr> 
      <td colspan="2"> <strong>Auto-Add Options</strong></td>
    </tr>
<xsl:choose>
<xsl:when test="//@index >= 0">
<tr><td colspan="2" style="border: 1px solid #FFFFFF;">
<table width='100%'>
  <xsl:choose>
  <xsl:when test="count(//matchList/matchListName) > 0">
  <xsl:apply-templates select="//matchList/matchListName" />
  </xsl:when>
  <xsl:otherwise>
  <tr><td><b> No Match Items </b></td></tr>
  </xsl:otherwise>
  </xsl:choose>
</table>
</td></tr>
<tr><td colspan='2'>
Available Match Lists :
<select name="name" id="epgMatchList">
  <xsl:apply-templates select="//allEpgMatches/item" />
</select>
<button type="button" onClick="addEpgMatch()">Add</button>
</td></tr>
</xsl:when>
<xsl:otherwise>
<tr><td colspan='2'>
Available Match Lists : <select name="name">
  <xsl:apply-templates select="//allEpgMatches/item" />
</select>
</td></tr>
</xsl:otherwise>
</xsl:choose>
  <tr><td colspan="2" align="right"><br/></td></tr>
    <tr> 
      <td align="right"><strong>Auto Deleteable</strong></td>
      <td><input name="autoDel" type="checkbox" id="autoDel2" value="true"><xsl:if test="//autoDel/@enabled = 'true'"><xsl:attribute name="checked">checked</xsl:attribute></xsl:if></input><strong>Keep 
        For </strong> <input name="keepFor" type="text" id="keepFor2" size="3"><xsl:attribute name="value"><xsl:value-of select="//autoDel/@keepFor" /></xsl:attribute></input>
        days </td>
    </tr>
    <tr><td colspan="2" align="right"><br/></td></tr>
    <tr> 
      <td align="right"><strong>Start Time Buffer</strong></td>
      <td><input name="startbuffer" type="text" id="startbuffer" size="3"><xsl:attribute name="value"><xsl:value-of select="//buffer/@start" /></xsl:attribute></input>
        minutes </td>
    </tr>
    <tr> 
      <td align="right"><strong>End Time Buffer</strong></td>
      <td><input name="endbuffer" type="text" id="endbuffer" size="3"><xsl:attribute name="value"><xsl:value-of select="//buffer/@end" /></xsl:attribute></input>
        minutes </td>
    </tr>
    <tr> 
      <td align="right"><strong>EPG Time Buffer</strong></td>
      <td><input name="epgbuffer" type="text" id="epgbuffer" size="3"><xsl:attribute name="value"><xsl:value-of select="//buffer/@epg" /></xsl:attribute></input>
        minutes</td>
    </tr>
    <tr><td colspan="2" align="right"><br/></td></tr>
    <tr>
      <td align="right" valign="top"><strong>Capture Type</strong></td>
      <td><select id='capturetype' name='capturetype'>
<option value='*UNDEFINED*'>(Please select one):</option>
  <xsl:apply-templates select="//allCaptureTypes/item" />
</select><xsl:text> </xsl:text><img style='cursor:hand;cursor:pointer;' border='0' src='/images/help24.png' alt='help' align='absmiddle' onClick="showHelp('/servlet/SystemDataRes?action=25');" width='24' height='24'/></td>
    </tr>
    <tr>
      <td align="right" valign="top"><strong>Capture Path</strong></td>
      <td><SELECT id='capturePath' NAME='capturePath'>
<option value='*UNDEFINED*'>(Please select one):</option>
<xsl:apply-templates select="//allCapturePaths/item" />
</SELECT>
</td>
    </tr>
    <tr>
      <td align="right" valign="top"><strong>Filename Pattern</strong></td>
      <td><select name='namePattern'>
<option value='*UNDEFINED*'>(Please select one):</option>
<xsl:apply-templates select="//allNamePatterns/item" />
</select></td>
    </tr>    
    <tr> 
      <td align="right" valign="top"><strong>Post Capture Task</strong></td>
      <td><select name='task'>
<option value='*UNDEFINED*'>(Please select one):</option>
<xsl:apply-templates select="//allTasks/item" />
</select>
</td>
    </tr>
    <tr><td colspan="2" align="right"><br/></td></tr>
    <tr>
      <td align="right"><strong>Merge Double Episodes</strong></td>
      <td><input name="mergeDoubleEpisodes" type="checkbox" value="true"><xsl:if test="//mergedoubleepisode/@enabled = 'true'"><xsl:attribute name="checked">checked</xsl:attribute></xsl:if></input></td>
    </tr>
    <tr>
      <td align="right"><strong>Exclude Duplicate Shows</strong></td>
      <td><input name="duplicateDetection" type="checkbox" value="true"><xsl:if test="//duplicateDetection/@enabled = 'true'"><xsl:attribute name="checked">checked</xsl:attribute></xsl:if></input><xsl:text> </xsl:text><img style='cursor:hand;cursor:pointer;' border='0' src='/images/help24.png' alt='help' align='absmiddle' onClick="showHelp('duplicateDetection');" width='24' height='24'/></td>
    </tr>
    <tr>
      <td align="right"> </td>
      <td><input name="submit" type='submit' value='Submit' /><input name="index" type="hidden" id="index"><xsl:attribute name="value"><xsl:value-of select="//@index" /></xsl:attribute></input><input name="putar" type="hidden"><xsl:attribute name="value"><xsl:value-of select="//@dari" /></xsl:attribute></input></td>
    </tr>
  </table>
</form>
</center>
</body>
  </html>
</xsl:template>

<xsl:template match="matchList/matchListName">
<tr><td><b><xsl:value-of select="." /></b></td><td align='right' path="{.}">
<img onClick="delEpgMatch(this)" class='hand' src='/images/delete.png' border='0' alt='Delete' title='Delete' width='24' height='24'/><xsl:text> </xsl:text>
<img onClick="editEpgMatch(this)" class='hand' src='/images/edit.png' border='0' alt='Edit' title='Edit' width='24' height='24'/>
</td></tr>
</xsl:template>

<xsl:template match="allEpgMatches/item">
<option><xsl:attribute name="value"><xsl:value-of select="@name" /></xsl:attribute><xsl:value-of select="@name" /></option>
</xsl:template>

<xsl:template match="allCaptureTypes/item">
<option><xsl:if test="//@captureType = @value"><xsl:attribute name="selected"/></xsl:if><xsl:attribute name="value"><xsl:value-of select="@value" /></xsl:attribute><xsl:value-of select="@name" /></option>
</xsl:template>

<xsl:template match="allCapturePaths/item">
<option><xsl:if test="//capturePath = @value"><xsl:attribute name="selected"/></xsl:if><xsl:attribute name="value"><xsl:value-of select="@value" /></xsl:attribute><xsl:value-of select="@name" /></option>
</xsl:template>

<xsl:template match="allNamePatterns/item">
<option><xsl:if test="//fileNamePattern = @value"><xsl:attribute name="selected"/></xsl:if><xsl:attribute name="value"><xsl:value-of select="@value" /></xsl:attribute><xsl:value-of select="@name" /></option>
</xsl:template>

<xsl:template match="allTasks/item">
<option><xsl:if test="//postTask = @value"><xsl:attribute name="selected"/></xsl:if><xsl:attribute name="value"><xsl:value-of select="@value" /></xsl:attribute><xsl:value-of select="@name" /></option>
</xsl:template>

</xsl:stylesheet>
