<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:template match="/">
    <html>
    <head>
    <title>EPG Data Source Setting</title>
    <link rel="stylesheet" href="/css/main.css" type="text/css"/>
<script src="/javascript/extra.js"></script>
<script src="/javascript/main.js"></script>
<xsl:comment>[if lt IE 7.0]&gt;
&lt;script src="/javascript/iepng.js"&gt;&lt;/script&gt;
&lt;![endif]</xsl:comment>
<script language="JavaScript">
function checkID()
{
  if(document.settings.sessionID.value.length != 6)
  {
    alert("Please enter the security ID at the bottom of the form!");
    return false;
  }
  else
  {
    listSubmit();
    return true;
  }
}
function setSecurityImage()
{
  var thisDate = new Date();
  var securityImageURL = "/servlet/ImageDataRes?sessionID=1&amp;time=" + thisDate.toGMTString();
  var image = document.getElementById("SecurityImage");
  if(image)
  {
    image.src = securityImageURL;
    setTimeout("setSecurityImage();", 180000);
  }
}
function enableProxyUP(bEnable)
{
  document.getElementById('httpProxyUsername').disabled = !bEnable;
  document.getElementById('httpProxyPassword').disabled = !bEnable;
}
</script>
  </head>
<body onLoad="setSecurityImage();" onpageshow="if (event.persisted) setSecurityImage();">
	<center>
		<a href='/' class="noUnder">
			<img border="0" src="/images/logo.png" align="absmiddle" width="64"
				height="64" />
			<span class="pageTitle"> DV Scheduler</span>
		</a>
		<br />
		<br />
		<a href='/settings.html' class="noUnder">
			<img border='0' src='/images/back.png' align='absmiddle' width='24'
				height='24' />
			<span class="areaTitle">System Index</span>
		</a>
		<p />
		<form action='/servlet/EpgDataRes' method='POST' accept-charset="UTF-8"
			name="settings">
			<xsl:if test="//@checkId='1'">
				<xsl:attribute name="onSubmit">return checkID();</xsl:attribute>
			</xsl:if>
			<xsl:if test="//@checkId='0'">
				<xsl:attribute name="onSubmit">listSubmit();</xsl:attribute>
			</xsl:if>
			<table border="0" cellspacing="2" cellpadding="2">
				<tr>
					<td colspan="3">
						<table width="100%" border="0" cellspacing="0" cellpadding="0">
							<tr>
								<td width="100%">
									<strong>Guide Data Source Settings</strong>
								</td>
								<td width="10"></td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td style="border: 1px solid #FFFFFF;">
						<table>
							<tr>
								<td align="right">
									<strong>
										<input name="sourceTypeInternal" type="checkbox" value="1">
											<xsl:if test="//@internalSourceEnabled='1'">
												<xsl:attribute name="checked" />
											</xsl:if>
										</input>
									</strong>
								</td>
								<td colspan="2">
									<strong>Built-in EPG Scanner</strong>
								</td>
							</tr>
							<tr>
								<td align="right">
								</td>
								<td>Start a Capture or Preview or Channel Surf for a few minutes
									to get that channel's EPG.</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td style="border: 1px solid #FFFFFF;">
						<table>
							<tr>
								<td align="right">
									<strong>
										<input name="sourceTypeFile" type="checkbox" value="1">
											<xsl:if test="//@fileSourceEnabled='1'">
												<xsl:attribute name="checked" />
											</xsl:if>
										</input>
									</strong>
								</td>
								<td colspan="2">
									<strong>File Source</strong>
								</td>
							</tr>
							<tr>
								<td align="right">
								</td>
								<td>File or Directory (one per line)</td>
							</tr>
							<tr>
								<td align="right">
								</td>
								<td>
									<textarea name='fileDIR' wrap='off'
										style="overflow:auto; height:80; width:610;">
										<xsl:value-of select="//fileDIR" />
									</textarea>
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td style="border: 1px solid #FFFFFF;">
						<table>
							<tr>
								<td align="right">
									<strong>
										<input name="sourceTypeHttp" type="checkbox" value="1">
											<xsl:if test="//@httpSourceEnabled='1'">
												<xsl:attribute name="checked" />
											</xsl:if>
										</input>
									</strong>
								</td>
								<td colspan="2">
									<strong>HTTP Web Source</strong>
								</td>
							</tr>
							<tr>
								<td align="right">
								</td>
								<td>Address (one per line)</td>
								<td>Username</td>
								<td>Password</td>
							</tr>
							<tr>
								<td align="right">
								</td>
								<td>
									<textarea
										onScroll="httpUser.scrollTop=scrollTop;httpPassword.scrollTop=scrollTop;"
										id='httpURL' name='httpURL' wrap='off'
										style="overflow:auto; height:80; width:430;" xml:space="preserve">
<xsl:value-of select="//httpURL" /></textarea>
								</td>
								<td>
									<textarea
										onScroll="httpURL.scrollTop=scrollTop;httpPassword.scrollTop=scrollTop;"
										id='httpUser' name='httpUser' wrap='off'
										style="overflow:auto; height:80; width:85;" xml:space="preserve">
<xsl:value-of select="//httpUser" /></textarea>
								</td>
								<td>
									<textarea
										onScroll="httpURL.scrollTop=scrollTop;httpUser.scrollTop=scrollTop;"
										id='httpPassword' name='httpPassword' wrap='off'
										style="overflow:auto; height:80; width:85;" xml:space="preserve">
<xsl:value-of select="//httpPassword" /></textarea>
								</td>
							</tr>
							<tr>
								<td></td>
								<td>
									HTTP Proxy Setting
								</td>
							</tr>
							<tr>
								<td></td>
								<td>
									Proxy:
									<input name='httpProxyServer' type='text' id="httpProxyServer2"
										value="{//@httpProxyServer}" size="31" />
									Port:
									<input name='httpProxyPort' type='text' id="httpProxyPort2"
										value="{//@httpProxyPort}" size="5" maxlength="6" />
								</td>
							</tr>
							<tr>
								<td></td>
								<td>
									<xsl:choose>
										<xsl:when test="string-length(//@httpProxyUsername)>0">
											<input type='radio' onClick="enableProxyUP(false)"
												name='enableProxyUsernamePassword' value='0' checked='1' />
											Use existing Username/Password
											<br />
											<input type='radio' onClick="enableProxyUP(true)"
												name='enableProxyUsernamePassword' value='1' />
											New Username:
											<input id='httpProxyUsername' name='httpProxyUsername'
												type='text' value="{//@httpProxyUsername}" size="12"
												disabled='true' />
											Password:
											<input id='httpProxyPassword' name='httpProxyPassword'
												type='password' value="" size="12" disabled='true' />
										</xsl:when>
										<xsl:otherwise>
											Username:
											<input id='httpProxyUsername' name='httpProxyUsername'
												type='text' value="" size="12" />
											Password:
											<input id='httpProxyPassword' name='httpProxyPassword'
												type='password' value="" size="12" />
											<input name="enableProxyUsernamePassword" type="hidden"
												value="1" />
										</xsl:otherwise>
									</xsl:choose>
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td>
						<br />
					</td>
				</tr>
				<tr>
					<td colspan="3" align="left">
						<strong>Additional Setting</strong>
					</td>
				</tr>
				<tr>
					<td style="border: 1px solid #FFFFFF;">
						<table width="100%" border="0">
							<tr>
								<td>
									<strong>Post-Load Task</strong>
								</td>
							</tr>
                            <tr>
                                <td style="padding-left: 50px;">
                                    Change program title case to
                                    <select name='postScanChangeTitleCase'>
                                        <option value=''></option>
                                        <option value='unchanged'>
                                            <xsl:if test="//@postScanChangeTitleCase='unchanged'">
                                                <xsl:attribute name="selected" />
                                            </xsl:if>
                                            (No Change)
                                        </option>
                                        <option value='lower'>
                                            <xsl:if test="//@postScanChangeTitleCase='lower'">
                                                <xsl:attribute name="selected" />
                                            </xsl:if>
                                            lower case
                                        </option>
                                        <option value='title'>
                                            <xsl:if test="//@postScanChangeTitleCase='title'">
                                                <xsl:attribute name="selected" />
                                            </xsl:if>
                                            Title Case
                                        </option>
                                        <option value='upper'>
                                            <xsl:if test="//@postScanChangeTitleCase='upper'">
                                                <xsl:attribute name="selected" />
                                            </xsl:if>
                                            UPPER CASE
                                        </option>
                                    </select>
                                </td>
                            </tr>
                            <tr>
                                <td style="padding-left: 50px;">
                                    Multi-Language EPG
                                </td>
                            </tr>
                            <tr>
                                <td style="padding-left: 50px;">
                                    Language Priority:
                                    <input name='languagePriority' type='text' id="languagePriority"
                                        value="{//@languagePriority}" size="31" />
                                    Max Languages saved:
                                    <input name='maxLanguage' type='text' id="maxLanguage"
                                        value="{//@maxLanguage}" size="5" maxlength="6" />
                                </td>
                            </tr>
                            <tr>
                                <td style="padding-left: 50px;">Enter 2-letters ISO 639 language code separated by commas. E.g. en,de,es</td>
                            </tr>
						</table>
					</td>
				</tr>
				<tr>
					<td>
						<br />
					</td>
				</tr>
				<tr>
					<td colspan="3" align="left" id="builtInSetting">
						<strong>Built-in EPG Scanner Advance Setting</strong>
					</td>
				</tr>
				<tr>
					<td style="border: 1px solid #FFFFFF;">
						<table width="100%" border="0">
							<tr>
								<td>
									<strong>Post-Load Task</strong>
								</td>
							</tr>
                            <tr>
                                <td style="padding-left: 50px;">
                                    <select name='Tasks.PostInternalScanTask'>
                                        <option value='*UNDEFINED*'>(Please select one):</option>
                                        <xsl:apply-templates select="//allTasks/item"
                                            mode="postInternalScan" />
                                    </select>
                                </td>
                            </tr>
							<tr>
								<td style="padding-left: 50px;">
									Scan for Favorite
									<input name="postInternalScanAutoMarkEnabled" type="checkbox"
										value="1">
										<xsl:if test="//@postInternalScanAutoMarkEnabled='1'">
											<xsl:attribute name="checked" />
										</xsl:if>
									</input>
								</td>
							</tr>
							<tr>
								<td style="padding-left: 50px;">
									Run Auto-Add Scan
									<input name="postInternalScanAutoAddEnabled" type="checkbox"
										value="1">
										<xsl:if test="//@postInternalScanAutoAddEnabled='1'">
											<xsl:attribute name="checked" />
										</xsl:if>
									</input>
								</td>
							</tr>
							<tr>
								<td>
									<strong>Schedule Data Load</strong>
								</td>
							</tr>
							<tr>
								<td style="padding-left: 50px;">
									Enable
									<input name="scheduleInternalEnabled" type="checkbox"
										value="1">
										<xsl:if test="//@scheduleInternalEnabled='1'">
											<xsl:attribute name="checked" />
										</xsl:if>
									</input>
									Schedule scan when a demodulator's EPG is older than 
									<input name="scheduleInternalPeriod" type="text" value="{//@scheduleInternalPeriod}"
										size="2" />
									hours
								</td>
							</tr>
                            <tr>
                                <td style="padding-left: 50px;">
                                    The following demodulators are enabled for scheduling:
                                    <table cellspacing="6" cellpadding="6">
                                        <tr>
                                            <td>
                                                Available Demodulators
                                                <br />
                                                <select name='chanAll' type='test' id="chanAll"
                                                    multiple="True" size='16' style="width:250px">
                                                    <xsl:apply-templates select="//allDemodulators/item" />
                                                </select>
                                                <br />
                                                <font size='-1'>
                                                    (Hold down CTRL to select
                                                    <br />
                                                    multiple items)
                                                </font>
                                            </td>
                                            <td align="center">
                                                <button type="button" onclick="listItemsAdd();"
                                                    style="width:50px">-&gt;</button>
                                                <br />
                                                <br />
                                                <button type="button" onclick="listItemsRemove();"
                                                    style="width:50px">&lt;-</button>
                                                <br />
                                                <br />
                                                <br />
                                            </td>
                                            <td>
                                                Enabled Demodulators
                                                <br />
                                                <select name='chanSelected' type='test' id="chanSelected"
                                                    multiple="True" size='16' style="width:250px">
                                                    <xsl:apply-templates select="//selectedDemodulators/item" />
                                                </select>
                                                <br />
                                                <font size='-1'>
                                                    (Hold down CTRL to select
                                                    <br />
                                                    multiple items)
                                                </font>
                                            </td>
                                        </tr>
                                    </table>
                                </td>
                            </tr>
						</table>
					</td>
				</tr>
                <tr>
                    <td>
                        <br />
                    </td>
                </tr>
                <tr>
                    <td colspan="3" align="left">
                        <strong>File Source and HTTP Web Source Additional Setting</strong>
                    </td>
                </tr>
                <tr>
                    <td style="border: 1px solid #FFFFFF;">
                        <table width="100%" border="0">
                            <tr>
                                <td>
                                    <strong>Pre-Load Task</strong>
                                </td>
                            </tr>
                            <tr>
                                <td style="padding-left: 50px;">
                                    <select name='Tasks.PreEPGloadTask'>
                                        <option value='*UNDEFINED*'>(Please select one):</option>
                                        <xsl:apply-templates select="//allTasks/item" />
                                    </select>
                                    &#160; &#160;Run Pre-Load Task on
                                    <select name='preActionRun'>
                                        <option value=''></option>
                                        <option value='All'>
                                            <xsl:if test="//@preActionRun='All'">
                                                <xsl:attribute name="selected" />
                                            </xsl:if>
                                            All
                                        </option>
                                        <option value='Scheduled Data Load'>
                                            <xsl:if test="//@preActionRun='Scheduled Data Load'">
                                                <xsl:attribute name="selected" />
                                            </xsl:if>
                                            Scheduled Data Load
                                        </option>
                                        <option value='Manual Data Load'>
                                            <xsl:if test="//@preActionRun='Manual Data Load'">
                                                <xsl:attribute name="selected" />
                                            </xsl:if>
                                            Manual Data Load
                                        </option>
                                    </select>
                                </td>
                            </tr>
                            <tr>
                                <td>
                                    <strong>Post-Load Task</strong>
                                </td>
                            </tr>
                            <tr>
                                <td style="padding-left: 50px;">
                                    <select name='Tasks.PostEPGloadTask'>
                                        <option value='*UNDEFINED*'>(Please select one):</option>
                                        <xsl:apply-templates select="//allTasks/item"
                                            mode="post" />
                                    </select>
                                    &#160; &#160;Run Post-Load Task on
                                    <select name='postActionRun'>
                                        <option value=''></option>
                                        <option value='All'>
                                            <xsl:if test="//@postActionRun='All'">
                                                <xsl:attribute name="selected" />
                                            </xsl:if>
                                            All
                                        </option>
                                        <option value='Scheduled Data Load'>
                                            <xsl:if test="//@postActionRun='Scheduled Data Load'">
                                                <xsl:attribute name="selected" />
                                            </xsl:if>
                                            Scheduled Data Load
                                        </option>
                                        <option value='Manual Data Load'>
                                            <xsl:if test="//@postActionRun='Manual Data Load'">
                                                <xsl:attribute name="selected" />
                                            </xsl:if>
                                            Manual Data Load
                                        </option>
                                    </select>
                                </td>
                            </tr>
                            <tr>
                                <td style="padding-left: 50px;">
                                    Scan for Favorite
                                    <input name="postScanAutoMarkEnabled" type="checkbox"
                                        value="1">
                                        <xsl:if test="//@postScanAutoMarkEnabled='1'">
                                            <xsl:attribute name="checked" />
                                        </xsl:if>
                                    </input>
                                    on
                                    <select name='postScanAutoMarkRun'>
                                        <option value=''></option>
                                        <option value='All'>
                                            <xsl:if test="//@postScanAutoMarkRun='All'">
                                                <xsl:attribute name="selected" />
                                            </xsl:if>
                                            All
                                        </option>
                                        <option value='Scheduled Data Load'>
                                            <xsl:if test="//@postScanAutoMarkRun='Scheduled Data Load'">
                                                <xsl:attribute name="selected" />
                                            </xsl:if>
                                            Scheduled Data Load
                                        </option>
                                        <option value='Manual Data Load'>
                                            <xsl:if test="//@postScanAutoMarkRun='Manual Data Load'">
                                                <xsl:attribute name="selected" />
                                            </xsl:if>
                                            Manual Data Load
                                        </option>
                                    </select>
                                </td>
                            </tr>
                            <tr>
                                <td style="padding-left: 50px;">
                                    Run Auto-Add Scan
                                    <input name="postScanAutoAddEnabled" type="checkbox"
                                        value="1">
                                        <xsl:if test="//@postScanAutoAddEnabled='1'">
                                            <xsl:attribute name="checked" />
                                        </xsl:if>
                                    </input>
                                    on
                                    <select name='postScanAutoAddRun'>
                                        <option value=''></option>
                                        <option value='All'>
                                            <xsl:if test="//@postScanAutoAddRun='All'">
                                                <xsl:attribute name="selected" />
                                            </xsl:if>
                                            All
                                        </option>
                                        <option value='Scheduled Data Load'>
                                            <xsl:if test="//@postScanAutoAddRun='Scheduled Data Load'">
                                                <xsl:attribute name="selected" />
                                            </xsl:if>
                                            Scheduled Data Load
                                        </option>
                                        <option value='Manual Data Load'>
                                            <xsl:if test="//@postScanAutoAddRun='Manual Data Load'">
                                                <xsl:attribute name="selected" />
                                            </xsl:if>
                                            Manual Data Load
                                        </option>
                                    </select>
                                </td>
                            </tr>
                            <tr>
                                <td>
                                    <strong>Schedule Data Load</strong>
                                </td>
                            </tr>
                            <tr>
                                <td style="padding-left: 50px;">
                                    Enable
                                    <input name="scheduleImportEnabled" type="checkbox"
                                        value="1">
                                        <xsl:if test="//@scheduleImportEnabled='1'">
                                            <xsl:attribute name="checked" />
                                        </xsl:if>
                                    </input>
                                    Start at
                                    <input name="scheduleHour" type="text" value="{//@scheduleHour}"
                                        size="2" maxlength="2" />
                                    :
                                    <input name="scheduleMin" type="text" value="{//@scheduleMin}"
                                        size="2" maxlength="2" />
                                    or
                                    <input name="scheduleMinuteAfterLaunch" type="text"
                                        value="{//@scheduleMinuteAfterLaunch}" size="3" />
                                    minutes after app started, then every
                                    <input name="schedulePeriod" type="text" value="{//@schedulePeriod}"
                                        size="2" />
                                    hours
                                </td>
                            </tr>
                            <tr>
                                <td style="padding-left: 50px;">
                                    Wake up system
                                    <input style="" type="checkbox" name="wakeSystem" value="1">
                                        <xsl:if test="//@wakeSystem='1'">
                                            <xsl:attribute name="checked" />
                                        </xsl:if>
                                    </input>
                                    <xsl:text> </xsl:text>
                                    <font size="-1">(wake to load, otherwise wait when system is
                                        on)</font>
                                </td>
                            </tr>
                            <tr>
                                <td style="padding-left: 50px;">
                                    When not capturing
                                    <input style="" type="checkbox" name="whenNotCapturing"
                                        value="1">
                                        <xsl:if test="//@whenNotCapturing='1'">
                                            <xsl:attribute name="checked" />
                                        </xsl:if>
                                    </input>
                                    <xsl:text> </xsl:text>
                                    <font size="-1">(wait for current schedules to finish before
                                        running)</font>
                                </td>
                            </tr>
                            <tr>
                                <td style="padding-left: 50px;">
                                    Don't run within
                                    <input style="width:30px" type="text" name="timeToNextSchedule"
                                        max-char="3" value="{//@timeToNextSchedule}" />
                                    minutes of a scheduled recording
                                </td>
                            </tr>
                        </table>
                    </td>
                </tr>
				<tr>
					<xsl:if test="//@checkId='0'">
						<xsl:attribute name="style">visibility:hidden</xsl:attribute>
					</xsl:if>
					<td colspan="3">
						<br />
						Security ID
						<input type="text" size="6" maxlength="6" name="sessionID"
							value="" />
						enter the number from the following image
						<img id='SecurityImage' align='absmiddle' src='/images/secure-blank.png' />
					</td>
				</tr>
				<tr>
					<td colspan="3" align="center">
						<input type="submit" name="Submit" value="Submit" />
						<input name="action" type="hidden" id="action" value="17" />
						<input type='hidden' name='chanMatch' id='chanMatch' />
					</td>
				</tr>
			</table>
		</form>
		<br />
		<br />
		<table>
			<tr>
				<td valign="top">
					<p>
						<strong>TV Guide Data Source Setup</strong>
					</p>
					<p> DV Scheduler has multiple ways of importing XMLTV guide data.</p>
					<ol>
						<li>
							Built-in EPG Scanner. Everytime a capture (or a preview or a
							channel surf) is started events are collected, and if the capture
							is long enough (a few minutes) the EPG will be updated.<br/>For
							rarely used channels "Schedule Data Load" can be enabled, this
							will schedule EPG collection for channels whose EPG data is older
							than the specified number of hours. Alternatively, you can add dummy <a class="under" href="/servlet/ScheduleDataRes">recording schedules</a> and set its type to "EPG Scan". <br/>See
							<a class="under" href="/servlet/EpgDataRes?action=02#epgAge">EPG Data Report</a>
							for age of each channel's EPG.<br/>To exclude certain channels from being shown on the EPG see 
							<a class="under" href="/servlet/ChannelDataRes?action=14">Channel Surf Order</a>.
						</li>
						<li>
							Import from local files. For example you can use
							<a class="under" href='http://sourceforge.net/projects/epgcollector/'>EPG Collector</a>
							or
							<a class="under" href='http://myweb.tiscali.co.uk/pclare/DVBGuide/'>DVBGuide</a>
							that will generate XMLTV files. Also see "DVSDVBGuideBatch.txt"
							in folder "data\xmltv" of where DV Scheduler is installed if
							you're using DVBGuide.
						</li>
						<li>Download and import from a Web Address.</li>
					</ol>

					<p>
						<strong>File Source</strong>
						<br />
						The file source just loads XMLTV data from the specified XML file.
						If a directory is specified then all files in the directory that
						has an extension of .xml will be loaded.
					</p>

					<p>
						E.g.
						<br />
						C:\xmltv\data
					</p>

					<p>If you have more than one file or directory you can enter them
						one directory per line.</p>

					<p>
						<strong>HTTP Web Source</strong>
						<br />
						This option is very much like the above option but instead of
						loading
						the data from the local hard drive it loads it from a Web
						Address.
					</p>

					<p>
						E.g.
						<br />
						http://www.xmldata.com/xmldata.xml
					</p>

					The files can be zipped and DV Scheduler will automatically unzip
					them.
					<p />

					<p>
						E.g.
						<br />
						http://www.xmldata.com/xmldata.zip
					</p>

					<p>If you have more than one address and/or files in your data set
						you can enter them one address per line, with the corresponding
						username and password (if any).</p>

					If you have the same address but more than one file in your data
					set you can also either zip all your data files
					and point DV
					Scheduler at the zip or create a "files.txt" file and
					make the first
					line
					&lt;XMLTV_FILE_LIST&gt; then each on a new line the names of
					the files that make up
					your data set, point DV Scheduler to this
					"files.txt" file and DV
					Scheduler
					will grab all the files in your
					files.txt list file. Any of these files
					can also be zipped
					and DV
					Scheduler will automatically unzip them.
					<p>
						E.g.
						<pre>
							&lt;XMLTV_FILE_LIST&gt;
							20050726.xml
							20050727.xml
						</pre>
					</p>

					<p>
						<strong>Proxy Settings</strong>
						<br />
						If you need to use a proxy to connect to the Web enter the proxy
						in the
						HTTP Proxy Settings option.
					</p>
					<p>
						<strong>Schedule Data Load</strong>
						<br />
						You can Schedule DV Scheduler to download and import data every
						set hours, check the enabled check box and enter the time. DV
						Scheduler can also wake up the system at the scheduled time;
						otherwise data load will occur when the system is next running.
					</p>

				</td>
			</tr>
		</table>
		<br />
		<br />
	</center>
</body>
  </html>
</xsl:template>

<xsl:template match="allTasks/item">
<option><xsl:if test="//@preEPGloadTask = @value"><xsl:attribute name="selected"/></xsl:if><xsl:attribute name="value"><xsl:value-of select="@value" /></xsl:attribute><xsl:value-of select="@name" /></option>
</xsl:template>

<xsl:template match="allTasks/item" mode="post">
<option><xsl:if test="//@postEPGloadTask = @value"><xsl:attribute name="selected"/></xsl:if><xsl:attribute name="value"><xsl:value-of select="@value" /></xsl:attribute><xsl:value-of select="@name" /></option>
</xsl:template>

<xsl:template match="allTasks/item" mode="postInternalScan">
<option><xsl:if test="//@postInternalScanTask = @value"><xsl:attribute name="selected"/></xsl:if><xsl:attribute name="value"><xsl:value-of select="@value" /></xsl:attribute><xsl:value-of select="@name" /></option>
</xsl:template>

<xsl:template match="allDemodulators/item">
<xsl:if test="not(@selected)"><option><xsl:attribute name="value"><xsl:value-of select="@value" /></xsl:attribute><xsl:value-of select="@name" /></option></xsl:if>
</xsl:template>

<xsl:template match="selectedDemodulators/item">
<option><xsl:attribute name="value"><xsl:value-of select="@value" /></xsl:attribute><xsl:value-of select="@name" /></option>
</xsl:template>

</xsl:stylesheet>
