<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

	<xsl:template match="/">
   
   <html>
   <head>
   <title>Timer Control</title>
   <link rel="stylesheet" type="text/css" href="/css/kb-epg.css"/>
   
   <xsl:apply-templates select="//navigation" />
   
   <script>
   var backTarget = "/servlet/ApplyTransformRes?xml=epg-index&amp;xsl=kb-buttons";
   </script>
   
   <script src="/javascript/kbepg.js"></script>
   
   
   </head>
   <body onload="Initialize();">
   
   <center><br/><br/>
   
   <table width="85%"  border="0" cellspacing="2" cellpadding="2">
     <tr>
     
       <td width='1px'>
       <img src='/images/epgControl.png' width='100' height='35' progName='Back' progAdd='/servlet/ApplyTransformRes?xml=epg-index&amp;xsl=kb-buttons' progTime='n/a' desc='Press select button to close or Left for Previous Page and Right for Next Page of program items' activeClass='epgControlImageSelected' normalClass='epgControlImage' class='epgControlImage' id='0-0'/>
       </td>
     
       <td>
       <center><span class='epgTitle'><xsl:apply-templates select="//@title" mode="cols" /></span></center>
       </td>
       
     </tr>
   </table>   
   <br/><br/>
   
   <table class='epgTable' width='85%' border='0' cellspacing='0' cellpadding='0' name='epgtable'>
      
   <tr>
   <th class='epgTimes' colspan='15'>&#160;</th>
   <xsl:apply-templates select="//time" mode="cols" />
   </tr>
   
   <xsl:apply-templates select="//channel" mode="rows" />
   
   <tr>
   <td class='epgTimes' colspan='13'>&#160;</td>
   <xsl:apply-templates select="//now_pointer" mode="cols" />
   </tr>
   
   </table>
   
   <p/><br/>
   <table width="85%"  border="0" cellspacing="2" cellpadding="2">
     <tr>
       <td id='item_Title' class='epg_item_title'>&#160;</td>
       <td id='item_Time' class='epg_item_time'>&#160;</td>
     </tr>
     <tr>
       <td id='item_Details' colspan='2' class='epg_item_details'>&#160;</td>
     </tr>
   </table>
   
   </center>
   
   </body>
   </html>   
   
	</xsl:template>

   
	<xsl:template match="time" mode="cols">
   
      <th class='epgTimes' colspan='30'>
      <xsl:value-of select="." />
      </th>

	</xsl:template>
	
	<xsl:template match="now_pointer" mode="cols">
   
      <td style="text-align: right; padding: 0px;">
      <xsl:attribute name="colspan"><xsl:value-of select="@min + 2" /></xsl:attribute>
      <img src="/images/pointer-left.gif" width='11' height='16' /></td>
      
      <td colspan="2" style="text-align: left; padding: 0px;">
      <img src="/images/pointer-right.gif" width='11' height='16' />
      </td>

	</xsl:template>	
	
   
   <xsl:template match="channel" mode="rows">
      <xsl:variable name="filter" select="display-name"/>
      <xsl:variable name="rowPosition" select="position() * 5"/>
      
      <tr>
      <td class='epgChannel' colspan='15'><xsl:value-of select="substring(display-name, 0, 7)" /></td>
      
         <xsl:apply-templates select="//programme[@channel=$filter]">
				<xsl:with-param name="rowPosition" select="$rowPosition" />
			</xsl:apply-templates>
				
	   </tr>
	        
	   <xsl:if test="count(//schedule[@channel=$filter and @overlapCount=0]) > 0">
   	   <tr>
   	   <td colspan='15'></td>
            <xsl:apply-templates select="//schedule[@channel=$filter and @overlapCount=0]">
            <xsl:with-param name="rowPosition" select="$rowPosition + 1" />
   			</xsl:apply-templates>	
         </tr>		
		</xsl:if>
		
		<xsl:if test="count(//schedule[@channel=$filter and @overlapCount=1]) > 0">
   	   <tr>
   	   <td colspan='15'></td>
            <xsl:apply-templates select="//schedule[@channel=$filter and @overlapCount=1]">
            <xsl:with-param name="rowPosition" select="$rowPosition + 2" />
   			</xsl:apply-templates>	
         </tr>							      
		</xsl:if>
		
		<xsl:if test="count(//schedule[@channel=$filter and @overlapCount=2]) > 0">
   	   <tr>
   	   <td colspan='15'></td>
            <xsl:apply-templates select="//schedule[@channel=$filter and @overlapCount=2]">
            <xsl:with-param name="rowPosition" select="$rowPosition + 3" />
   			</xsl:apply-templates>	
         </tr>							      
		</xsl:if>		
      
		<xsl:if test="count(//schedule[@channel=$filter and @overlapCount=3]) > 0">
   	   <tr>
   	   <td colspan='15'></td>
            <xsl:apply-templates select="//schedule[@channel=$filter and @overlapCount=3]">
            <xsl:with-param name="rowPosition" select="$rowPosition + 4" />
   			</xsl:apply-templates>	
         </tr>							      
		</xsl:if>
		
		      
	</xsl:template>
	
	
   <xsl:template match="programme">
   
      <xsl:param name="rowPosition"/>
   
      <td activeClass='epgProgramSelected' normalClass='epgProgram' class='epgProgram'>
      <xsl:attribute name="id"><xsl:value-of select="$rowPosition" />-<xsl:value-of select="position() - 1" /></xsl:attribute>

      <xsl:if test="length/@fits = 1">
         <xsl:attribute name="style">border-right: 6px solid #BBBBFF; border-left: 6px solid #BBBBFF;</xsl:attribute>
      </xsl:if>
      
      <xsl:if test="length/@fits = 2">
         <xsl:attribute name="style">border-left: 6px solid #BBBBFF;</xsl:attribute>
      </xsl:if>

      <xsl:if test="length/@fits = 3">
         <xsl:attribute name="style">border-right: 6px solid #BBBBFF;</xsl:attribute>
      </xsl:if>


      <xsl:variable name="maxSize" select="200" />
      <xsl:choose>
      <xsl:when test="string-length(desc) = 0">
         <xsl:attribute name="desc">&#160;</xsl:attribute>
      </xsl:when>      
      <xsl:when test="string-length(desc) &lt; $maxSize">
         <xsl:attribute name="desc"><xsl:value-of select="desc" /></xsl:attribute>
      </xsl:when>
      <xsl:otherwise>
          <xsl:attribute name="desc"><xsl:value-of select="substring(desc, 0, number($maxSize)-2)" />--></xsl:attribute>
      </xsl:otherwise>
      </xsl:choose>


      <xsl:attribute name="progName"><xsl:value-of select="title" /></xsl:attribute>
      <xsl:attribute name="progTime"><xsl:value-of select="substring(@start,9,2)" />:<xsl:value-of select="substring(@start,11,2)" /> (<xsl:value-of select="programLength" />)</xsl:attribute>
      <xsl:attribute name="progAdd"><xsl:value-of select="showDetails" /></xsl:attribute>
      <xsl:attribute name="colspan"><xsl:value-of select="length" /></xsl:attribute>
      <xsl:attribute name="title"><xsl:value-of select="title" /></xsl:attribute>
     
      <span class='solidText'><xsl:value-of select="title" /> </span>
      
      </td>

   </xsl:template>
	
   <xsl:template match="schedule">
   
      <xsl:param name="rowPosition"/>
   
      <xsl:if test="@prePadding > 0">
         <td class='epgClear'>
         <xsl:attribute name="colspan"><xsl:value-of select="@prePadding" /></xsl:attribute>
         </td>
      </xsl:if> 
   
      <td activeClass='epgScheduleSelected' normalClass='epgSchedule' class='epgSchedule'>

      <xsl:if test="@fits = 1">
         <xsl:attribute name="style">border-right: 6px solid #ff47f9; border-left: 6px solid #ff47f9;</xsl:attribute>
         
         <xsl:if test="itemState = 2">
            <xsl:attribute name="style">border-right: 6px solid #ff47f9; border-left: 6px solid #ff47f9;</xsl:attribute>
         </xsl:if>
      </xsl:if>

      <xsl:if test="@fits = 2">
         <xsl:attribute name="style">border-left: 6px solid #ff47f9;</xsl:attribute>
         
         <xsl:if test="itemState = 2">
            <xsl:attribute name="style">border-left: 6px solid #ff47f9;</xsl:attribute>
         </xsl:if>                  
      </xsl:if>

      <xsl:if test="@fits = 3">
         <xsl:attribute name="style">border-right: 6px solid #ff47f9;</xsl:attribute>
         
         <xsl:if test="itemState = 2">
            <xsl:attribute name="style">border-right: 6px solid #ff47f9;</xsl:attribute>
         </xsl:if>          
      </xsl:if>

      <xsl:if test="itemState = 2">
         <xsl:attribute name="class">epgScheduleRunning</xsl:attribute>
         <xsl:attribute name="normalClass">epgScheduleRunning</xsl:attribute>
         <xsl:attribute name="activeClass">epgScheduleRunningSelected</xsl:attribute>
      </xsl:if>

      <xsl:attribute name="id"><xsl:value-of select="$rowPosition" />-<xsl:value-of select="position() - 1" /></xsl:attribute>
            
      <xsl:attribute name="desc"><xsl:value-of select="@channel" /></xsl:attribute>
      
      <xsl:attribute name="progName"><xsl:value-of select="title" /></xsl:attribute>
      <xsl:attribute name="progTime"><xsl:value-of select="substring(@start,9,2)" />:<xsl:value-of select="substring(@start,11,2)" /> (<xsl:value-of select="@duration" />)</xsl:attribute>
      <xsl:attribute name="progAdd"><xsl:value-of select="progAdd" /></xsl:attribute>
      <xsl:attribute name="colspan"><xsl:value-of select="@span" /></xsl:attribute>
      <xsl:attribute name="title"><xsl:value-of select="title" /></xsl:attribute>
      <xsl:attribute name="progEdit"><xsl:value-of select="progEdit" /></xsl:attribute>
      

      <span class='solidText'>
         <xsl:value-of select="substring(@start,9,2)" />:<xsl:value-of select="substring(@start,11,2)" /> (<xsl:value-of select="@duration" />) <xsl:value-of select="itemStatus" />
      </span>
      
      </td>

   </xsl:template>	
	
	<xsl:template match="navigation">
	
	   <script>
      var prevURL = '<xsl:value-of select="previous" />';
      var nextURL = '<xsl:value-of select="next" />';
      var reqYear = '<xsl:value-of select="//@year" />';
      var reqMonth = '<xsl:value-of select="//@month" />';
      var reqDay = '<xsl:value-of select="//@day" />';
      var reqStart = '<xsl:value-of select="//@start" />';
      var reqShow = '<xsl:value-of select="//@show" />';
      var selected = '<xsl:value-of select="selected" />';
      </script>
      
   </xsl:template>  
	
	   
</xsl:stylesheet>

