<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:template match="/">
    <html>
    <head>
    <title>System Info</title>
    <link rel="stylesheet" href="/css/main.css" type="text/css"/>
<script src="/javascript/main.js"></script>
<xsl:comment>[if lt IE 7.0]&gt;
&lt;script src="/javascript/iepng.js"&gt;&lt;/script&gt;
&lt;![endif]</xsl:comment>
  </head>
<body>
<center>
<a href='/' class="noUnder"><img border="0" src="/images/logo.png" align="absmiddle" width="64" height="64"/><span class="pageTitle"> DV Scheduler</span></a><br/>
<br/>
<a href='/settings.html' class="noUnder"><img border='0' src='/images/back.png' align='absmiddle' width='24' height='24'/> 
<span class="areaTitle">System Index</span></a><br/><br/>
<table class='systemtable'><tr><td colspan='2' class='systemheading'>System Info</td></tr>
<tr><td class='systemkey'>HTTP Server Version</td><td class='systemdata'><xsl:value-of select="//@version"/></td></tr>
<tr><td class='systemkey'>Started</td><td class='systemdata'><xsl:value-of select="//@timeStartedStr"/></td></tr>
<tr><td class='systemkey'>Current Time</td><td class='systemdata'><xsl:value-of select="//@timeNowStr"/></td></tr>
<tr><td class='systemkey'>Up Time</td><td class='systemdata'><xsl:value-of select="//@upTimeStr"/></td></tr>
<tr><td class='systemkey'>Capture since started</td><td class='systemdata'><xsl:value-of select="//@sessionCapture"/></td></tr>
<tr><td class='systemkey'>Capture time since started</td><td class='systemdata'><xsl:value-of select="//@sessionCaptureTimeStr"/></td></tr>
<tr><td class='systemkey'>Total capture</td><td class='systemdata'><xsl:value-of select="//@totalCapture"/></td></tr>
<tr><td class='systemkey'>Total capture time</td><td class='systemdata'><xsl:value-of select="//@totalCaptureTimeStr"/></td></tr>
<tr><td class='systemkey'>Memory</td><td class='systemdata'><xsl:value-of select="//@freeMemoryPercent"/>% Free</td></tr>
<tr><td class='systemkey'>Channels Loaded</td><td class='systemdata'><xsl:value-of select="//@countChannel"/></td></tr>
<tr><td class='systemkey'>Groups Loaded</td><td class='systemdata'><xsl:value-of select="//@countGroup"/></td></tr>
<tr><td class='systemkey'>Users Loaded</td><td class='systemdata'><xsl:value-of select="//@countUser"/></td></tr>
<tr><td class='systemkey'>Trusted IPs Loaded</td><td class='systemdata'><xsl:value-of select="//@countTrustedIp"/></td></tr>
<tr><td class='systemkey'>Trusted IP Ranges Loaded</td><td class='systemdata'><xsl:value-of select="//@countTrustedIpRange"/></td></tr>
<tr><td class='systemkey'>Number of Devices Selected</td><td class='systemdata'><xsl:value-of select="//@countDevice"/></td></tr>
<tr><td class='systemkey'>Number of Devices Running</td><td class='systemdata'><xsl:value-of select="//@countDeviceRunning"/></td></tr>
<tr><td class='systemkey'>Httpd Path</td><td class='systemdata'><xsl:value-of select="//@pathHttpd"/></td></tr>
<tr><td class='systemkey'>Data Path</td><td class='systemdata'><xsl:value-of select="//@pathData"/></td></tr>
<tr><td class='systemkey'>User Data Path</td><td class='systemdata'><xsl:value-of select="//@pathUserData"/></td></tr>
<xsl:apply-templates select="//directories/directory" />    
</table>

<br/><br/>
<a class="noUnder" href="/servlet/SystemDataRes?action=11"><strong>Show Java Enviroment</strong></a>
<br/><br/>
<a class="noUnder" href="http://sydney.edu.au/engineering/it/~efax/DVScheduler.html"><strong>Go to DV Scheduler Download Page</strong></a>
</center>
</body>
  </html>
</xsl:template>

<xsl:template match="directories/directory">
<tr><td class='systemkey'><xsl:value-of select="position()"/>. Capture To</td><td class='systemdata'><xsl:value-of select="@name"/></td></tr>
<tr><td class='systemkey'><xsl:value-of select="position()"/>. Free Space</td><td class='systemdata'>
<xsl:choose>
  <xsl:when test="number(@freeSpace) > 0">
<xsl:value-of select="format-number(floor(number(@freeSpace) div (1024*1024)),'###,###')" /> MB
  </xsl:when>
  <xsl:otherwise>
Error Capture Drive May Not Exist
  </xsl:otherwise>
</xsl:choose>
</td></tr>
</xsl:template>

</xsl:stylesheet>
