/*
   Copyright (C) 2007-2010 contributors

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

 */

import java.io.*;
import java.util.Map;

import org.w3c.dom.*;
import javax.xml.parsers.*;

class ApplyTransformRes extends HTTPResponse
{

	public ApplyTransformRes(Map<String, String> headers, HTTPurl urlData, OutputStream outStream) throws Exception
	{
		super(headers, urlData, outStream);
	}

	public void getResponse() throws Exception
	{
		m_outStream.write(doTransform());
	}

	private byte[] doTransform() throws Exception
	{
		String xml = m_urlData.getParameter("xml");
		String xsl = m_urlData.getParameter("xsl");

		String httpDir = m_store.getProperty("path.httproot", "http");
		String themeDir = m_store.getThemeDirectory(m_headers.get("User-Agent"));
		String path = httpDir + File.separator + "themes" + File.separator + themeDir + File.separator + "xml" + File.separator + xml + ".xml";

		xsl = xsl + ".xsl";

		DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
		DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();

		File xmlSource = new File(path);
		if(xmlSource.exists() == false)
		{
			path = httpDir + File.separator + "xml" + File.separator + xml + ".xml";
			xmlSource = new File(path);
			if(xmlSource.exists() == false)
				throw new Exception("Source XML file (" + path + ") not found");
		}

		Document doc = docBuilder.parse(xmlSource);

		//
		// Do transform and return data
		//
		XSL transformer = new XSL(doc, xsl, m_headers, m_urlData);

		//if(mark != null && mark.equalsIgnoreCase("yes"))
		transformer.addCookie("backURL", m_urlData.getRequestString());

		return transformer.transform();
	}
}
