import java.text.*;
import java.util.*;

class DateFormatter2
{
	SimpleDateFormat m_dateTimeFormatter = null;
	SimpleDateFormat m_timeFormatter = null;
	SimpleDateFormat m_hourFormatter = null;
	SimpleDateFormat m_dateHourFormatter = null;
	SimpleDateFormat m_dateMonthFormatter = null;
	SimpleDateFormat m_dayWeekFormatter = null;

	public DateFormatter2()
	{
		DataStore store = DataStore.getInstance();
		String timeFormat = store.getProperty("format.time", "24");

		if (timeFormat.equals("12"))
		{
			m_dateTimeFormatter = new SimpleDateFormat("h:mm a MMMMM d yyyy");
			m_timeFormatter = new SimpleDateFormat("h:mm a");
			m_hourFormatter = new SimpleDateFormat("h a");
			m_dateHourFormatter = new SimpleDateFormat("h a d");
			m_dateMonthFormatter = new SimpleDateFormat("d MMM");
			m_dayWeekFormatter = new SimpleDateFormat("EEE");
		}
		else
		{
			m_dateTimeFormatter = new SimpleDateFormat("HH:mm MMMMM d yyyy");
			m_timeFormatter = new SimpleDateFormat("HH:mm");
			m_hourFormatter = new SimpleDateFormat("HH");
			m_dateHourFormatter = new SimpleDateFormat("HH d");
			m_dateMonthFormatter = new SimpleDateFormat("d MMM");
			m_dayWeekFormatter = new SimpleDateFormat("EEE");
		}
	}

	public String formatDateTime(Date time)
	{
		return m_dateTimeFormatter.format(time);
	}

	public String formatTime(Date time)
	{
		return m_timeFormatter.format(time);
	}

	public String formatHour(Date time)
	{
		return m_hourFormatter.format(time);
	}

	public String formatDateHour(Date time)
	{
		return m_dateHourFormatter.format(time);
	}

	public String formatDateMonth(Date time)
	{
		return m_dateMonthFormatter.format(time);
	}

	public String formatDayWeek(Date time)
	{
		return m_dayWeekFormatter.format(time);
	}
}