/*
   Copyright (C) 2007-2010 contributors

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

 */

import java.io.*;
import java.util.*;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.DOMImplementation;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

class EpgAutoAddDataRes extends HTTPResponse {
	public EpgAutoAddDataRes(Map<String, String> headers, HTTPurl urlData,
			OutputStream outStream) throws Exception {
		super(headers, urlData, outStream);
	}

	public void getResponse() throws Exception {
		String action = m_urlData.getParameter("action");
		if ("02".equals(action)) {
			m_outStream.write(deleteAutoAddItem());
			return;
		} else if ("03".equals(action)) {
			m_outStream.write(xmlAutoEpgAddForm());
			return;
		} else if ("04".equals(action)) {
			m_outStream.write(addAutoAddItem());
			return;
		} else if ("05".equals(action)) {
			m_outStream.write(showMatchList());
			return;
		} else if ("06".equals(action)) {
			m_outStream.write(addMatchList());
			return;
		} else if ("07".equals(action)) {
			m_outStream.write(deleteMatchList());
			return;
		} else if ("08".equals(action)) {
			m_outStream.write(editMatchList());
			return;
		} else if ("09".equals(action)) {
			m_outStream.write(renameMatchList());
			return;
		} else if ("10".equals(action)) {
			m_outStream.write(addTextMatch());
			return;
		} else if ("11".equals(action)) {
			m_outStream.write(addSpanMatch());
			return;
		} else if ("12".equals(action)) {
			m_outStream.write(addDayMatch());
			return;
		} else if ("13".equals(action)) {
			m_outStream.write(deleteMatchItem());
			return;
		} else if ("14".equals(action)) {
			m_outStream.write(createAutoAddFromItem());
			return;
		} else if ("15".equals(action)) {
			m_outStream.write(rescanXMLTVdata());
			return;
		} else if ("16".equals(action)) {
			m_outStream.write(addMatchListToMatcher());
			return;
		} else if ("17".equals(action)) {
			m_outStream.write(delMatchListToMatcher());
			return;
		} else if ("18".equals(action)) {
			m_outStream.write(exportMatchListList());
			return;
		} else if ("19".equals(action)) {
			m_outStream.write(textInserterPage());
			return;
		} else if ("20".equals(action)) {
			m_outStream.write(action20());
			return;
		} else if ("23".equals(action)) {
			m_outStream.write(moveAutoAddItem());
			return;
		} else if ("25".equals(action)) {
			m_outStream.write(showConflicts());
			return;
		} else if ("26".equals(action)) {
			m_outStream.write(exportAutoEpgList());
			return;
		} else if ("27".equals(action)) {
			m_outStream.write(enableEpgAutoAdd());
			return;
		} else if ("28".equals(action)) {
			m_outStream.write(reMarkXMLTVdata());
			return;
		} else if ("29".equals(action)) {
			m_outStream.write(addOtherMatch());
			return;
		} else if ("30".equals(action)) {
			m_outStream.write(addDurationMatch());
			return;
		} else if ("31".equals(action)) {
			m_outStream.write(updateTitleFilter());
			return;
		} else if ("32".equals(action)) {
			m_outStream.write(moveSelectedEpgAutoAdds());
			return;
		} else if ("33".equals(action)) {
			m_outStream.write(deleteAllEpgAutoAdds());
			return;
		} else if ("34".equals(action)) {
			m_outStream.write(EnableDisableEpgAutoAdds());
			return;
		} else {
			m_outStream.write(xmlEpgAutoAdds());
			return;
		}
	}

	private byte[] action20() throws Exception {
		int id = -1;
		try {
			id = Integer.parseInt(m_urlData.getParameter("id"));
		} catch (Exception e) {
		}

		int toIndex = -1;
		try {
			toIndex = Integer.parseInt(m_urlData.getParameter("move"));
		} catch (Exception e) {
		}

		Vector<EpgMatch> mList = m_store.getEpgAutoAdds();

		if (id > -1 && toIndex > -1 && toIndex < mList.size()) {
			EpgMatch obj = (EpgMatch) mList.remove(id);
			if (obj != null) {
				mList.add(toIndex, obj);
				m_store.saveEpgAutoList(null);
			}
		}

		StringBuffer buff = new StringBuffer();
		buff.append("HTTP/1.0 302 Moved Temporarily\n");
		buff.append("Location: /servlet/" + m_urlData.getServletClass()
				+ "?action=01\n\n");
		return buff.toString().getBytes("UTF-8");
	}

	private byte[] textInserterPage() throws Exception {
		StringBuffer buff = new StringBuffer();

		PageTemplate template = new PageTemplate(m_headers, m_urlData,
				"epg-textInsert.html");

		GuideStore guide = GuideStore.getInstance();

		HashMap<String, Channel> channels = m_store.getChannels();
		String[] keys = (String[]) channels.keySet().toArray(new String[0]);
		for (int x = 0; x < keys.length; x++) {
			buff.append("<a href='#' onClick=\"addText('"
					+ Formatter.encodeURL_UTF8E(keys[x]) + "');\">" + keys[x]
							+ "</a>");
			if (x < keys.length - 1)
				buff.append(", ");
		}
		if (buff.length() == 0)
			buff.append("none");
		template.replace("$channels", buff.toString());

		buff = new StringBuffer();
		String[] cats = guide.getCategoryStrings();
		for (int x = 0; x < cats.length; x++) {
			buff.append("<a href='#' onClick=\"addText('"
					+ Formatter.encodeURL_UTF8E(cats[x]) + "');\">" + cats[x]
							+ "</a>");
			if (x < cats.length - 1)
				buff.append(", ");
		}
		if (buff.length() == 0)
			buff.append("none");
		template.replace("$categories", buff.toString());

		SortedSet<String> progNames = new TreeSet<String>();
		guide.getProgramNames(progNames);
		String[] names = (String[]) progNames.toArray(new String[0]);
		buff = new StringBuffer();
		for (int x = 0; x < names.length; x++) {
			String htmlText = HTMLEncoder.encode(names[x]);

			buff.append("<a href='#' onClick=\"addText('"
					+ Formatter.encodeURL(names[x], "UTF-8") + "');\">"
					+ htmlText + "</a>");
			if (x < names.length - 1)
				buff.append(", \n");
		}
		if (buff.length() == 0)
			buff.append("none");
		template.replace("$programs", buff.toString());

		return template.getPageBytes();
	}

	private byte[] delMatchListToMatcher() throws Exception {
		String name = m_urlData.getParameter("name");

		int index = -1;
		try {
			index = Integer.parseInt(m_urlData.getParameter("index"));
		} catch (Exception e) {
		}

		if (name != null && name.length() > 0 && index > -1) {
			EpgMatch matcher = (EpgMatch) (m_store.getEpgAutoAdds().get(index));
			if (matcher != null) {
				matcher.removeMatchListName(name);
				m_store.saveEpgAutoList(null);
			}
		}

		return getRedirUrlRedir(null).getBytes("UTF-8");
	}

	private byte[] addMatchListToMatcher() throws Exception {
		String name = m_urlData.getParameter("name");

		int index = -1;
		try {
			index = Integer.parseInt(m_urlData.getParameter("index"));
		} catch (Exception e) {
		}

		if (index > -1 && name != null) {
			EpgMatch matcher = (EpgMatch) (m_store.getEpgAutoAdds().get(index));
			if (matcher != null) {
				matcher.addMatchListName(name);
				m_store.saveEpgAutoList(null);
			}
		}

		return getRedirUrlRedir(null).getBytes("UTF-8");
	}

	private byte[] rescanXMLTVdata() throws Exception {
		StringBuffer buff = new StringBuffer();
		m_store.rescanXMLTVdata(buff);

		PageTemplate template = new PageTemplate(m_headers, m_urlData,
				"epg-rescan.html");
		template.replace("$result", buff.toString());

		return template.getPageBytes();
	}

	private byte[] reMarkXMLTVdata() throws Exception {
		StringBuffer buff = new StringBuffer();
		m_store.reMarkXMLTVdata(buff);

		PageTemplate template = new PageTemplate(m_headers, m_urlData,
				"epg-rescan.html");
		template.replace("$result", buff.toString());

		return template.getPageBytes();
	}

	private byte[] showConflicts() throws Exception {
		GuideStore guide = GuideStore.getInstance();

		Vector<AddConflictDetails> conflicts = guide.getAutoAddConflicts();

		StringBuffer buff = new StringBuffer();

		buff.append("<table border='0' cellspacing='5' cellpadding='5'>");

		buff.append("<tr>\n");
		buff
		.append("<td nowrap class='itemheading'><strong>Name</strong></td>\n");
		buff
		.append("<td nowrap class='itemheading'><strong>Reason</strong></td>\n");
		buff
		.append("<td nowrap class='itemheading'><strong>Conflicts</strong></td>\n");
		buff.append("</tr>\n");

		AddConflictDetails conf = null;

		for (int x = 0; x < conflicts.size(); x++) {
			conf = (AddConflictDetails) conflicts.get(x);

			buff.append("<tr>\n");

			buff.append("<td nowrap valign='top'>" + conf.getName() + "</td>");
			buff
			.append("<td nowrap valign='top'>" + conf.getReason()
					+ "</td>");
			buff.append("<td nowrap valign='top'>" + conf.getConflict()
					+ "</td>");

			buff.append("</tr>\n");
		}

		buff.append("</table>");

		PageTemplate template = new PageTemplate(m_headers, m_urlData,
				"epg-conflicts.html", true);
		template.replace("$title", "EPG Auto-Add conflicts from last run");
		template.replace("$list", buff.toString());

		return template.getPageBytes();
	}

	private byte[] addAutoAddItem() throws Exception {
		if (m_urlData.getParameter("submit", "Submit").equals("Add"))
			return addMatchListToMatcher();

		String alias = m_urlData.getParameter("alias", "").trim();
		String oldAlias = m_urlData.getParameter("oldAlias", "").trim();

		String ad = m_urlData.getParameter("autoDel");
		boolean autoDel = false;
		if (ad != null && ad.equalsIgnoreCase("true"))
			autoDel = true;

		int keepFor = 30;
		try {
			keepFor = Integer.parseInt(m_urlData.getParameter("keepFor"));
		} catch (Exception e) {
		}

		int startBuffer = 0;
		int endBuffer = 0;
		int epgBuffer = 0;
		try {
			startBuffer = Integer.parseInt(m_urlData
					.getParameter("startbuffer"));
			endBuffer = Integer.parseInt(m_urlData.getParameter("endbuffer"));
			epgBuffer = Integer.parseInt(m_urlData.getParameter("epgbuffer"));
		} catch (Exception e) {
		}

		// make sure post task exists
		HashMap<?, ?> tasks = m_store.getTaskList();
		String postTask = m_urlData.getParameter("task");
		if (postTask == null || postTask.equalsIgnoreCase("none")
				|| !tasks.containsKey(postTask))
			postTask = "";

		String capturePath = m_urlData.getParameter("capturePath");
		String[] paths = DVScheduler.getArray(m_store.getProperty(
				"Capture.path", "capture"));
		if (capturePath == null)
			capturePath = paths[0];
		else if (!capturePath.equals("*")) {
			boolean bFound = false;
			for (int x = 0; x < paths.length; x++) {
				if (paths[x].equals(capturePath)) {
					bFound = true;
					break;
				}
			}
			if (!bFound)
				capturePath = "*";
		}

		// check name pattern exists
		String namePattern = m_urlData.getParameter("namePattern");
		String[] namePatterns = m_store.getNamePatterns();
		boolean found = false;
		for (int x = 0; x < namePatterns.length; x++) {
			if (namePatterns[x].equals(namePattern)) {
				found = true;
				break;
			}
		}
		if (!found) {
			namePattern = namePatterns[0];
		}

		String capType = "";
		try {
			capType = m_urlData.getParameter("capturetype");
		} catch (Exception e) {
		}

		String mergeDoubleEpisodes = m_urlData
				.getParameter("mergeDoubleEpisodes");
		boolean bMergeDoubleEpisodes = false;
		if (mergeDoubleEpisodes != null
				&& mergeDoubleEpisodes.equalsIgnoreCase("true"))
			bMergeDoubleEpisodes = true;

		String duplicateDetection = m_urlData
				.getParameter("duplicateDetection");
		boolean bDuplicateDetection = false;
		if (duplicateDetection != null
				&& duplicateDetection.equalsIgnoreCase("true"))
			bDuplicateDetection = true;

		EpgMatch epgMatch = null;

		int index = -1;
		try {
			index = Integer.parseInt(m_urlData.getParameter("index"));

		} catch (Exception e) {
		}

		if (index > -1) {
			epgMatch = (EpgMatch) m_store.getEpgAutoAdds().get(index);
		} else {
			epgMatch = new EpgMatch();
			m_store.addEpgMatch(epgMatch, 0);

			String matchList = m_urlData.getParameter("name");
			// only if new add initial match list
			if (matchList != null && matchList.length() > 0) {
				epgMatch.getMatchListNames().add(matchList);
			}
		}

		epgMatch.setName( (alias.equals(oldAlias)) ? alias : m_store.getEpgAutoAddUniqueName(alias) );
		epgMatch.setKeepFor(keepFor);
		epgMatch.setAutoDelete(autoDel);
		epgMatch.setStartBuffer(startBuffer);
		epgMatch.setEndBuffer(endBuffer);
		epgMatch.setEPGBuffer(epgBuffer);
		epgMatch.setPostTask(postTask);
		epgMatch.setCapturePath(capturePath);
		epgMatch.setFileNamePattern(namePattern);
		epgMatch.setCaptureType(capType);
		epgMatch.setDuplicateDetection(bDuplicateDetection);
		epgMatch.setMergeDoubleEpisode(bMergeDoubleEpisodes);

		m_store.saveEpgAutoList(null);

		return getRedirUrlRedir(null).getBytes("UTF-8");
	}

	private byte[] moveAutoAddItem() throws Exception {
		int id = -1;
		try {
			id = Integer.parseInt(m_urlData.getParameter("id"));
		} catch (Exception e) {
		}

		int dir = 1;
		try {
			dir = Integer.parseInt(m_urlData.getParameter("dir"));
		} catch (Exception e) {
		}

		boolean direction = false;
		if (dir == 1)
			direction = true;

		if (id != -1)
			m_store.moveEpgItem(id, direction);

		StringBuffer buff = new StringBuffer();
		buff.append("HTTP/1.0 302 Moved Temporarily\n");
		buff.append("Location: /servlet/" + m_urlData.getServletClass()
				+ "?action=01\n\n");

		return buff.toString().getBytes("UTF-8");

	}

	private byte[] xmlAutoEpgAddForm() throws Exception {
		// Creation of an XML document
		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		DocumentBuilder db = dbf.newDocumentBuilder();
		DOMImplementation di = db.getDOMImplementation();
		Document doc = di.createDocument("", "EpgAutoAddForm", null);
		Element root = doc.getDocumentElement();
		int indexOf = m_urlData.getParameterInt("index", -1);
		root.setAttribute("index", Integer.toString(indexOf));
		root.setAttribute("dari", getRedirUrl(null));

		Vector<EpgMatch> list = m_store.getEpgAutoAdds();
		EpgMatch epgMatcher = null;

		if (indexOf > -1 && indexOf < list.size()) {
			epgMatcher = (EpgMatch) list.get(indexOf);
		}

		if (epgMatcher == null)
			epgMatcher = new EpgMatch();

		epgMatcher.getXML(doc, root);

		Element elm = doc.createElement("allEpgMatches");
		m_store.getEpgMatchesXml(doc, elm);
		root.appendChild(elm);

		elm = doc.createElement("allCaptureTypes");
		m_store.getCaptureTypesXml(doc, elm);
		root.appendChild(elm);

		elm = doc.createElement("allCapturePaths");
		m_store.getCapturePathsXml(doc, elm);
		root.appendChild(elm);

		elm = doc.createElement("allNamePatterns");
		m_store.getNamePatternsXml(doc, elm);
		root.appendChild(elm);

		elm = doc.createElement("allTasks");
		m_store.getTaskListXml(doc, elm);
		root.appendChild(elm);

		//
		// Do transform and return data
		//
		XSL transformer = new XSL(doc, "epg-auto-add-form.xsl", m_headers,
				m_urlData);

		return transformer.transform();
	}

	private byte[] deleteAutoAddItem() throws Exception {
		StringBuffer buff = new StringBuffer();
		String idString = m_urlData.getParameter("id");

		int id = -1;

		if (idString != null) {
			try {
				id = Integer.parseInt(idString);
			} catch (Exception e) {
			}
		}

		int nDeleteEpgMatches = m_urlData.getParameterInt("all", -1);

		if (id > -1) {
			EpgMatch item = (EpgMatch) m_store.getEpgAutoAdds().get(id);

			if (item != null) {
				if (nDeleteEpgMatches == 0) {
					m_store.removeEpgMatch(id);
				} else if (nDeleteEpgMatches == 1) {
					String[] unUsed = noSharedMatchLists(item);

					m_store.removeEpgMatch(id);

					for (int x = 0; x < unUsed.length; x++) {
						m_store.getEpgMatches().remove(unUsed[x]);
					}
					m_store.saveEpgMatches(null);
				} else {
					Vector<Integer> sel = new Vector<Integer>();
					sel.add(id);
					return xmlConfirmDeleteAutoAdds(sel);
				}
			}
		}

		buff.append("HTTP/1.0 302 Moved Temporarily\n");
		buff.append("Location: /servlet/" + m_urlData.getServletClass()
				+ "?action=01\n\n");

		return buff.toString().getBytes("UTF-8");
	}

	private String[] noSharedMatchLists(EpgMatch item) {
		Vector<String> unUsed = new Vector<String>();
		EpgMatch[] items = (EpgMatch[]) m_store.getEpgAutoAdds().toArray(
				new EpgMatch[0]);

		for (int x = 0; x < item.getMatchListNames().size(); x++) {
			boolean used = false;
			String name = (String) item.getMatchListNames().get(x);

			for (int y = 0; y < items.length; y++) {
				if (item != items[y]
						&& items[y].getMatchListNames().contains(name))
					used = true;
			}

			if (used == false)
				unUsed.add(name);
		}

		return (String[]) unUsed.toArray(new String[0]);
	}

	private byte[] exportMatchListList() throws Exception {
		StringBuffer buff = new StringBuffer();

		buff.append("HTTP/1.0 200 OK\nContent-Type: text/xml\n");
		buff
		.append("Content-Disposition: attachment; filename=\"MatchList.xml\"\n");
		buff.append("Pragma: no-cache\n");
		buff.append("Cache-Control: no-cache\n");
		buff.append("\n");

		m_store.saveEpgMatches(buff);

		return buff.toString().getBytes("UTF-8");
	}

	private byte[] exportAutoEpgList() throws Exception {
		StringBuffer buff = new StringBuffer();

		buff.append("HTTP/1.0 200 OK\nContent-Type: text/xml\n");
		buff
		.append("Content-Disposition: attachment; filename=\"EpgAutoAdd.xml\"\n");
		buff.append("Pragma: no-cache\n");
		buff.append("Cache-Control: no-cache\n");
		buff.append("\n");

		m_store.saveEpgAutoList(buff);

		return buff.toString().getBytes("UTF-8");
	}

	private byte[] enableEpgAutoAdd() throws Exception {
		String out = "HTTP/1.0 302 Moved Temporarily\nLocation: " + "/servlet/"
				+ m_urlData.getServletClass() + "?action=01\n\n";

		int indexOf = Integer.parseInt(m_urlData.getParameter("index"));

		Vector<?> list = m_store.getEpgAutoAdds();
		EpgMatch epgMatcher = (EpgMatch) list.get(indexOf);

		if (epgMatcher != null) {
			if ("true".equals(m_urlData.getParameter("enabled")))
				epgMatcher.setEnabled(true);
			else if ("false".equals(m_urlData.getParameter("enabled")))
				epgMatcher.setEnabled(false);
			else if ("2".equals(m_urlData.getParameter("enabled")))
				epgMatcher.setEnabled(!epgMatcher.isEnabled());

			if ("true".equals(m_urlData.getParameter("enabledMark")))
				epgMatcher.setEnabledMark(true);
			else if ("false".equals(m_urlData.getParameter("enabledMark")))
				epgMatcher.setEnabledMark(false);
			else if ("2".equals(m_urlData.getParameter("enabledMark")))
				epgMatcher.setEnabledMark(!epgMatcher.isEnabledMark());

			m_store.saveEpgAutoList(null);
		}

		return out.getBytes("UTF-8");
	}

	private byte[] xmlEpgAutoAdds() throws Exception {
		// Creation of an XML document
		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		DocumentBuilder db = dbf.newDocumentBuilder();
		DOMImplementation di = db.getDOMImplementation();
		Document doc = di.createDocument("", "auto-add", null);
		Element root = doc.getDocumentElement();

		m_store.getEpgAutoAddsXml(doc, root);

		//
		// Do transform and return data
		//
		XSL transformer = new XSL(doc, "epg-auto-add.xsl", m_headers, m_urlData);

		return transformer.transform();
	}

	private byte[] createAutoAddFromItem() throws Exception {
		GuideStore guide = GuideStore.getInstance();

		HashMap<String, EpgMatchList> matchLists = m_store.getEpgMatches();

		String itemID = m_urlData.getParameter("itemID");
		String wsChan = m_urlData.getParameter("chan");
		String epgChan = guide.getEpgChannelIdFromMap(wsChan);

		GuideItem item = guide.getProgram(epgChan, itemID);

		if (item == null) {
			return getRedirUrlRedir(null).getBytes("UTF-8");
		}

		String name = item.getName();
		int nextIndex = 0;
		boolean useInt = false;
		String matchListName = name + " (" + wsChan + ")";

		if (matchLists.containsKey(matchListName)) {
			useInt = true;
			while (matchLists.containsKey(matchListName + "_" + nextIndex)) {
				nextIndex++;
			}
		}

		if (useInt)
			matchListName = matchListName + "_" + nextIndex;

		EpgMatchList newMatchList = new EpgMatchList();
		Vector<EpgMatchListItem> items = newMatchList.getMatchList();

		EpgMatchListItem newItemTitle = new EpgMatchListItem(
				EpgMatchListItem.TYPE_TEXT);
		newItemTitle.setTextSearchData(name + "*", EpgMatchListItem.FIELD_TITLE,
				true, EpgMatchListItem.FLAG_CASEINSENSATIVE);
		items.add(newItemTitle);

		EpgMatchListItem newItemChan = new EpgMatchListItem(
				EpgMatchListItem.TYPE_TEXT);
		newItemChan.setTextSearchData(wsChan, EpgMatchListItem.FIELD_CHANNEL,
				true, EpgMatchListItem.FLAG_CASEINSENSATIVE);
		items.add(newItemChan);

		matchLists.put(matchListName, newMatchList);

		// save out new MatchList
		m_store.saveEpgMatches(null);

		// create the new AA item
		EpgMatch epgMatch = new EpgMatch();
		epgMatch.setName( m_store.getEpgAutoAddUniqueName(name) );
		epgMatch.getMatchListNames().add(matchListName);

		int keepFor = 30;
		try {
			keepFor = Integer.parseInt(m_store.getProperty("AutoDel.KeepFor",
					"30"));
		} catch (Exception e) {
		}

		epgMatch.setKeepFor(keepFor);
		epgMatch.setAutoDelete(m_store.isAutoDelByDefault());

		int startBuff = 0;
		int endBuffer = 0;
		int epgBuffer = 0;
		try {
			startBuff = Integer.parseInt(m_store.getProperty(
					"Schedule.buffer.start", "0"));
			endBuffer = Integer.parseInt(m_store.getProperty(
					"Schedule.buffer.end", "0"));
			epgBuffer = Integer.parseInt(m_store.getProperty(
					"Schedule.buffer.EPG", "0"));
		} catch (Exception e) {
		}
		epgMatch.setStartBuffer(startBuff);
		epgMatch.setEndBuffer(endBuffer);
		epgMatch.setEPGBuffer(epgBuffer);

		epgMatch.setPostTask(m_store.getProperty("Tasks.DefTask", ""));

		String[] namePatterns = m_store.getNamePatterns();
		if (namePatterns.length > 0) {
			epgMatch.setFileNamePattern(namePatterns[0]);
		} else {
			epgMatch
			.setFileNamePattern("(%y-%m-%d %h-%M) %n [%c]\n%n [%c]\n%n\n%n\\%y-%m-%d");
		}

		String capType = "Capture.deftype";
		/*
		 * String capType = ""; try { capType =
		 * store.getProperty("Capture.deftype", ""); } catch (Exception e){}
		 */

		epgMatch.setCaptureType(capType);

		// save new auto-add
		m_store.addEpgMatch(epgMatch, 0, 1);

		return getRedirUrlRedir(null).getBytes("UTF-8");
	}

	private byte[] addDayMatch() throws Exception {
		String name = m_urlData.getParameter("name");

		HashMap<?, ?> matchLists = m_store.getEpgMatches();
		EpgMatchList matchList = (EpgMatchList) matchLists.get(name);

		if (matchList != null) {
			Vector<EpgMatchListItem> matchItems = matchList.getMatchList();
			EpgMatchListItem newItem = null;

			int index = -1;
			String update = m_urlData.getParameter("update");
			if (update != null && update.equals("Update")) {
				try {
					index = Integer.parseInt(m_urlData.getParameter("index"));
				} catch (Exception e) {
				}
			}

			if ((index > -1) && (index < matchItems.size())) {
				newItem = matchItems.get(index);
			} else {
				newItem = new EpgMatchListItem(EpgMatchListItem.TYPE_DAYS);
			}

			String sun = m_urlData.getParameter("sun");
			if (sun != null && "1".equals(sun))
				newItem.setDayData(EpgMatchListItem.DAYS_SUN, true);
			else
				newItem.setDayData(EpgMatchListItem.DAYS_SUN, false);

			String mon = m_urlData.getParameter("mon");
			if (mon != null && "1".equals(mon))
				newItem.setDayData(EpgMatchListItem.DAYS_MON, true);
			else
				newItem.setDayData(EpgMatchListItem.DAYS_MON, false);

			String tue = m_urlData.getParameter("tue");
			if (tue != null && "1".equals(tue))
				newItem.setDayData(EpgMatchListItem.DAYS_TUE, true);
			else
				newItem.setDayData(EpgMatchListItem.DAYS_TUE, false);

			String wed = m_urlData.getParameter("wed");
			if (wed != null && "1".equals(wed))
				newItem.setDayData(EpgMatchListItem.DAYS_WED, true);
			else
				newItem.setDayData(EpgMatchListItem.DAYS_WED, false);

			String thur = m_urlData.getParameter("thur");
			if (thur != null && "1".equals(thur))
				newItem.setDayData(EpgMatchListItem.DAYS_THUR, true);
			else
				newItem.setDayData(EpgMatchListItem.DAYS_THUR, false);

			String fri = m_urlData.getParameter("fri");
			if (fri != null && "1".equals(fri))
				newItem.setDayData(EpgMatchListItem.DAYS_FRI, true);
			else
				newItem.setDayData(EpgMatchListItem.DAYS_FRI, false);

			String sat = m_urlData.getParameter("sat");
			if (sat != null && "1".equals(sat))
				newItem.setDayData(EpgMatchListItem.DAYS_SAT, true);
			else
				newItem.setDayData(EpgMatchListItem.DAYS_SAT, false);

			if ((index < 0) || (index >= matchItems.size()))
				matchItems.add(newItem);

			m_store.saveEpgMatches(null);
		}

		return getRedirUrlRedir(null).getBytes("UTF-8");
	}

	private byte[] addSpanMatch() throws Exception {
		String name = m_urlData.getParameter("name");

		HashMap<?, ?> matchLists = m_store.getEpgMatches();
		EpgMatchList matchList = (EpgMatchList) matchLists.get(name);

		if (matchList != null) {
			int index = -1;
			String update = m_urlData.getParameter("update");
			if (update != null && update.equals("Update")) {
				try {
					index = Integer.parseInt(m_urlData.getParameter("index"));
				} catch (Exception e) {
				}
			}

			int spanFromHour = -1;
			try {
				spanFromHour = Integer.parseInt(m_urlData
						.getParameter("span_from_hour"));
			} catch (Exception e) {
			}

			int spanFromMin = -1;
			try {
				spanFromMin = Integer.parseInt(m_urlData
						.getParameter("span_from_min"));
			} catch (Exception e) {
			}

			int spanToHour = -1;
			try {
				spanToHour = Integer.parseInt(m_urlData
						.getParameter("span_to_hour"));
			} catch (Exception e) {
			}

			int spanToMin = -1;
			try {
				spanToMin = Integer.parseInt(m_urlData
						.getParameter("span_to_min"));
			} catch (Exception e) {
			}

			if (spanFromHour > -1 && spanFromMin > -1 && spanToHour > -1
					&& spanToMin > -1) {
				Vector<EpgMatchListItem> matchItems = matchList.getMatchList();

				if ((index > -1) && (index < matchItems.size())) {
					matchItems.get(index).setSpanData(spanFromHour,
							spanFromMin, spanToHour, spanToMin);
				} else {
					EpgMatchListItem newItem = new EpgMatchListItem(
							EpgMatchListItem.TYPE_SPAN);
					newItem.setSpanData(spanFromHour, spanFromMin, spanToHour,
							spanToMin);
					matchItems.add(newItem);
				}
				m_store.saveEpgMatches(null);
			}
		}

		return getRedirUrlRedir(null).getBytes("UTF-8");
	}

	private byte[] addOtherMatch() throws Exception {
		String name = m_urlData.getParameter("name");

		HashMap<?, ?> matchLists = m_store.getEpgMatches();
		EpgMatchList matchList = (EpgMatchList) matchLists.get(name);

		if (matchList != null) {
			int index = -1;
			String update = m_urlData.getParameter("update");
			if (update != null && update.equals("Update")) {
				try {
					index = Integer.parseInt(m_urlData.getParameter("index"));
				} catch (Exception e) {
				}
			}

			int otherFlag = -1;
			try {
				otherFlag = Integer.parseInt(m_urlData
						.getParameter("otherflag"));
			} catch (Exception e) {
			}

			boolean otherValue = true;
			try {
				otherValue = Boolean.parseBoolean(m_urlData
						.getParameter("othervalue"));
			} catch (Exception e) {
			}

			Vector<EpgMatchListItem> matchItems = matchList.getMatchList();

			if ((index > -1) && (index < matchItems.size())) {
				matchItems.get(index).SetOther(otherFlag, otherValue);
			} else {
				EpgMatchListItem newItem = new EpgMatchListItem(
						EpgMatchListItem.TYPE_OTHER);
				newItem.SetOther(otherFlag, otherValue);
				matchItems.add(newItem);
			}
			m_store.saveEpgMatches(null);
		}

		return getRedirUrlRedir(null).getBytes("UTF-8");
	}

	private byte[] addDurationMatch() throws Exception {
		String name = m_urlData.getParameter("name");

		HashMap<?, ?> matchLists = m_store.getEpgMatches();
		EpgMatchList matchList = (EpgMatchList) matchLists.get(name);

		if (matchList != null) {
			int index = -1;
			String update = m_urlData.getParameter("update");
			if (update != null && update.equals("Update")) {
				try {
					index = Integer.parseInt(m_urlData.getParameter("index"));
				} catch (Exception e) {
				}
			}

			int minDuration = -1;
			try {
				minDuration = Integer.parseInt(m_urlData.getParameter("minDuration"));
			} catch (Exception e) {
			}

			int maxDuration = -1;
			try {
				maxDuration = Integer.parseInt(m_urlData.getParameter("maxDuration"));
			} catch (Exception e) {
			}

			if ( (minDuration != -1) || (maxDuration != -1) )
			{
				Vector<EpgMatchListItem> matchItems = matchList.getMatchList();

				if ((index > -1) && (index < matchItems.size())) {
					matchItems.get(index).SetDuration(minDuration, maxDuration);
				} else {
					EpgMatchListItem newItem = new EpgMatchListItem(
							EpgMatchListItem.TYPE_DURATION);
					newItem.SetDuration(minDuration, maxDuration);
					matchItems.add(newItem);
				}
				m_store.saveEpgMatches(null);
			}
		}

		return getRedirUrlRedir(null).getBytes("UTF-8");
	}

	private byte[] deleteMatchItem() throws Exception {
		String name = m_urlData.getParameter("name");
		int index = -1;
		try {
			index = Integer.parseInt(m_urlData.getParameter("index"));
		} catch (Exception e) {
		}

		HashMap<?, ?> matchLists = m_store.getEpgMatches();
		EpgMatchList matchList = (EpgMatchList) matchLists.get(name);

		if (matchList != null) {
			Vector<?> items = matchList.getMatchList();

			if (index > -1 && index < items.size()) {
				items.remove(index);
				m_store.saveEpgMatches(null);
			}
		}

		return getRedirUrlRedir(null).getBytes("UTF-8");
	}

	private byte[] addTextMatch() throws Exception {
		String name = m_urlData.getParameter("name");

		HashMap<?, ?> matchLists = m_store.getEpgMatches();
		EpgMatchList matchList = (EpgMatchList) matchLists.get(name);

		if (matchList != null) {
			int index = -1;
			String update = m_urlData.getParameter("update");
			if (update != null && update.equals("Update")) {
				try {
					index = Integer.parseInt(m_urlData.getParameter("index"));
				} catch (Exception e) {
				}
			}

			String textSearch = m_urlData.getParameter("searchText");

			int field = -1;
			try {
				field = Integer.parseInt(m_urlData.getParameter("field"));
			} catch (Exception e) {
			}

			boolean exists = true;
			if ("false".equalsIgnoreCase(m_urlData.getParameter("exists")))
				exists = false;

			int flags = -1;
			try {
				flags = Integer.parseInt(m_urlData.getParameter("flags"));
			} catch (Exception e) {
			}

			if (textSearch != null && textSearch.length() > 0 && field > -1
					&& flags > -1) {
				Vector<EpgMatchListItem> matchItems = matchList.getMatchList();

				if ((index > -1) && (index < matchItems.size())) {
					matchItems.get(index).setTextSearchData(textSearch, field,
							exists, flags);
				} else {
					EpgMatchListItem newItem = new EpgMatchListItem(
							EpgMatchListItem.TYPE_TEXT);
					newItem.setTextSearchData(textSearch, field, exists, flags);
					matchItems.add(newItem);
				}

				m_store.saveEpgMatches(null);
			}
		}

		return getRedirUrlRedir(null).getBytes("UTF-8");
	}

	private byte[] renameMatchList() throws Exception {
		String name = m_urlData.getParameter("name", "").trim();

		if (!name.isEmpty()) {
			String oldName = m_urlData.getParameter("oldname");
			boolean bUseTitleFilter = m_urlData.getParameterInt(
					"useTextFilter", 0) == 1;
			HashMap<String, EpgMatchList> matchLists = m_store.getEpgMatches();

			if (name.equals(oldName)) {
				EpgMatchList matchList = (EpgMatchList) matchLists.get(oldName);
				if (matchList != null) {
					matchList.setUseTitleFilter(bUseTitleFilter);
					m_store.saveEpgMatches(null);
				}
			} else if (!matchLists.containsKey(name)) {
				EpgMatchList matchList = (EpgMatchList) matchLists
						.remove(oldName);
				if (matchList != null) {
					matchList.setUseTitleFilter(bUseTitleFilter);
					matchLists.put(name, matchList);
					m_store.saveEpgMatches(null);

					Vector<?> autoAddItems = m_store.getEpgAutoAdds();
					for (int x = 0; x < autoAddItems.size(); x++) {
						EpgMatch item = (EpgMatch) autoAddItems.get(x);
						item.renameMatchListName(oldName, name);
					}
					m_store.saveEpgAutoList(null);
				}
			}
		}

		return getRedirUrlRedir(null).getBytes("UTF-8");
	}

	private byte[] addMatchList() throws Exception {
		String name = m_urlData.getParameter("name", "").trim();

		if (!name.isEmpty()) {
			HashMap<String, EpgMatchList> matchLists = m_store.getEpgMatches();
			if (!matchLists.containsKey(name)) {
				EpgMatchList matchList = new EpgMatchList();
				matchLists.put(name, matchList);
				m_store.saveEpgMatches(null);
			}
		}

		StringBuffer out = new StringBuffer(256);
		out.append("HTTP/1.0 302 Moved Temporarily\n");
		out.append("Location: /servlet/" + m_urlData.getServletClass()
				+ "?action=05\n\n");
		return out.toString().getBytes("UTF-8");
	}

	private byte[] deleteMatchList() throws Exception {
		String name = m_urlData.getParameter("name");

		if (name != null && !name.isEmpty()) {
			HashMap<?, ?> matchLists = m_store.getEpgMatches();
			matchLists.remove(name);
			m_store.saveEpgMatches(null);

			Vector<?> autoAddItems = m_store.getEpgAutoAdds();
			for (int x = 0; x < autoAddItems.size(); x++) {
				EpgMatch item = (EpgMatch) autoAddItems.get(x);
				item.removeMatchListName(name);
			}
			m_store.saveEpgAutoList(null);
		}

		StringBuffer out = new StringBuffer(256);
		out.append("HTTP/1.0 302 Moved Temporarily\n");
		out.append("Location: /servlet/" + m_urlData.getServletClass()
				+ "?action=05\n\n");
		return out.toString().getBytes("UTF-8");
	}

	private byte[] showMatchList() throws Exception {
		Vector<?> matches = m_store.getEpgAutoAdds();
		HashMap<String, Integer> usedMatchLists = new HashMap<String, Integer>();
		for (int x = 0; x < matches.size(); x++) {
			EpgMatch item = (EpgMatch) matches.get(x);
			for (int y = 0; y < item.getMatchListNames().size(); y++) {
				String mlName = (String) item.getMatchListNames().get(y);
				if (usedMatchLists.containsKey(mlName)) {
					Integer oldCount = (Integer) usedMatchLists.get(mlName);
					usedMatchLists.put(mlName, new Integer(
							oldCount.intValue() + 1));
				} else {
					usedMatchLists.put(mlName, new Integer(1));
				}
			}
		}

		StringBuffer buff = new StringBuffer();

		HashMap<String, EpgMatchList> matchLists = m_store.getEpgMatches();

		String[] keys = (String[]) matchLists.keySet().toArray(new String[0]);
		Arrays.sort(keys, String.CASE_INSENSITIVE_ORDER);

		for (int x = 0; x < keys.length; x++) {
			buff.append("<tr>");

			Integer count = new Integer(0);
			if (usedMatchLists.containsKey(keys[x])) {
				count = (Integer) usedMatchLists.get(keys[x]);
			}
			buff.append("<td nowrap>" + count);
			buff.append("</td>");

			String htmlName = HTMLEncoder.encode(keys[x]);

			buff.append("<td nowrap>" + htmlName + "</td>");

			buff.append("<td nowrap align='right'>");
			buff.append("<a href='/servlet/" + m_urlData.getServletClass()
					+ "?action=07&name="
					+ Formatter.encodeURL(keys[x], "UTF-8"));
			buff.append("' onClick='return confirmAction(\"Delete\");'>");
			buff.append("<img src='/images/delete.png' border='0' alt='Delete' title='Delete' width='24' height='24'></a> ");

			buff.append("<img onClick='editEpgMatch(\"" + Formatter.encodeURL_UTF8E(keys[x]) + 
					"\")' class='hand' src='/images/edit.png' border='0' alt='Edit' title='Edit' width='24' height='24'/>");
			buff.append("</td>");
			buff.append("</tr>\n");
		}

		PageTemplate template = new PageTemplate(m_headers, m_urlData,
				"epg-matchLists.html", true);
		template.replace("$title", "EPG Match Lists");
		template.replace("$list", buff.toString());
		template.replace("$filterTitle", HTMLEncoder
				.encode(m_store.m_EpgTitleFilter));

		return template.getPageBytes();
	}

	private byte[] editMatchList() throws Exception {
		GuideStore guide = GuideStore.getInstance();

		String name = m_urlData.getParameter("name");

		HashMap<?, ?> matchLists = m_store.getEpgMatches();
		EpgMatchList matchList = (EpgMatchList) matchLists.get(name);

		if (matchList == null) {
			StringBuffer out = new StringBuffer(256);
			out.append("HTTP/1.0 302 Moved Temporarily\n");
			out.append("Location: /servlet/" + m_urlData.getServletClass()
					+ "?action=05\n\n");
			return out.toString().getBytes("UTF-8");
		}

		PageTemplate template = new PageTemplate(m_headers, m_urlData,
				"epg-matchListEdit.html");

		template.replace("$title", "Edit Epg Auto-Add Match List");

		template.replace("$URLname", Formatter.encodeURL(name, "UTF-8"));

		String htmlName = name;
		htmlName = htmlName.replaceAll("\"", "&quot;");
		template.replace("$name", htmlName);
		template.replace("$checked", matchList.isUseTitleFilter() ? "checked"
				: "");

		String dari = getRedirUrl(null);
		String dariEnc = Formatter.encodeURL(dari, "UTF-8");
		template.replace("$dariEnc", dariEnc);
		template.replace("$dari", dari);

		Vector<?> items = matchList.getMatchList();
		StringBuffer buff = new StringBuffer();
		for (int x = 0; x < items.size(); x++) {
			EpgMatchListItem item = (EpgMatchListItem) items.get(x);
			buff.append("<tr type='" + item.getType() + "' ");

			if (item.getType() == EpgMatchListItem.TYPE_TEXT) {
				String searchText = HTMLEncoder.encode(item.getTextSearch());

				buff.append("text='" + searchText + "' field='"
						+ item.getField() + "' exist='" + item.getExists()
						+ "' flag='" + item.getFlags() + "'>");

				buff.append("<td>TEXT : (" + searchText + ") in the ");

				if (item.getField() == EpgMatchListItem.FIELD_TITLE) {
					buff.append("title");
				} else if (item.getField() == EpgMatchListItem.FIELD_DESCRIPTION) {
					buff.append("description");
				} else if (item.getField() == EpgMatchListItem.FIELD_CHANNEL) {
					buff.append("channel");
				} else if (item.getField() == EpgMatchListItem.FIELD_CATEGORY) {
					buff.append("category");
				} else if (item.getField() == EpgMatchListItem.FIELD_SUBTITLE) {
					buff.append("sub-title");
				} else if (item.getField() == EpgMatchListItem.FIELD_LANGUAGE) {
					buff.append("language");
				} else if (item.getField() == EpgMatchListItem.FIELD_RATINGS) {
					buff.append("ratings");
				}

				if (item.getExists()) {
					buff.append(" must exist");
				} else {
					buff.append(" must NOT exist");
				}

				if (item.getFlags() == EpgMatchListItem.FLAG_NONE)
					buff.append(" (Case)");
				else if (item.getFlags() == EpgMatchListItem.FLAG_CASEINSENSATIVE)
					buff.append(" (No Case)");
				else if (item.getFlags() == EpgMatchListItem.FLAG_REGEX)
					buff.append(" (RegEx)");

				buff.append("</td>");
			} else if (item.getType() == EpgMatchListItem.TYPE_SPAN) {
				buff.append("fromHour='" + item.getSpanFromHour()
						+ "' fromMinute='" + item.getSpanFromMin()
						+ "' toHour='" + item.getSpanToHour() + "' toMinute='"
						+ item.getSpanToMin() + "'>");

				buff.append("<td>SPAN : From <b>"
						+ DataStore.intToStr(item.getSpanFromHour()) + ":"
						+ DataStore.intToStr(item.getSpanFromMin()));
				buff.append("</b> to <b>"
						+ DataStore.intToStr(item.getSpanToHour()) + ":"
						+ DataStore.intToStr(item.getSpanToMin()) + "</b>");

				buff.append("</td>");
			} else if (item.getType() == EpgMatchListItem.TYPE_DAYS) {
				if (item.getDayValue(EpgMatchListItem.DAYS_SUN))
					buff.append(" Sun ");

				if (item.getDayValue(EpgMatchListItem.DAYS_MON))
					buff.append(" Mon ");

				if (item.getDayValue(EpgMatchListItem.DAYS_TUE))
					buff.append(" Tue ");

				if (item.getDayValue(EpgMatchListItem.DAYS_WED))
					buff.append(" Wed ");

				if (item.getDayValue(EpgMatchListItem.DAYS_THUR))
					buff.append(" Thur ");

				if (item.getDayValue(EpgMatchListItem.DAYS_FRI))
					buff.append(" Fri ");

				if (item.getDayValue(EpgMatchListItem.DAYS_SAT))
					buff.append(" Sat ");

				buff.append(">");

				buff.append("<td>DAYS : ");

				if (item.getDayValue(EpgMatchListItem.DAYS_SUN))
					buff.append(" Sun ");

				if (item.getDayValue(EpgMatchListItem.DAYS_MON))
					buff.append(" Mon ");

				if (item.getDayValue(EpgMatchListItem.DAYS_TUE))
					buff.append(" Tue ");

				if (item.getDayValue(EpgMatchListItem.DAYS_WED))
					buff.append(" Wed ");

				if (item.getDayValue(EpgMatchListItem.DAYS_THUR))
					buff.append(" Thur ");

				if (item.getDayValue(EpgMatchListItem.DAYS_FRI))
					buff.append(" Fri ");

				if (item.getDayValue(EpgMatchListItem.DAYS_SAT))
					buff.append(" Sat ");

				buff.append("</td>");
			} else if (item.getType() == EpgMatchListItem.TYPE_OTHER) {
				buff.append("flag='" + item.GetOtherFlag() + "' value='"
						+ item.GetOtherValue() + "'>");

				buff.append("<td>OTHER : " + item.GetOtherFlagStr() + " = "
						+ item.GetOtherValue());

				buff.append("</td>");
			} else if (item.getType() == EpgMatchListItem.TYPE_DURATION) {
				int min = item.GetMinDuration();
				int max = item.GetMaxDuration();

				buff.append("minDuration='" + (min > 0 ? min : "")
						+ "' maxDuration='" + (max > 0 ? max : "") + "'>");

				if (min > 0) {
					buff.append("<td>DURATION : Minimum "
							+ item.GetMinDuration() + " minutes");
					if (max > 0)
						buff.append(", maximum " + item.GetMaxDuration()
								+ " minutes");
				} else if (max > 0)
					buff.append("<td>DURATION : Maximum "
							+ item.GetMaxDuration() + " minutes");

				buff.append("</td>");
			} else {
				buff.append("<td>Unknown Type</td>");
			}

			buff
			.append("<td align='right'><img onClick='deleteMatchItem(\"" + Formatter.encodeURL_UTF8E(name) + "\"," + x + ")' align='absmiddle' src='/images/delete.png' class='hand' border='0' alt='Delete' title='Delete' width='24' height='24'/>"
					+ " <img style='cursor:hand;cursor:pointer;' border=0 src='/images/edit.png' alt='Edit' title='Edit' onClick=\"edit('"
					+ x + "');\" width='24' height='24'></td>");

			buff.append("</tr>");

		}

		if (items.size() == 0) {
			buff.append("<tr><td colspan='2'>No Match Items</td></tr>");
		}

		template.replace("$matchItems", buff.toString());

		// Show match list result search
		if ("1".equals(m_urlData.getParameter("show"))) {
			DateFormatter2 dateFormatter2 = new DateFormatter2();
			buff = new StringBuffer();

			HashMap<String, Vector<GuideItem>> results = new HashMap<String, Vector<GuideItem>>();
			int num = guide.searchEPG(matchList, results);

			Calendar startTime = Calendar.getInstance();

			buff.append("<table class='epgSearchResults'>\n");

			String[] keys = (String[]) results.keySet().toArray(new String[0]);

			for (int y = 0; y < keys.length; y++) {
				Vector<?> result = (Vector<?>) results.get(keys[y]);

				if (result.size() > 0) {
					buff.append("<tr><td colspan='4'>\n");
					buff.append("<span class='areaTitle'>" + keys[y]
							+ "</span><br>\n");
					buff.append("</td></tr\n");

					for (int x = 0; x < result.size(); x++) {
						GuideItem item = (GuideItem) result.get(x);
						startTime.setTime(item.getStart());

						int hour = startTime.get(Calendar.HOUR);
						if (hour == 0)
							hour = 12;

						String startString = dateFormatter2
								.formatTime(startTime.getTime());
						/*
						 * String startString = store.intToStr(hour) + ":" +
						 * store.intToStr(startTime.get(Calendar.MINUTE)) + " "
						 * + store.ampm.get(new
						 * Integer(startTime.get(Calendar.AM_PM)));
						 */

						String dateString = m_store.dayName.get(new Integer(
								startTime.get(Calendar.DAY_OF_WEEK)))
								+ ", "
								+ startTime.get(Calendar.DATE)
								+ " "
								+ m_store.monthNameShort.get(new Integer(
										startTime.get(Calendar.MONTH)));

						buff.append("<tr>\n");
						buff.append("<td class='epgSearchResults'>"
								+ item.getName() + "</td>");
						buff.append("<td class='epgSearchResults'>"
								+ dateString + " at " + startString + "</td>");
						buff.append("<td class='epgSearchResults'>"
								+ item.getDuration() + "</td>");

						buff.append("<td class='epgSearchResults'>");

						String infoUrl = "/servlet/EpgDataRes?action=06&id="
								+ item.toString() + "&channel="
								+ Formatter.encodeURL(keys[y], "UTF-8");
						buff
						.append("<span class='programName' onClick=\"openDetails('"
								+ infoUrl + "')\">");
						buff.append("Details");
						buff.append("</span> | \n");

						if (startTime.get(Calendar.HOUR_OF_DAY) < 6)
							startTime.add(Calendar.DATE, -1);

						String epgUrl = "/servlet/EpgDataRes?action=12"
								+ "&year=" + startTime.get(Calendar.YEAR)
								+ "&month="
								+ (startTime.get(Calendar.MONTH) + 1) + "&day="
								+ startTime.get(Calendar.DATE) + "&scrollto="
								+ startTime.get(Calendar.HOUR_OF_DAY);

						buff.append("<a class='infoNav' href='" + epgUrl
								+ "'>EPG</a>");

						buff.append("</td>");

						buff.append("</tr>\n");
					}
				}
			}

			if (num == 0) {
				buff.append("<tr><td colspan='4'>No Matches</td></tr>\n");
			}

			buff.append("</table><p>\n");

			template.replace("$searchResult", buff.toString());

		} else {
			template.replace("$searchResult", "");
		}

		return template.getPageBytes();
	}

	private byte[] updateTitleFilter() throws Exception {
		m_store.m_EpgTitleFilter = DVScheduler.checkBreaks(m_urlData
				.getParameter("filterTitle", "").trim());
		m_store.saveEpgMatches(null);

		return getServletRedir("?action=05").getBytes("UTF-8");
	}

	private byte[] xmlConfirmDeleteAutoAdds(Vector<Integer> selectedVector)
			throws Exception {
		//
		// Creation of an XML document
		//
		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		DocumentBuilder db = dbf.newDocumentBuilder();
		DOMImplementation di = db.getDOMImplementation();

		Document doc = di.createDocument("", "delAutoAdd", null);
		Element root = doc.getDocumentElement();
		String command = "/servlet/EpgAutoAddDataRes?action=32&delSel=1";
		for (int i = 0; i < selectedVector.size(); i++) {
			command += "&sel=" + selectedVector.get(i);
		}
		command += getRedirUrlDari(null);
		root.setAttribute("action", command);

		String[] epgMatchesToDeleteArray = getEpgMatchesToDelete(selectedVector)
				.toArray(new String[0]);
		Arrays.sort(epgMatchesToDeleteArray, String.CASE_INSENSITIVE_ORDER);
		Element elm = doc.createElement("epgMatches");
		Element elm2 = null;
		for (int i = 0; i < epgMatchesToDeleteArray.length; i++) {
			elm2 = doc.createElement("epgMatch");
			elm2.setAttribute("name", epgMatchesToDeleteArray[i]);
			elm.appendChild(elm2);
		}
		root.appendChild(elm);

		//
		// Send output back
		//
		XSL transformer = new XSL(doc, "epg-auto-add-question.xsl", m_headers,
				m_urlData);
		return transformer.transform();
	}

	private Set<String> getEpgMatchesToDelete(Vector<Integer> selectedVector) {
		Vector<EpgMatch> epgAutoAdds = m_store.getEpgAutoAdds();
		Set<String> epgMatchesToDelete = new HashSet<String>();
		for (int i = 0; i < selectedVector.size(); i++) {
			int index = selectedVector.get(i);
			if ((index >= 0) && (index < epgAutoAdds.size())) {
				epgMatchesToDelete.addAll(epgAutoAdds.get(index)
						.getMatchListNames());
			}
		}

		Set<Integer> selectedSet = new HashSet<Integer>(selectedVector);
		for (int i = 0; i < epgAutoAdds.size(); i++) {
			if (selectedSet.contains(i))
				continue;

			Vector<String> epgMatchesStillUsed = epgAutoAdds.get(i)
					.getMatchListNames();
			for (int j = 0; j < epgMatchesStillUsed.size(); j++) {
				String item = epgMatchesStillUsed.get(j);
				if (epgMatchesToDelete.contains(item))
					epgMatchesToDelete.remove(item);
			}
		}

		return epgMatchesToDelete;
	}

	private byte[] moveSelectedEpgAutoAdds() throws Exception {
		String selected = m_urlData.getParameter("sel");
		if ((selected == null) || (selected.isEmpty()))
			return getRedirUrlRedir(null).getBytes("UTF-8");
		String[] selectedArray = selected.split("\n");
		Vector<Integer> selectedVector = new Vector<Integer>();
		for (int i = 0; i < selectedArray.length; i++) {
			int sel = -1;
			try {
				sel = Integer.parseInt(selectedArray[i]);
			} catch (Exception e) {
			}

			if (sel > -1)
				selectedVector.add(sel);
		}
		if (selectedVector.isEmpty())
			return getRedirUrlRedir(null).getBytes("UTF-8");

		if (m_urlData.getParameterStartsWith("delSel") != null) {
			int nDeleteEpgMatches = m_urlData.getParameterInt("all", -1);
			if (nDeleteEpgMatches == 1) {
				Vector<String> epgMatchesToDelete = new Vector<String>(
						getEpgMatchesToDelete(selectedVector));
				m_store.deleteEpgAutoAdds(selectedVector);
				m_store.deleteEpgMatches(epgMatchesToDelete);
			} else if (nDeleteEpgMatches == 0)
				m_store.deleteEpgAutoAdds(selectedVector);
			else {
				return xmlConfirmDeleteAutoAdds(selectedVector);
			}
		} else if (m_urlData.getParameterStartsWith("moveEnd") != null) {
			m_store.moveEpgAutoAddsBeforeEpgAutoAdd(-1, selectedVector);
		} else {
			int beforeIndex = -1;
			try {
				beforeIndex = Integer.parseInt(m_urlData
						.getParameterStartsWith("move.").split("\\.")[1]);
			} catch (Exception e) {
			}

			if (beforeIndex > -1)
				m_store.moveEpgAutoAddsBeforeEpgAutoAdd(beforeIndex,
						selectedVector);
		}

		return getRedirUrlRedir(null).getBytes("UTF-8");
	}

	private byte[] deleteAllEpgAutoAdds() throws Exception {
		m_store.deleteAllEpgAutoAdds();

		return getServletRedir("?action=01").getBytes("UTF-8");
	}

	private byte[] EnableDisableEpgAutoAdds() throws Exception {
		String action = m_urlData.getParameter("actionSelect");

		Vector<EpgMatch> list = m_store.getEpgAutoAdds();
		if ("enableAllAutoAdd".equals(action))
		{
			for (int i=0; i<list.size(); i++)
			{
				list.get(i).setEnabled(true);
			}
			m_store.saveEpgAutoList(null);
		}
		else if ("disableAllAutoAdd".equals(action))
		{
			for (int i=0; i<list.size(); i++)
			{
				list.get(i).setEnabled(false);
			}
			m_store.saveEpgAutoList(null);
		}
		else if ("enableAllFavorite".equals(action))
		{
			for (int i=0; i<list.size(); i++)
			{
				list.get(i).setEnabledMark(true);
			}
			m_store.saveEpgAutoList(null);
		}
		else if ("disableAllFavorite".equals(action))
		{
			for (int i=0; i<list.size(); i++)
			{
				list.get(i).setEnabledMark(false);
			}
			m_store.saveEpgAutoList(null);
		}

		return getServletRedir("?action=01").getBytes("UTF-8");
	}
}
