/*
   Copyright (C) 2007-2010 contributors

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

 */

import java.net.URLDecoder;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

public class GroupAuth
{
	// true means m_servlets lists allowed sites (other sites not allowed);
	// false means m_servlets lists not-allowed sites (other sites allowed).
	public boolean m_bAllowed = false;

	public boolean m_bAllFiles = false;
	public boolean m_bAllServlets = false;

	public Map< String, Set<String> > m_servlets = new HashMap< String, Set<String> >();

	public boolean checkPermission(HTTPurl urlData) throws Exception
	{
		String servlet = null;
		Set<String> actions = null;

		switch (urlData.getRequestType())
		{
		case 1:
			servlet = "-";
			break;

		case 2: case 4: case 5:
			if (m_bAllFiles)
				return m_bAllowed;
			actions = m_servlets.get( URLDecoder.decode(urlData.getRequestString().replace("+", "%2B"), "UTF-8") );
			return !((actions != null && actions.isEmpty()) ^ m_bAllowed);
		case 3:
			if (m_bAllServlets)
				return m_bAllowed;
			servlet = urlData.getServletClass();
			break;

		default:
			return false;
		}

		actions = m_servlets.get(servlet);
		if ( (actions == null) || actions.isEmpty() )
			return !m_bAllowed;
		if ( actions.contains("*") )
			return m_bAllowed;

		String action = urlData.getParameter("action");
		if (action == null)
			return !(actions.contains("-") ^ m_bAllowed);

		return !(actions.contains(action) ^ m_bAllowed);
	}
}