/*
   Copyright (C) 2007-2010 contributors

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

 */

import java.io.*;
import java.net.URLDecoder;
import java.util.*;

class HTTPResponse
{
	protected DataStore m_store = null;
	protected Map<String, String> m_headers = null;
	protected HTTPurl m_urlData = null;
	protected OutputStream m_outStream = null;

	public HTTPResponse(Map<String, String> headers, HTTPurl urlData, OutputStream outStream) throws Exception
	{
		m_store = DataStore.getInstance();

		m_headers = headers;
		m_urlData = urlData;
		m_outStream = outStream;
	}

	public void getResponse() throws Exception
	{
	}

	public void getResponse2() throws Exception
	{
	}

	public static boolean isLocal(String ip)
	{
		return ( "127.0.0.1".equals(ip) || "0:0:0:0:0:0:0:1".equals(ip) || "localhost".equals(ip) );
	}

	public static boolean isLocal(Map<String, String> headers)
	{
		String ip = headers.get("RemoteAddress");
		return isLocal(ip);
	}

	protected boolean isLocal()
	{
		return isLocal(m_headers);
	}

	public static String getRedirUrl(Map<String, String> headers, HTTPurl urlData, String defaultRedirUrl)
	{
		String redirUrl = urlData.getParameter("putar");
		if (redirUrl == null || redirUrl.length() == 0)
		{
			redirUrl = urlData.getParameter("dari");
			if (redirUrl == null || redirUrl.length() == 0)
			{
				redirUrl = headers.get("Referer");
				/*
				String hostAddress = headers.get("HostAddress");
				String hostName = headers.get("HostName");
				if ( hostName.equals("127.0.0.1") || hostName.equals("0:0:0:0:0:0:0:1") )
					hostName = "localhost";
				if ( redirUrl == null || redirUrl.length() == 0 || hostAddress == null || hostName == null || 
						(!redirUrl.contains(hostAddress) && !redirUrl.contains(hostName)) )
				 */
				if ( (redirUrl == null) || redirUrl.isEmpty() )
				{
					redirUrl = urlData.getCookie("backURL");
					try
					{
						redirUrl = URLDecoder.decode(redirUrl, "UTF-8");
					}
					catch (Exception e) {}
					if (redirUrl == null || redirUrl.length() == 0)
						redirUrl = (defaultRedirUrl != null && !defaultRedirUrl.isEmpty()) ? defaultRedirUrl : (urlData.getServletClass().isEmpty() ? "/" : ("/servlet/" + urlData.getServletClass()));
				}
			}
		}

		return redirUrl.replace("&scrollto=", "&nada=");
	}

	protected String getRedirUrl(String defaultRedirUrl)
	{
		return getRedirUrl(m_headers, m_urlData, defaultRedirUrl);
	}

	public static String getRedirUrlPutar(Map<String, String> headers, HTTPurl urlData, String defaultRedirUrl) throws Exception
	{
		return "&putar=" + Formatter.encodeURL(getRedirUrl(headers, urlData, defaultRedirUrl), "UTF-8");
	}

	protected String getRedirUrlPutar(String defaultRedirUrl) throws Exception
	{
		return getRedirUrlPutar(m_headers, m_urlData, defaultRedirUrl);
	}

	public static String getRedirUrlDari(Map<String, String> headers, HTTPurl urlData, String defaultRedirUrl) throws Exception
	{
		return "&dari=" + Formatter.encodeURL(getRedirUrl(headers, urlData, defaultRedirUrl), "UTF-8");
	}

	protected String getRedirUrlDari(String defaultRedirUrl) throws Exception
	{
		return getRedirUrlDari(m_headers, m_urlData, defaultRedirUrl);
	}

	public static String getRedir(String url)
	{
		String redirect = "HTTP/1.0 302 Moved Temporarily\n";
		redirect += "Location: " + url + "\n\n";

		return redirect;
	}

	public static String getServletRedir(HTTPurl urlData, String url)
	{
		return getRedir("/servlet/" + urlData.getServletClass() + url);
	}

	public String getServletRedir(String url)
	{
		return getServletRedir(m_urlData, url);
	}

	public static String getServletRedir(HTTPurl urlData)
	{
		return getRedir("/servlet/" + urlData.getServletClass());
	}

	public String getServletRedir()
	{
		return getServletRedir(m_urlData);
	}

	public static String getRedirUrlRedir(Map<String, String> headers, HTTPurl urlData, String defaultRedirUrl)
	{
		return getRedir(getRedirUrl(headers, urlData, defaultRedirUrl));
	}

	protected String getRedirUrlRedir(String defaultRedirUrl)
	{
		return getRedirUrlRedir(m_headers, m_urlData, defaultRedirUrl);
	}
}
