import java.util.*;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Text;

public class NetworkType
{
	private SortedSet<String> m_networkTypes = new TreeSet<String>();
	private String m_setting = "";

	public NetworkType()
	{
	}

	public NetworkType(String networkType)
	{
		set(networkType);
	}

	public static List<String> getNetworkTypes(String networkType)
	{
		List<String> list = new LinkedList<String>();
		String[] types = networkType.split(",");
		for (int i=0; i<types.length; i++)
		{
			types[i].trim();
			if (types[i].isEmpty())
				continue;

			if (types[i].equalsIgnoreCase("DVB-S2"))
				list.add("DVB-S");
			else
				list.add(types[i]);
		}

		return list;
	}
	
	public void set(String networkType)
	{
		m_networkTypes.clear();
		String[] types = networkType.split(",");
		for (int i=0; i<types.length; i++)
		{
			types[i].trim();
			if (types[i].isEmpty())
				continue;

			if (types[i].equalsIgnoreCase("DVB-S2"))
				m_networkTypes.add("DVB-S");
			else
				m_networkTypes.add(types[i]);
		}

		setNetworkTypes();
	}

	public String toString()
	{
		return m_setting;
	}

	public boolean equals(NetworkType networkType)
	{
		return m_networkTypes.equals(networkType.m_networkTypes);
	}

	public boolean isCompatible(String networkType)
	{
		return m_networkTypes.contains(networkType);
	}

	public boolean isCompatible(NetworkType networkType)
	{
		Iterator<String> iter = networkType.m_networkTypes.iterator();
		while (iter.hasNext())
		{
			if (m_networkTypes.contains(iter.next()))
				return true;
		}
		return false;
	}

	protected void setNetworkTypes()
	{
		m_setting = "";
		Iterator<String> iter = m_networkTypes.iterator();
		while (iter.hasNext())
		{
			if (!m_setting.isEmpty())
				m_setting += ",";
			m_setting += iter.next();
		}
	}

	public void set(SortedSet<String> networkTypes)
	{
		m_networkTypes = networkTypes;
		setNetworkTypes();
	}

	public void add(String networkType)
	{
		// For backward compatibility.
		if (networkType.equals("0"))
			networkType = "DVB-T";
		else if (networkType.equals("1"))
			networkType = "DVB-C";
		else if (networkType.equals("2"))
			networkType = "DVB-S";
		else if (networkType.equals("3"))
			networkType = "ATSC";

		m_networkTypes.add(networkType);
		setNetworkTypes();
	}

	public void getXML(Document doc, Element item)
	{
		Iterator<String> iter = m_networkTypes.iterator();
		while (iter.hasNext())
		{
			Element elm = doc.createElement("networktype");
			Text text = doc.createTextNode(iter.next());
			elm.appendChild(text);
			item.appendChild(elm);
		}
	}
}