/*
   Copyright (C) 2007-2010 contributors

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

 */

import java.io.*;
import java.util.*;
import java.text.*;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.DOMImplementation;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

class SystemDataRes extends HTTPResponse
{
	private DateFormat dtf = DateFormat.getDateTimeInstance(DateFormat.FULL, DateFormat.FULL);

	public SystemDataRes(Map<String, String> headers, HTTPurl urlData, OutputStream outStream) throws Exception
	{
		super(headers, urlData, outStream);
	}

	public void getResponse() throws Exception
	{
		String action = m_urlData.getParameter("action");
		if("02".equals(action))
		{
			m_outStream.write(showServerProperties());
			return;
		}
		else if("03".equals(action))
		{
			ThreadLock.getInstance().getLock();
			try
			{
				m_outStream.write(setServerProperty());
			}
			finally
			{
				ThreadLock.getInstance().releaseLock();
			}
			return;
		}
		else if("04".equals(action))
		{
			ThreadLock.getInstance().getLock();
			try
			{
				m_outStream.write(refreshTunerList());
			}
			finally
			{
				ThreadLock.getInstance().releaseLock();
			}
			return;
		}     
		else if("06".equals(action))
		{
			m_outStream.write(showAutoDelItems());
			return;
		}   
		else if("07".equals(action))
		{
			ThreadLock.getInstance().getLock();
			try
			{
				m_outStream.write(remAutoDelItem());
			}
			finally
			{
				ThreadLock.getInstance().releaseLock();
			}
			return;
		}
		else if("08".equals(action))
		{
			m_outStream.write(showTasks());
			return;
		}         
		else if("09".equals(action))
		{
			ThreadLock.getInstance().getLock();
			try
			{
				m_outStream.write(addTask());
			}
			finally
			{
				ThreadLock.getInstance().releaseLock();
			}
			return;
		}
		else if("10".equals(action))
		{
			ThreadLock.getInstance().getLock();
			try
			{
				m_outStream.write(removeTask());
			}
			finally
			{
				ThreadLock.getInstance().releaseLock();
			}
			return;
		}
		else if("11".equals(action))
		{
			m_outStream.write(showJavaEnviroment());
			return;
		}      
		else if("12".equals(action))
		{
			m_outStream.write(setEpgTask());
			return;
		}
		else if("13".equals(action))
		{
			ThreadLock.getInstance().getLock();
			try
			{
				m_outStream.write(addTunerToList());
			}
			finally
			{
				ThreadLock.getInstance().releaseLock();
			}
			return;
		}      
		else if("14".equals(action))
		{
			ThreadLock.getInstance().getLock();
			try
			{
				m_outStream.write(removeTunerFromList());
			}
			finally
			{
				ThreadLock.getInstance().releaseLock();
			}
			return;
		}  
		else if("15".equals(action))
		{
			ThreadLock.getInstance().getLock();
			try
			{
				m_outStream.write(moveTunerUp());
			}
			finally
			{
				ThreadLock.getInstance().releaseLock();
			}
			return;
		}    
		else if("16".equals(action))
		{
			ThreadLock.getInstance().getLock();
			try
			{
				m_outStream.write(moveTunerDown());
			}
			finally
			{
				ThreadLock.getInstance().releaseLock();
			}
			return;
		}      
		else if("17".equals(action))
		{
			m_outStream.write(enableTask());
			return;
		}    
		else if("18".equals(action))
		{
			m_outStream.write(exportTaskList());
			return;
		}       
		else if("19".equals(action))
		{
			m_outStream.write(showAvailableThemes());
			return;
		}  
		else if("20".equals(action))
		{
			m_outStream.write(applyThemes());
			return;
		} 
		else if("22".equals(action))
		{
			m_outStream.write(xmlEditTask());
			return;
		}        
		else if("23".equals(action))
		{
			ThreadLock.getInstance().getLock();
			try
			{
				m_outStream.write(updateTask());
			}
			finally
			{
				ThreadLock.getInstance().releaseLock();
			}
			return;
		}
		else if("24".equals(action))
		{
			m_outStream.write(showEngineHelpCapture("Capture.deftype.html"));
			return;
		}
		else if("25".equals(action))
		{
			m_outStream.write(showEngineHelpCapture("CaptureTypes.html"));
			return;
		}
		else if("26".equals(action))
		{
			m_outStream.write(showEngineHelpPreview("Preview.deftype.html"));
			return;
		}
		else if("27".equals(action))
		{
			ThreadLock.getInstance().getLock();
			try
			{
				m_outStream.write(updateCaptureDevice());
			}
			finally
			{
				ThreadLock.getInstance().releaseLock();
			}
			return;
		}
		else if("28".equals(action))
		{
			m_outStream.write(showEngineHelpCapture("Capture.channel.html"));
			return;
		}
		else if("29".equals(action))
		{
			ThreadLock.getInstance().getLock();
			try
			{
				m_outStream.write(addCustomDevice());
			}
			finally
			{
				ThreadLock.getInstance().releaseLock();
			}
			return;
		}
		else if("30".equals(action))
		{
			m_outStream.write(showEngineHelpPreview("Preview.channel.html"));
			return;
		}
		else if("31".equals(action))
		{
			m_outStream.write(showEngineHelpSurf("Surf.deftype.html"));
			return;
		}
		else if("32".equals(action))
		{
			m_outStream.write(showEngineHelpSurf("Surf.channel.html"));
			return;
		}
		else if("33".equals(action))
		{
			m_outStream.write(showEngineHelpPreviewRemote("Preview.remote.channel.html"));
			return;
		}
		else if("34".equals(action))
		{
			m_outStream.write(showEngineHelpSurfRemote("Surf.remote.channel.html"));
			return;
		}
		else if("35".equals(action))
		{
			m_outStream.write(showEngineHelpPreviewRemote("Preview.remote.deftype.html"));
			return;
		}
		else if("36".equals(action))
		{
			m_outStream.write(showEngineHelpSurfRemote("Surf.remote.deftype.html"));
			return;
		}
		else if("37".equals(action))
		{
			suspendComputer();
			return;
		}
		else if("38".equals(action))
		{
			hibernateComputer();
			return;
		}
		else if("39".equals(action))
		{
			shutdownComputer();
			return;
		}
		else if("40".equals(action))
		{
			ThreadLock.getInstance().getLock();
			try
			{
				m_outStream.write(deleteFile());
			}
			finally
			{
				ThreadLock.getInstance().releaseLock();
			}
			return;
		}
		else if("41".equals(action))
		{
			ThreadLock.getInstance().getLock();
			try
			{
				m_outStream.write(editAutoDelItem());
			}
			finally
			{
				ThreadLock.getInstance().releaseLock();
			}
			return;
		}
		else if("42".equals(action))
		{
			ThreadLock.getInstance().getLock();
			try
			{
				m_outStream.write(nameNumberDevices());
			}
			finally
			{
				ThreadLock.getInstance().releaseLock();
			}
			return;
		}
		else if("43".equals(action))
		{
			m_outStream.write(addTheme());
			return;
		}
		else if("44".equals(action))
		{
			m_outStream.write(deleteTheme());
			return;
		}
		else if("45".equals(action))
		{
			m_outStream.write(doSelectedThemes());
			return;
		}
		else if("46".equals(action))
		{
			m_outStream.write(showEngineHelpRemoteFilePlay("Surf.remote.file.html"));
			return;
		}
		else if("47".equals(action))
		{
			m_outStream.write(runCommand());
			return;
		}
		else if("48".equals(action))
		{
			m_outStream.write(setAutoDelOverride());
			return;
		}
		else if("49".equals(action))
		{
			ThreadLock.getInstance().getLock();
			try
			{
				m_outStream.write(removeAllDevices());
			}
			finally
			{
				ThreadLock.getInstance().releaseLock();
			}
			return;
		}
		else if("50".equals(action))
		{
			ThreadLock.getInstance().getLock();
			try
			{
				m_outStream.write(addAllAvailableDevices());
			}
			finally
			{
				ThreadLock.getInstance().releaseLock();
			}
			return;
		}
		else if("51".equals(action))
		{
			ThreadLock.getInstance().getLock();
			try
			{
				m_outStream.write(updateDeviceDefaultData());
			}
			finally
			{
				ThreadLock.getInstance().releaseLock();
			}
			return;
		}
		else if("SystemGetTunerList".equals(action))
		{
			m_outStream.write(getTunerList());
			return;
		}
		else
			m_outStream.write(xmlShowSystemInfo());
	}

	private byte[] applyThemes() throws Exception
	{
		//String out = "HTTP/1.0 302 Moved Temporarily\nLocation: " +
		//"/servlet/" + m_urlData.getServletClass() + "?action=02\n\n";
		String out = "HTTP/1.0 302 Moved Temporarily\nLocation: /settings.html\n\n";

		String theme = m_urlData.getParameter("theme");

		m_store.setProperty("path.theme", theme);

		return out.getBytes("UTF-8");
	} 

	private byte[] showAvailableThemes() throws Exception
	{
		StringBuffer out = new StringBuffer();
		PageTemplate template = new PageTemplate(m_headers, m_urlData, "ShowThemes.html", true);

		String httpDir = m_store.getProperty("path.httproot", "http");
		String themeDir = m_store.getProperty("path.theme", "..");

		out.append("<option value=\"..\"");
		if("..".equalsIgnoreCase(themeDir))
			out.append(" SELECTED ");
		out.append(">default</option>\n");

		File themeDirs = new File(httpDir + File.separator + "themes");
		int count = 0;
		if(themeDirs.exists())
		{
			File[] dirs = themeDirs.listFiles();
			for(int x = 0; x < dirs.length; x++)
			{
				if ( dirs[x].isDirectory() && !dirs[x].getName().equalsIgnoreCase("default") )
				{
					count++;
					out.append("<option value=\"" + dirs[x].getName() + "\"");
					if(dirs[x].getName().equalsIgnoreCase(themeDir))
						out.append(" SELECTED ");
					out.append(">" + dirs[x].getName() + "</option>\n");
				}
			}
		}

		if(count == 0)
		{
			out.append("<option value=\"none\">none available</option>\n");
		}

		template.replace("$themeList", out.toString());
		template.replace("$userAgent", m_headers.get("User-Agent"));

		out.delete(0, out.length());
		for (int i=0; i<m_store.m_agentThemes.size(); i++)
		{
			String[] array = m_store.m_agentThemes.get(i);
			if (m_store.m_agentThemes.size() > 1)
				out.append("<tr><td><input type='checkbox' name='sel' value='" + i + "'></td>");
			else
				out.append("<tr><td></td>");
			out.append("<td>" + array[0] + "</td><td>" + (array[1].equals("..") ? "default" : array[1]) + "</td><td>");
			if (m_store.m_agentThemes.size() > 1)
				out.append("<input type='image' name='move." + i + "' align='absmiddle' border='0' alt='Move selected items above this item' title='Move selected items above this item' src='/images/moveBefore.png' width='24' height='24' onMouseOver='lineTop(this, true)' onMouseOut='lineTop(this, false)'>\n");
			out.append("<a href='/servlet/SystemDataRes?action=44&id=" + i + "'><img align='absmiddle' border='0' alt='Delete' title='Delete' src='/images/delete.png' width='24' height='24'></a></td>\n");
			out.append("</tr>");
		}
		if (m_store.m_agentThemes.size() > 1)
		{
			out.append("<tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td><input type='image' name='moveEnd' align='absmiddle' border='0' alt='Move selected items to end' title='Move selected items to end' src='/images/moveBefore.png' width='24' height='24' onMouseOver='lineTop(this, true)' onMouseOut='lineTop(this, false)'> <input type='image' name='delSel' align='absmiddle' border='0' alt='Delete selected items' title='Delete selected items' src='/images/delete.png' width='24' height='24'></td></tr>\n");
		}
		template.replace("$agentThemeList", out.toString());

		return template.getPageBytes();
	}

	private byte[] addTheme() throws Exception
	{
		String agent = m_urlData.getParameter("userAgent");
		String theme = m_urlData.getParameter("theme");
		m_store.addTheme(agent, theme);

		return getServletRedir("?action=19").getBytes("UTF-8");
	}

	private byte[] deleteTheme() throws Exception
	{
		int index = m_urlData.getParameterInt("id", -1);
		if (index > -1)
			m_store.deleteTheme(index);

		return getServletRedir("?action=19").getBytes("UTF-8");
	}

	private byte[] doSelectedThemes() throws Exception
	{
		String redir = getServletRedir("?action=19");

		String selected = m_urlData.getParameter("sel");
		if ( (selected == null) || (selected.isEmpty()) )
			return redir.getBytes("UTF-8");
		String[] selectedArray = selected.split("\n");
		Vector<Integer> selectedVector = new Vector<Integer>();
		for (int i=0; i<selectedArray.length; i++)
		{
			int sel = -1;
			try
			{
				sel = Integer.parseInt(selectedArray[i]);
			}
			catch(Exception e){}

			if (sel > -1)
				selectedVector.add(sel);
		}
		if (selectedVector.isEmpty())
			return redir.getBytes("UTF-8");

		if (m_urlData.getParameterStartsWith("delSel") != null)
		{
			m_store.deleteThemes(selectedVector);
		}
		else if (m_urlData.getParameterStartsWith("moveEnd") != null)
		{
			m_store.moveThemesBeforeTheme(-1, selectedVector);
		}
		else
		{
			int beforeIndex = -1;
			try
			{
				beforeIndex = Integer.parseInt(m_urlData.getParameterStartsWith("move.").split("\\.")[1]);
			}
			catch(Exception e){}

			if (beforeIndex > -1)
				m_store.moveThemesBeforeTheme(beforeIndex, selectedVector);
		}

		return redir.getBytes("UTF-8");
	}

	private byte[] showJavaEnviroment() throws Exception
	{
		StringBuffer biff = new StringBuffer(2048);

		NumberFormat nf = NumberFormat.getInstance();
		Runtime r = Runtime.getRuntime();
		long total = r.totalMemory();
		long free = r.freeMemory();     
		long max = r.maxMemory();

		biff.append("HTTP/1.0 200 OK\n");
		biff.append("Content-Type: text/plain\n");
		biff.append("Pragma: no-cache\n");
		biff.append("Cache-Control: no-cache\n\n");

		biff.append("--------------------------------------------------------------------------\n");
		biff.append("System Info\n");
		biff.append("--------------------------------------------------------------------------\n");
		biff.append("java.home: " + System.getProperty("java.home") + "\n");
		biff.append("java.class.path: " + "java.home" + System.getProperty("java.class.path") + "\n");
		biff.append("java.specification.version: " + System.getProperty("java.specification.version") + "\n");
		biff.append("java.specification.vendor: " + System.getProperty("java.specification.vendor") + "\n");
		biff.append("java.specification.name: " + System.getProperty("java.specification.name") + "\n");
		biff.append("java.version: " + System.getProperty("java.version") + "\n");
		biff.append("java.vendor: " + System.getProperty("java.vendor") + "\n");
		biff.append("java.vendor.url: " + System.getProperty("java.vendor.url") + "\n");
		biff.append("java.vm.specification.version: " + System.getProperty("java.vm.specification.version") + "\n");
		biff.append("java.vm.specification.vendor: " + System.getProperty("java.vm.specification.vendor") + "\n");
		biff.append("java.vm.specification.name: " + System.getProperty("java.vm.specification.name") + "\n");
		biff.append("java.vm.version: " + System.getProperty("java.vm.version") + "\n");
		biff.append("java.vm.vendor: " + System.getProperty("java.vm.vendor") + "\n");
		biff.append("java.vm.name: " + System.getProperty("java.vm.name") + "\n");
		biff.append("java.class.version: " + System.getProperty("java.class.version") + "\n");
		biff.append("os.home: " + System.getProperty("os.name") + "\n");
		biff.append("os.arch: " + System.getProperty("os.arch" + "\n"));
		biff.append("os.version: " + System.getProperty("os.version") + "\n");
		biff.append("user.name: " + System.getProperty("user.name") + "\n");
		biff.append("user.home: " + System.getProperty("user.home") + "\n");
		biff.append("user.dir: " + System.getProperty("user.dir") + "\n");
		biff.append("Runtime.maxMemory()   : " + nf.format(max) + "\n");
		biff.append("Runtime.totalMemory() : " + nf.format(total) + "\n");
		biff.append("Runtime.freeMemory() : " + nf.format(free) + "\n");
		biff.append("Time Zone ID     : " + Calendar.getInstance().getTimeZone().getID() + "\n");
		biff.append("Time Zone Name   : " + Calendar.getInstance().getTimeZone().getDisplayName() + "\n");
		biff.append("Time Zone DST    : " + Calendar.getInstance().getTimeZone().getDSTSavings() + "\n");
		biff.append("Time Zone Offset : " + Calendar.getInstance().getTimeZone().getRawOffset() + "\n");
		biff.append("--------------------------------------------------------------------------\n"); 

		biff.append("HTTP Headers\n--------------------------------------------------------------------------\n");
		String[] headName = (String[])m_headers.keySet().toArray(new String[0]);
		for(int x = 0; x < headName.length; x++)
		{
			biff.append(headName[x] + " : " + (String)m_headers.get(headName[x]) + "\n");
		}

		biff.append("--------------------------------------------------------------------------\n");

		biff.append("Timer Thread Status = " + m_store.timerStatus + "\n");
		biff.append("--------------------------------------------------------------------------\n");

		biff.append("Threads\n--------------------------------------------------------------------------\n");      
		ThreadGroup top = Thread.currentThread().getThreadGroup();
		StringBuffer buff = new StringBuffer();
		while (true)
		{
			if(top.getParent() != null)
				top = top.getParent();
			else
				break;
		}
		Thread[] theThreads = new Thread[top.activeCount()];
		top.enumerate(theThreads);
		for (int i = 0; i < theThreads.length; i++)
		{
			biff.append("Thread " + i + " : " + theThreads[i].getName() + " : " + theThreads[i].toString() + " : " + theThreads[i].getState() + "\n\n");
			StackTraceElement[] stack = theThreads[i].getStackTrace();
			buff.append("Thread " + i + " : " + theThreads[i].getName() + " : " + theThreads[i].toString() + " : " + theThreads[i].getState() + "\n");
			for(int q = 0; q < stack.length; q++)
			{
				buff.append(stack[q].toString() + "\n");
			}
			buff.append("\n");
		}
		biff.append("--------------------------------------------------------------------------\n");  

		biff.append("Thread StackTrace\n--------------------------------------------------------------------------\n");      
		biff.append(buff.toString());
		biff.append("--------------------------------------------------------------------------\n");        

		biff.append("ThreadLock Details\n--------------------------------------------------------------------------\n");      

		biff.append("Is Locked : " + ThreadLock.getInstance().isLocked() + "\n");
		biff.append("Has Queued Threads :  " + ThreadLock.getInstance().hasQueuedThreads() + "\n");
		biff.append("Queue Length : " + ThreadLock.getInstance().getQueueLength() + "\n");

		biff.append("--------------------------------------------------------------------------\n");        


		return biff.toString().getBytes("UTF-8");
	}

	private byte[] removeTask() throws Exception
	{
		String out = "HTTP/1.0 302 Moved Temporarily\nLocation: " +
				"/servlet/" + m_urlData.getServletClass() + "?action=08\n\n";

		if ( !isLocal() && m_store.isSecurity() )
		{
			out = "Security Warning:\n\n";
			out += "This action is not permitted from remote addresses, you can only perform\n";
			out += "this action from the machine that DV Scheduler is running on.\n\n";
			out += "Your current address is " + (String)m_headers.get("RemoteAddress");
			return out.getBytes("UTF-8");
		}

		HashMap<?, ?> tasks = m_store.getTaskList();

		String name = m_urlData.getParameter("name");
		tasks.remove(name);

		m_store.saveTaskList(null);

		return out.getBytes("UTF-8");
	}

	private byte[] addTask() throws Exception
	{
		HashMap<String, TaskCommand> tasks = m_store.getTaskList();

		String name = m_urlData.getParameter("name").trim();
		name = checkName(name);

		if(name != null && name.trim().length() > 0)
		{
			TaskCommand taskCommand = new TaskCommand(name);         
			tasks.put(taskCommand.getName(), taskCommand);
			m_store.saveTaskList(null);

			String out = "HTTP/1.0 302 Moved Temporarily\nLocation: " +
					"/servlet/" + m_urlData.getServletClass() + "?action=22&name=" + Formatter.encodeURL(name.trim(), "UTF-8") + "\n\n";      

			return out.getBytes("UTF-8");         
		}

		String out = "HTTP/1.0 302 Moved Temporarily\nLocation: " +
				"/servlet/" + m_urlData.getServletClass() + "?action=08\n\n";      

		return out.getBytes("UTF-8");
	}   

	private String checkName(String name)
	{
		return Formatter.format(name.trim());
		/*
		StringBuffer finalName = null;

		try
		{
			finalName = new StringBuffer(256);
			for (int x = 0; x < name.length(); x++)
			{
				char charAt = name.charAt(x);

				if((charAt >= 'a' && charAt <= 'z')
						|| (charAt >= 'A' && charAt <= 'Z')
						|| (charAt >= '0' && charAt <= '9') || charAt == ' ')
					finalName.append(charAt);
				else
					finalName.append('-');
			}

		}
		catch (Exception e)
		{
			name = "error";
		}

		return finalName.toString();
		 */
	}   

	private byte[] exportTaskList() throws Exception
	{
		StringBuffer buff = new StringBuffer();

		buff.append("HTTP/1.0 200 OK\nContent-Type: text/xml\n");
		buff.append("Content-Disposition: attachment; filename=\"Tasks.xml\"\n");
		buff.append("Pragma: no-cache\n");
		buff.append("Cache-Control: no-cache\n");
		buff.append("\n"); 

		m_store.saveTaskList(buff);

		return buff.toString().getBytes("UTF-8");
	}

	private byte[] setEpgTask() throws Exception
	{
		String out = "HTTP/1.0 302 Moved Temporarily\nLocation: " +
				"/servlet/" + m_urlData.getServletClass() + "?action=08\n\n";

		String taskDef = m_urlData.getParameter("Tasks.DefTask");
		if(taskDef == null || "none".equals(taskDef)) taskDef = "";
		m_store.setProperty("Tasks.DefTask", taskDef);

		String taskPre = m_urlData.getParameter("Tasks.PreTask");
		if(taskPre == null || "none".equals(taskPre)) taskPre = "";    
		m_store.setProperty("Tasks.PreTask", taskPre);

		String taskPreLive = m_urlData.getParameter("Tasks.PreLiveTask");
		if(taskPreLive == null || "none".equals(taskPreLive)) taskPreLive = "";    
		m_store.setProperty("Tasks.PreLiveTask", taskPreLive);

		taskDef = m_urlData.getParameter("Tasks.StartRecordErrorTask");
		if(taskDef == null || "none".equals(taskDef)) taskDef = "";
		m_store.setProperty("Tasks.StartRecordErrorTask", taskDef);

		taskDef = m_urlData.getParameter("Tasks.RecordErrorTask");
		if(taskDef == null || "none".equals(taskDef)) taskDef = "";
		m_store.setProperty("Tasks.RecordErrorTask", taskDef);

		taskDef = m_urlData.getParameter("Tasks.PidChangeTask");
		if(taskDef == null || "none".equals(taskDef)) taskDef = "";
		m_store.setProperty("Tasks.PidChangeTask", taskDef);

		return out.getBytes("UTF-8");
	}      

	private byte[] updateTask() throws Exception
	{
		String out = "HTTP/1.0 302 Moved Temporarily\nLocation: " +
				"/servlet/" + m_urlData.getServletClass() + "?action=08\n\n";

		if ( !isLocal() && m_store.isSecurity() )
		{
			out = "Security Warning:\n\n";
			out += "This action is not permitted from remote addresses, you can only perform\n";
			out += "this action from the machine that DV Scheduler is running on.\n\n";
			out += "Your current address is " + (String)m_headers.get("RemoteAddress");
			return out.getBytes("UTF-8");
		}

		String sessionID = m_urlData.getParameter("sessionID");
		if(!m_store.checkSessionId(sessionID))
		{
			out = "Security Warning: The Security Session ID you entered is not correct.";
			return out.getBytes("UTF-8");
		}

		HashMap<String, TaskCommand> tasks = m_store.getTaskList();

		String oldName = m_urlData.getParameter("oldName").trim();
		TaskCommand task = (TaskCommand)tasks.get(oldName);
		if (task == null)
			return out.getBytes("UTF-8");

		String newName = m_urlData.getParameter("name").trim();
		if ( !newName.equals(oldName) )
		{
			if ( tasks.containsKey(newName) )
			{
				int count = 1;
				while (tasks.containsKey(newName + "-" + ++count));

				newName += "-" + count;
			}

			tasks.remove(oldName);
			tasks.put(newName, task);
		}

		String command = m_urlData.getParameter("command");
		String autoRem = m_urlData.getParameter("autoRemove");
		String delay = m_urlData.getParameter("delay");

		Boolean autoRemove = new Boolean(false);
		if("true".equalsIgnoreCase(autoRem))
			autoRemove = new Boolean(true);

		Boolean allowSuspend = "true".equalsIgnoreCase(m_urlData.getParameter("allowSuspend"));

		String value = m_urlData.getParameter("whenNotCapturing");
		boolean bWhenNotCapturing = (value != null) && value.equalsIgnoreCase("true") ? true : false;

		value = m_urlData.getParameter("concurrentTasks");
		int maxConcurrentTask = 0;
		try
		{
			maxConcurrentTask = Integer.parseInt(value);
		}
		catch(Exception e){}

		value = m_urlData.getParameter("timeToNextSchedule");
		int minIdleTime = 0;
		try
		{
			minIdleTime = Integer.parseInt(value);
		}
		catch(Exception e){}

		int delayValue = 0;
		try
		{
			delayValue = Integer.parseInt(delay);
		}
		catch(Exception e){}

		task.setName(newName);
		task.setCommand(command.trim());
		task.setAutoRemove(autoRemove.booleanValue());
		task.setDelay(delayValue);
		task.setWhenNotCapturing(bWhenNotCapturing);
		task.setMaxConcurrentTask(maxConcurrentTask);
		task.setMinIdleTime(minIdleTime);
		task.setAllowSuspend(allowSuspend);

		m_store.saveTaskList(null);

		return out.getBytes("UTF-8");      
	}

	private byte[] xmlEditTask() throws Exception
	{
		String taskName = m_urlData.getParameter("name");
		HashMap<String, TaskCommand> tasks = m_store.getTaskList();
		TaskCommand task = (TaskCommand)tasks.get(taskName);
		if (task == null)
			return getRedirUrlRedir(null).getBytes("UTF-8");

		//
		// Creation of an XML document
		//
		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		DocumentBuilder db = dbf.newDocumentBuilder();
		DOMImplementation di = db.getDOMImplementation();

		Document doc = di.createDocument("", "editTask", null);
		Element root = doc.getDocumentElement();

		root.setAttribute("checkId", m_store.isSecurity() ? "1" : "0");

		task.getXML(doc, root);

		//
		// Send output back 
		//
		XSL transformer = new XSL(doc, "taskEdit.xsl", m_headers, m_urlData);
		return transformer.transform();
	}

	private byte[] enableTask() throws Exception
	{
		String out = "HTTP/1.0 302 Moved Temporarily\nLocation: " +
				"/servlet/" + m_urlData.getServletClass() + "?action=08\n\n";      

		if ( !isLocal() && m_store.isSecurity() )
		{
			out = "Security Warning:\n\n";
			out += "This action is not permitted from remote addresses, you can only perform\n";
			out += "this action from the machine that DV Scheduler is running on.\n\n";
			out += "Your current address is " + (String)m_headers.get("RemoteAddress");
			return out.getBytes("UTF-8");
		}      

		HashMap<?, ?> tasks = m_store.getTaskList();

		String enabled = m_urlData.getParameter("enabled");
		String name = m_urlData.getParameter("name");

		TaskCommand taskCommand = (TaskCommand)tasks.get(name);

		if(taskCommand != null)
		{
			if("true".equals(enabled))
				taskCommand.setEnabled(true);
			else
				taskCommand.setEnabled(false);

			m_store.saveTaskList(null);
		}

		return out.getBytes("UTF-8");      
	}

	private byte[] showTasks() throws Exception
	{
		StringBuffer out = new StringBuffer(2048);
		PageTemplate template = new PageTemplate(m_headers, m_urlData, "TaskList.html", true);

		if (!m_store.isSecurity())
		{
			template.replace("onSubmit='return checkID();'", "");
			template.replace("$style", "style='visibility:hidden'");
		}

		HashMap<String, TaskCommand> tasks = m_store.getTaskList();

		String[] keys = (String[])tasks.keySet().toArray(new String[0]);

		Arrays.sort(keys);

		for(int x = 0; x < keys.length; x++)
		{
			TaskCommand taskCommand = (TaskCommand)tasks.get(keys[x]);

			out.append("<tr>\n");

			if(taskCommand.getEnabled())
			{
				out.append("<td align='center'><a href='/servlet/" + m_urlData.getServletClass() + 
						"?action=17&name=" + Formatter.encodeURL(keys[x], "UTF-8") + 
						"&enabled=false'><img border='0' alt='Yes' title='Yes' src='/images/tick.png' width='24' height='24'></a></td>");
			}
			else
			{
				out.append("<td align='center'><a href='/servlet/" + m_urlData.getServletClass() + 
						"?action=17&name=" + Formatter.encodeURL(keys[x], "UTF-8") + 
						"&enabled=true'><img border='0' alt='No' title='No' src='/images/stop.png' width='24' height='24'></a></td>");
			}

			out.append("<td nowrap><a class='noUnder' title='Run this task' href='/servlet/" + m_urlData.getServletClass() + 
					"?action=47&command=" + Formatter.encodeURL(keys[x], "UTF-8") + 
					"'>" + HTMLEncoder.encode(keys[x]) + "</a></td>");

			out.append("<td nowrap>" + new Boolean(taskCommand.getAutoRemove()).toString() + "</td>");

			out.append("<td nowrap>" + new Integer(taskCommand.getDelay()).toString() + "</td>");

			out.append("<td>" + taskCommand.getCommand() + "</td>");

			out.append("<td align='center' nowrap>");

			out.append("<a class='noUnder' " +
					"href='/servlet/" + m_urlData.getServletClass() + 
					"?action=22&name=" + Formatter.encodeURL(keys[x], "UTF-8") + "'>");
			out.append("<img src='/images/edit.png' border='0' alt='Edit' title='Edit' width='24' height='24'></a> ");   

			out.append("<a class='noUnder' onClick='return confirmAction(\"Delete\");' " +
					"href='/servlet/" + m_urlData.getServletClass() + 
					"?action=10&name=" + Formatter.encodeURL(keys[x], "UTF-8") + "'>");
			out.append("<img src='/images/delete.png' border='0' alt='Delete' title='Delete' width='24' height='24'></a> ");

			out.append("</td>");

			out.append("</tr>\n");
		}

		template.replace("$taskList", out.toString());

		template.replace("$defEpgTaskSelect", getTaskSelect("Tasks.DefTask"));

		template.replace("$preTaskSelect", getTaskSelect("Tasks.PreTask"));

		template.replace("$preLiveTaskSelect", getTaskSelect("Tasks.PreLiveTask"));

		template.replace("$startRecordErrorTaskSelect", getTaskSelect("Tasks.StartRecordErrorTask"));

		template.replace("$recordErrorTaskSelect", getTaskSelect("Tasks.RecordErrorTask"));

		template.replace("$pidChangeTaskSelect", getTaskSelect("Tasks.PidChangeTask"));

		return template.getPageBytes();
	}        

	private String getTaskSelect(String selected)
	{
		String selectedTask = m_store.getProperty(selected, "");

		StringBuffer buff = new StringBuffer(1024);
		HashMap<String, TaskCommand> tasks = m_store.getTaskList();

		String[] keys = (String[])tasks.keySet().toArray(new String[0]);

		Arrays.sort(keys);

		buff.append("<select name='" + selected + "'>\n");

		if(selectedTask.length() == 0)
			buff.append("<option value='' selected>none</option>\n");
		else
			buff.append("<option value='' >none</option>\n");

		for(int x = 0; x < keys.length; x++)
		{
			if(selectedTask.equalsIgnoreCase(keys[x]))
				buff.append("<option value='" + HTMLEncoder.encode(keys[x]) + "' selected>" + HTMLEncoder.encode(keys[x]) + "</option>\n");
			else
				buff.append("<option value='" + HTMLEncoder.encode(keys[x]) + "'>" + HTMLEncoder.encode(keys[x]) + "</option>\n");
		}

		buff.append("</select>\n");

		return buff.toString();
	}

	private byte[] remAutoDelItem() throws Exception
	{
		String out = "HTTP/1.0 302 Moved Temporarily\nLocation: " +
				"/servlet/" + m_urlData.getServletClass() + "?action=06\n\n";

		String id = m_urlData.getParameter("id");

		m_store.removeAutoDeleteItem(id);
		m_store.saveAutoDelList();

		return out.getBytes("UTF-8");
	}

	private byte[] showAutoDelItems() throws Exception
	{
		StringBuffer out = new StringBuffer(2048);
		PageTemplate template = new PageTemplate(m_headers, m_urlData, "AutoDelItems.html", true);

		Map<String, KeepForDetails> items = m_store.getAutoDelList();
		String[] key = (String[])items.keySet().toArray(new String[0]);
		boolean bAutoDelOverride = m_store.isAutoDelOverride();
		int minute = m_store.getPropertyInt("AutoDel.OverrideMinutes", 0);
		int day = minute / 24 / 60;
		minute = minute % (24 * 60);
		template.replace("$autoDelOverride", bAutoDelOverride ? "checked" : "");
		template.replace("$autoDelDay", Integer.toString(day));
		template.replace("$autoDelMinute", Integer.toString(minute));
		for(int x = 0; x < key.length; x++)
		{
			KeepForDetails item = (KeepForDetails)items.get(key[x]);
			if (!bAutoDelOverride)
			{
				day = item.getKeepForMinutes() / 24 / 60;
				minute = item.getKeepForMinutes() % (24 * 60);
			}

			out.append("<tr>\n");
			out.append("<td>" + item.getCreated().toString() + "</td>");
			out.append("<td>" + item.getFileName() + "</td>");
			out.append("<td>" + day + " days, " + minute + " mins</td>");

			out.append("<td><a href='/servlet/" + m_urlData.getServletClass() + "?action=07&id=" + key[x] + "'><img src='/images/delete.png' border='0' alt='Delete' title='Delete' width='24' height='24'></a>");
			out.append("<a onClick='return confirmAction();' href='/servlet/" + m_urlData.getServletClass() + "?action=40&id=" + key[x] + "'><img src='/images/stopDelete.png' border='0' alt='Delete File' title='Delete File' width='24' height='24'></a>");
			out.append("<img class='hand' onClick='editAutoDelItem(this);' id='" + key[x] + "' day='" + day + "' minute='" + minute + "' src='/images/edit.png' border='0' alt='Edit' title='Edit' width='24' height='24'></td>");

			out.append("</tr>\n");
		}

		template.replace("$itemList", out.toString());
		template.replace("$autoDelLog", m_store.getAutoDelLog());

		return template.getPageBytes(); 
	}      

	private byte[] refreshTunerList() throws Exception
	{
		m_store.getTunerList(true);
		return getServletRedir("?action=SystemGetTunerList").getBytes("UTF-8");
	}

	private byte[] getTunerList() throws Exception
	{
		PageTemplate template = new PageTemplate(m_headers, m_urlData, "CardSetup.html", true);

		String typeStr = "<select name='networkType'>\n";
		for (int x = 0; x < m_store.getNetworkTypeSize(); x++)
		{
			String networkType = m_store.getNetworkType(x);
			typeStr += "<option id='networkType" + networkType + "' value='" + networkType + "'>" + networkType + "</option>\n";
		}
		typeStr += "</select>";
		template.replace("$typeList", typeStr);

		CaptureDeviceList devList = CaptureDeviceList.getInstance();

		/*
		int activeDevices = devList.getRunningDeviceCount();
		if(activeDevices > 0)
		{
			template.replace("$cardList", "Can not display devices, Captures Running!");
			template.replace("$cardCount", new Integer(activeDevices).toString()); 
			return template.getPageBytes();
		}
		 */

		Vector<CaptureDevice> tunersList = m_store.getTunerList(false);

		StringBuffer out = new StringBuffer();
		out.append("<tr><td colspan='4' style='border: 1px solid #FFFFFF;'><strong>Currently Selected Devices</strong></td></tr><tr><td>Name</td><td>Type</td><td>Tuning</td><td>Action</td></tr>");

		Set<String> deviceNames = new HashSet<String>();
		boolean bDuplicateName = false;
		Set<Integer> deviceNumbers = new HashSet<Integer>();
		boolean bDuplicateNumber = false;
		boolean bNegativeNumber = false;
		Set<String> deviceUniqueNames = new HashSet<String>();
		boolean bDuplicateUniqueName = false;
		boolean bEmptyUniqueName = false;
		for(int x = 0; x < devList.getDeviceCount(); x++)
		{
			CaptureDevice cd = (CaptureDevice)devList.getDevice(x);

			if (!deviceNames.add(cd.getName()))
				bDuplicateName = true;

			if (!deviceNumbers.add(cd.getNumber()))
				bDuplicateNumber = true;

			if (cd.getNumber() < 0)
				bNegativeNumber = true;

			if (!deviceUniqueNames.add(cd.getUniqueName()))
				bDuplicateUniqueName = true;

			if ( (cd.getUniqueName() == null) || (cd.getUniqueName().isEmpty()) )
				bEmptyUniqueName = true;

			out.append("<form action='/servlet/" + m_urlData.getServletClass() + "' method='POST'>");
			out.append("<input type='hidden' name='action' value='27'>");
			out.append("<input type='hidden' name='tunerID' value='" + x + "'>");

			out.append("<tr name='" + HTMLEncoder.encode(cd.getName()) + "' ");
			out.append("number='" + cd.getNumber() + "' ");
			out.append("uniqueName='" + HTMLEncoder.encode(cd.getUniqueName()) + "' ");
			out.append("networkType='" + HTMLEncoder.encode(cd.getNetworkType()) + "' ");
			out.append("tuningMethod='" + cd.getTuningMethod() + "' ");
			out.append("userData='" + HTMLEncoder.encode(cd.getUserData()) + "'>");

			out.append("<td>" + cd.getNumber() + ". " + cd.getName() + "</td>"); 

			out.append("<td nowrap>");
			out.append(" <select name='networkType' onChange='submit();'");
			out.append("style='background-color: #ffffff; color: #000000; border: 1px solid #ffffff; font-size: 10px;'>");
			for (int y = 0; y < m_store.getNetworkTypeSize(); y++)
			{
				String networkType = m_store.getNetworkType(y);
				out.append("<option value='" + networkType + "'");
				if(cd.getNetworkType().equals(networkType))
					out.append(" selected");
				out.append(">" + networkType + "</option>");
			}
			out.append("</select></td>");

			out.append("<td nowrap><select name='tuningMethod' onChange='submit();'");
			out.append("style='background-color: #ffffff; color: #000000; border: 1px solid #ffffff; font-size: 10px;'>");
			out.append("<option value='1'");
			if (cd.getTuningMethod() == CaptureDevice.TUNING_NORMAL)
				out.append(" selected");
			out.append(">Normal</option>");
			out.append("<option value='2'");
			if (cd.getTuningMethod() == CaptureDevice.TUNING_FAST)
				out.append(" selected");
			out.append(">Fast</option>");
			out.append("</select></td>");

			out.append("<td align='right'>");
			out.append("<a href='/servlet/SystemDataRes?action=14&tunerID=" + x + "'><img border='0' alt='Delete' title='Delete' src='/images/delete.png' align='absmiddle' width='24' height='24'></a> ");
			out.append("<img style='cursor:hand;cursor:pointer;' border=0 src='/images/edit.png' alt='Edit' title='Edit' onClick=\"edit('" + x + "');\" align='absmiddle' width='24' height='24'> ");
			out.append("<a href='/servlet/SystemDataRes?action=15&tunerID=" + x + "'><img border='0' alt='Up' title='Up' src='/images/up01.png' align='absmiddle' width='7' height='7'></a> ");
			out.append("<a href='/servlet/SystemDataRes?action=16&tunerID=" + x + "'><img border='0' alt='Down' title='Down' src='/images/down01.png' align='absmiddle' width='7' height='7'></a>");

			out.append("</td></tr>\n");
			out.append("</form>");
		}

		if (bEmptyUniqueName)
		{
			out.append("<tr><td class='warning' colspan='4'>Warning: One or more devices have no unique name. Please correct this.</td></tr>");
		}

		if (bDuplicateUniqueName)
		{
			out.append("<tr><td class='warning' colspan='4'>Warning: One or more devices have the same unique name. Please correct this.</td></tr>");
		}

		if (bDuplicateName)
		{
			out.append("<tr><td class='warning' colspan='4'>Warning: One or more devices have the same name. Click <a class='warning' href='/servlet/SystemDataRes?action=42'>here</a> to automaticaly rename the devices.</td></tr>");
		}

		if (bDuplicateNumber)
		{
			out.append("<tr><td class='warning' colspan='4'>Warning: One or more devices have the same number. Click <a class='warning' href='/servlet/SystemDataRes?action=42'>here</a> to automaticaly renumber the devices.</td></tr>");
		}

		if (bNegativeNumber)
		{
			out.append("<tr><td class='warning' colspan='4'>Warning: One or more devices have negative number. Click <a class='warning' href='/servlet/SystemDataRes?action=42'>here</a> to automaticaly renumber the devices.</td></tr>");
		}

		if(devList.getDeviceCount() == 0)
		{
			out.append("<tr><td colspan='4'>No devices selected</td></tr>");
		}
		else
			out.append("<tr><td><a onClick=\"return confirmDeleteAll();\" href=\"/servlet/SystemDataRes?action=49\" class=\"noUnder\"><img border=\"0\" src=\"/images/deleteAll.png\" align=\"absmiddle\" width=\"24\" height=\"24\"> Delete All</a></td></tr>");

		int numCards = 0;

		out.append("<tr><td colspan='4'><strong>&nbsp;</strong></td></tr>");
		out.append("<tr><td colspan='4' style='border: 1px solid #FFFFFF;'><strong><a href='/servlet/SystemDataRes?action=04' class='nounder'>Devices Available But Not Selected (Click to Refresh/Rescan)</a></strong></td></tr>");

		if (tunersList == null)
		{
			out.append("<tr><td colspan ='2'>No scan command found in capture engine path</td></tr>");
		}
		else if (!tunersList.isEmpty())
		{
			for(int x = 0; x < tunersList.size(); x++)
			{
				CaptureDevice dev = (CaptureDevice)tunersList.get(x);
				boolean found = false;
				for(int y = 0; y < devList.getDeviceCount(); y++)
				{
					CaptureDevice cd = (CaptureDevice)devList.getDevice(y);
					//if (cd.getID() == dev.getID() && cd.getName().equals(dev.getName()))
					if (!cd.getUniqueName().isEmpty() && cd.getUniqueName().equals(dev.getUniqueName()))
					{
						found = true;
						break;
					}
				}
				if(!found)
				{
					out.append("<tr>");
					out.append("<td>" + x + ". " + dev.getName() + " (" + dev.getNetworkType() + ")" + "</td>");
					out.append("<td width='50px'><a href='/servlet/SystemDataRes?action=13&tunerID=" + dev.getNumber() + "&networkType=" + Formatter.encodeURL(dev.getNetworkType(), "UTF-8"));
					out.append("&tunerUniqueName=" + Formatter.encodeURL(dev.getUniqueName(), "UTF-8"));
					out.append("&tunerName=" + Formatter.encodeURL(dev.getName(), "UTF-8") + "'>");
					out.append("<img border='0' alt='Add' title='Add' src='/images/add.png' align='absmiddle' width='24' height='24'></a></td>\n");
					out.append("</tr>");
					numCards++;
				}
			}
		}
		else if(numCards == 0)
		{
			out.append("<tr><td colspan ='2'>No devices available</td></tr>");
		}
		else
			out.append("<tr><td><a href=\"/servlet/SystemDataRes?action=50\" class=\"noUnder\"><img border=\"0\" src=\"/images/add.png\" align=\"absmiddle\" width=\"24\" height=\"24\"> Add All</a></td></tr>");

		numCards = 0;

		template.replace("$cardList", out.toString());

		//template.replace("$cardCount", new Integer(activeDevices).toString());
		template.replace("$cardCount", "-1");

		template.replace("$defaultData", devList.getDefaultData());

		return template.getPageBytes();      

	}

	private byte[] moveTunerUp() throws Exception
	{
		CaptureDeviceList devList = CaptureDeviceList.getInstance();

		int tunerIndex = -1;
		try
		{
			tunerIndex = Integer.parseInt(m_urlData.getParameter("tunerID"));
			//if(devList.getRunningDeviceCount() == 0)
			{
				if(tunerIndex > 0 && tunerIndex < devList.getDeviceCount())
				{
					CaptureDevice cap = devList.removeDevice(tunerIndex);
					devList.addDeviceAt(tunerIndex-1, cap);
					devList.saveDeviceList();
				}
			}
		}
		catch(Exception e)
		{}

		return getServletRedir("?action=SystemGetTunerList").getBytes("UTF-8");
	}

	private byte[] moveTunerDown() throws Exception
	{
		CaptureDeviceList devList = CaptureDeviceList.getInstance();

		int tunerIndex = -1;
		try
		{
			tunerIndex = Integer.parseInt(m_urlData.getParameter("tunerID"));
			//if(devList.getRunningDeviceCount() == 0)
			{
				if(tunerIndex >= 0 && tunerIndex < devList.getDeviceCount()-1)
				{
					CaptureDevice cap = devList.removeDevice(tunerIndex);
					devList.addDeviceAt(tunerIndex+1, cap);
					devList.saveDeviceList();
				}
			}
		}
		catch(Exception e)
		{}

		return getServletRedir("?action=SystemGetTunerList").getBytes("UTF-8");
	}   

	private byte[] addTunerToList() throws Exception
	{
		int tunerID = -1;
		String name = "";
		String uniqueName = "";
		String networkType = "DVB-T";
		try
		{
			tunerID = Integer.parseInt(m_urlData.getParameter("tunerID"));
			name = m_urlData.getParameter("tunerName");
			uniqueName = m_urlData.getParameter("tunerUniqueName");
			networkType = m_urlData.getParameter("networkType");
			List<String> networkTypes = NetworkType.getNetworkTypes(networkType);
			networkType = "";
			Iterator<String> iter = networkTypes.iterator();
			while (iter.hasNext())
			{
				String type = iter.next();
				if (m_store.isNetworkTypeValid(type))
				{
					networkType = type;
					break;
				}
			}

			if (networkType.isEmpty())
				networkType = "DVB-T";

			boolean alreadyAdded = false;

			CaptureDeviceList devList = CaptureDeviceList.getInstance();

			if(tunerID > -1)
			{
				for(int x = 0; x < devList.getDeviceCount(); x++)
				{
					CaptureDevice cap = (CaptureDevice)devList.getDevice(x);
					//if (cap.getID() == tunerID && cap.getName().equals(name))
					if (!cap.getUniqueName().isEmpty() && cap.getUniqueName().equals(uniqueName))
					{
						alreadyAdded = true;
					}
				}
			}

			if(alreadyAdded == false && tunerID > -1 /*&& devList.getRunningDeviceCount() == 0*/)
			{
				CaptureDevice cap = new CaptureDevice(name, tunerID, uniqueName, networkType);
				devList.addDevice(cap);
				devList.saveDeviceList();
			}
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}

		return getServletRedir("?action=SystemGetTunerList").getBytes("UTF-8");
	}

	private byte[] removeTunerFromList() throws Exception
	{
		int tunerIndex = -1;
		try
		{
			CaptureDeviceList devList = CaptureDeviceList.getInstance();

			tunerIndex = Integer.parseInt(m_urlData.getParameter("tunerID"));
			//if(devList.getRunningDeviceCount() == 0)
			{
				if(tunerIndex >= 0 && tunerIndex < devList.getDeviceCount())
				{
					devList.removeDevice(tunerIndex);
					devList.saveDeviceList();
				}
			}
		}
		catch(Exception e)
		{}

		return getServletRedir("?action=SystemGetTunerList").getBytes("UTF-8");
	} 

	private byte[] updateCaptureDevice() throws Exception
	{
		CaptureDeviceList devList = CaptureDeviceList.getInstance();

		int tunerIndex = -1;
		try
		{
			tunerIndex = Integer.parseInt(m_urlData.getParameter("tunerID"));
			if ( /*(devList.getRunningDeviceCount() == 0) &&*/ (tunerIndex >= 0) && (tunerIndex < devList.getDeviceCount()) )
			{
				CaptureDevice cap = devList.getDevice(tunerIndex);
				boolean bSave = false;
				String networkType = m_urlData.getParameter("networkType");
				if ( m_store.isNetworkTypeValid(networkType) )
				{
					cap.setNetworkType(networkType);
					bSave = true;
				}
				int tuningMethod = -1;
				try
				{
					tuningMethod = Integer.parseInt(m_urlData.getParameter("tuningMethod"));
				}
				catch(Exception e)
				{}
				if ( (tuningMethod == 1) || (tuningMethod == 2) )
				{
					cap.setTuningMethod(tuningMethod);
					bSave = true;
				}
				if (bSave)
					devList.saveDeviceList();
			}
		}
		catch(Exception e)
		{}

		return getServletRedir("?action=SystemGetTunerList").getBytes("UTF-8");
	}

	private byte[] setServerProperty() throws Exception
	{
		String out = "";
		String sessionID = m_urlData.getParameter("sessionID");
		if(!m_store.checkSessionId(sessionID))
		{
			out = "Security Warning: The Security Session ID you entered is not correct.";
			return out.getBytes("UTF-8");         
		}      

		out = "HTTP/1.0 302 Moved Temporarily\nLocation: /settings.html\n\n";

		String[] parameter = m_urlData.getParameterList();

		for(int x = 0; x < parameter.length; x++)
		{
			if(!parameter[x].equals("action") && !parameter[x].equals("sessionID"))
			{
				String value = m_urlData.getParameter(parameter[x]);
				if(value != null)
				{
					if (parameter[x].equals("Stream.port"))
					{
						if (!m_store.m_captureTasks.isEmpty() && !value.equals(m_store.getProperty("Stream.port", "50000-55000")))
						{
							out = "HTTP/1.0 302 Moved Temporarily\nLocation: " +
									"/servlet/" + m_urlData.getServletClass() + "?action=02&errormessage=Cannot set Default stream ports while captures running\n\n";
						}
						else
						{
							m_store.setProperty(parameter[x], value);
							if ( !m_store.setStreamPorts(false) )
							{
								out = "HTTP/1.0 302 Moved Temporarily\nLocation: " +
										"/servlet/" + m_urlData.getServletClass() + "?action=02&errormessage=Invalid Default stream ports entered, value has been reset to default\n\n";
							}
						}
					}
					else if (parameter[x].equals("Capture.deftype") && 
							!m_store.isCaptureTypeValid(value, m_urlData.getParameter("Capture.engine.path")))
					{
						out = "HTTP/1.0 302 Moved Temporarily\nLocation: " +
								"/servlet/" + m_urlData.getServletClass() + "?action=02&errormessage=Please check Default capture type\n\n";						
						m_store.setProperty(parameter[x], value);
					}
					/*
					else if (parameter[x].equals("Preview.deftype") && 
							!store.isPreviewTypeValid(value, m_urlData.getParameter("Capture.engine.path")))
					{
						out = "HTTP/1.0 302 Moved Temporarily\nLocation: " +
						"/servlet/" + m_urlData.getServletClass() + "?action=02&errormessage=Please check " + parameter[x] + "\n\n";						
						store.setServerProperty(parameter[x], value);
					}
					else if (parameter[x].equals("Surf.deftype") && 
							!store.isSurfTypeValid(value, m_urlData.getParameter("Capture.engine.path")))
					{
						out = "HTTP/1.0 302 Moved Temporarily\nLocation: " +
						"/servlet/" + m_urlData.getServletClass() + "?action=02&errormessage=Please check " + parameter[x] + "\n\n";						
						store.setServerProperty(parameter[x], value);
					}
					 */
					else if (parameter[x].equals("Capture.engine.path"))
					{
						value = new File(Formatter.formatDriveDirectory(value)).getPath();
						m_store.setProperty(parameter[x], value);
					}
					else if (parameter[x].equals("Capture.filename.patterns"))
					{
						m_store.setProperty(parameter[x], DVScheduler.checkBreaks(value).trim());
					}
					else if (parameter[x].equals("Capture.path"))
					{
						String[] paths = DVScheduler.getArray(DVScheduler.checkBreaks(value.trim()));
						value = "";
						for(int y = 0; y < paths.length; y++)
						{
							if (y != 0)
								value += "\n";

							value += new File(Formatter.formatDriveDirectory(paths[y])).getPath();
						}
						m_store.setProperty(parameter[x], value);
					}
					else if (parameter[x].equals("user.keywords"))
					{
						m_store.setProperty(parameter[x], DVScheduler.checkBreaks(value).trim());
					}
					else if (parameter[x].equals("EPG.webSearch"))
					{
						m_store.setProperty(parameter[x], DVScheduler.checkBreaks(value).trim());
					}
					else if (parameter[x].equals("email.server.password"))
					{
						if ( !value.equals("NoneUsesThisPass") )
							m_store.setProperty(parameter[x], value);
					}
					else if ( value.equals("*UNDEFINED*") && 
							!parameter[x].equals("Preview.deftype") && 
							!parameter[x].equals("Preview.remote.deftype") && 
							!parameter[x].equals("Surf.deftype") && 
							!parameter[x].equals("Surf.remote.deftype") )
					{
						out = "HTTP/1.0 302 Moved Temporarily\nLocation: " +
								"/servlet/" + m_urlData.getServletClass() + "?action=02&errormessage=Please check " + parameter[x] + "\n\n";						
						m_store.setProperty(parameter[x], value);
					}
					else
						m_store.setProperty(parameter[x], value);
				}
			}
		}

		return out.getBytes("UTF-8");
	}

	protected String formatOptionPassword(String name, String value, String description, String help, String unit)
	{
		return "<tr><td align='left'>" + (description == null ? name : description) + "</td><td>\n" + 
				"<input id='" + name + "' type='password' name='" + name + "' value='" + (value.isEmpty() ? "" : "NoneUsesThisPass") + "' size=" + (unit == null ? "'50'> " : ("'20'> " + unit)) + 
				"\n</td><td><img style='cursor:hand;cursor:pointer;' border=0 src='/images/help24.png' alt='Help' title='Help' align='absmiddle' onClick=\"showHelp('" + (help == null ? name : help) + "');\" width='24' height='24'>" + 
				"</td></tr>\n";
	}

	protected String formatOption(String name, String value, String description, String help, String unit)
	{
		return "<tr><td align='left'>" + (description == null ? name : description) + "</td><td>\n" + 
				"<input id='" + name + "' type='text' name='" + name + "' value='" + value + "' size=" + (unit == null ? "'50'> " : ("'20'> " + unit)) + 
				"\n</td><td><img style='cursor:hand;cursor:pointer;' border=0 src='/images/help24.png' alt='Help' title='Help' align='absmiddle' onClick=\"showHelp('" + (help == null ? name : help) + "');\" width='24' height='24'>" + 
				"</td></tr>\n";
	}

	protected String formatOptionTextArea(String key, String value, String description, String help)
	{
		return "<tr><td align='left'>" + (description == null ? key : description) + "</td><td>\n" + 
				"<textarea id='" + key + "' name='" + key + "' wrap='off' style=\"overflow:auto; height:80; width:325;\">\n" + HTMLEncoder.encode(value) + "</textarea>\n" + 
				"</td><td><img style='cursor:hand;cursor:pointer;' border=0 src='/images/help24.png' alt='Help' title='Help' align='absmiddle' onClick=\"showHelp('" + (help == null ? key : help) + "');\" width='24' height='24'>" + 
				"</td></tr>\n";
	}

	protected String formatOption(String name, Vector<String> keys, Vector<String> options, String value, String description, String help)
	{
		return "<tr><td align='left'>" + (description == null ? name : description) + "</td><td>" + 
				htmlDropMenu(keys, options, name, value) + 
				"</td><td><img style='cursor:hand;cursor:pointer;' border=0 src='/images/help24.png' alt='Help' title='Help' align='absmiddle' onClick=\"showHelp('" + (help == null ? name : help) + "');\" width='24' height='24'>" + 
				"</td></tr>\n";
	}

	protected String formatOption(String name, HashMap<String, String> options, String value, String description, String help)
	{
		return "<tr><td align='left'>" + (description == null ? name : description) + "</td><td>" + 
				htmlDropMenuSort(options, name, value) + 
				"</td><td><img style='cursor:hand;cursor:pointer;' border=0 src='/images/help24.png' alt='Help' title='Help' align='absmiddle' onClick=\"showHelp('" + (help == null ? name : help) + "');\" width='24' height='24'>" + 
				"</td></tr>\n";
	}

	private byte[] showServerProperties() throws Exception
	{
		Properties prop = m_store.getProperties();

		StringBuffer out = new StringBuffer(1024);
		String key = "";
		String value = "";
		HashMap<String, String> options = null;
		Vector<String> options2 = null;
		Vector<String> options3 = null;

		value = m_urlData.getParameter("errormessage");
		if (value != null)
		{
			out.append("<span class='warning'>" + value + "</span><br><br>");
		}

		// capture settings
		out.append("<tr><td colspan='3' align='left' style='border: 1px solid rgb(255, 255, 255);'>");
		out.append("<span class='areaTitle'>Capture Settings</span>\n");
		out.append("</td></tr>\n");

		key = "Capture.engine.path";
		String captureEnginePath = m_urlData.getParameter("Capture.engine.path");
		if (captureEnginePath == null)
			captureEnginePath = prop.getProperty(key, "util");
		out.append(formatOption(key, captureEnginePath, "Capture engine path", null, null));

		key = "Capture.deftype";
		value = prop.getProperty(key, "");
		options2 = m_store.getCaptureTypes(captureEnginePath);
		options2.remove(0);

		if (options2.isEmpty())
		{
			Vector<String> keys2 = new Vector<String>();
			keys2.add("*UNDEFINED*");
			options2.add("(No Valid Capture Type Found)");
			out.append(formatOption(key, keys2, options2, value, "Default capture type", null));
		}
		else
		{
			out.append(formatOption(key, options2, options2, value, "Default capture type", "/servlet/SystemDataRes?action=24&Capture.engine.path=" + Formatter.encodeURL(captureEnginePath, "UTF-8")));
		}

		key = "Capture.filename.patterns";
		value = prop.getProperty(key, "(%y-%m-%d %h-%M) %n [%c]\n%n [%c]\n%n\n%n\\%y-%m-%d");
		out.append(formatOptionTextArea(key, value, "Filename patterns", null));

		key = "Capture.path";
		value = prop.getProperty(key, "capture");
		out.append(formatOptionTextArea(key, value, "Capture paths", null));

		key = "Capture.pathSelection";
		value = prop.getProperty(key, "Max Space");
		options2 = new Vector<String>();
		options2.add("Max Space");
		options2.add("Sequential");
		options2.add("Random");
		options2.add("Evenly Distributed");
		out.append(formatOption(key, options2, options2, value, "Capture path selection", null));

		key = "Capture.minFreeSpace";
		value = prop.getProperty(key, "20000");
		out.append(formatOption(key, value, "Capture path minimum free space", null, "Megabyte"));

		key = "Capture.details";
		value = prop.getProperty(key, "same, end");
		options = new HashMap<String, String>();
		options.put("none", "None");
		options.put("same, beginning", "Same, beginning");
		options.put("same, end", "Same, end");
		options.put("path, beginning", "Path, beginning");
		options.put("path, end", "Path, end");
		out.append(formatOption(key, options, value, "Capture detail", null));

		key = "Capture.path.details";
		value = prop.getProperty(key, "");
		out.append(formatOption(key, value, "Capture detail path", null, null));

		key = "Capture.defaultDuration";
		value = prop.getProperty(key, "60");
		out.append(formatOption(key, value, "Default record duration", null, "minute"));

		key = "Capture.retryWait";
		value = prop.getProperty(key, "60");
		out.append(formatOption(key, value, "Retry wait time", null, "second"));

		key = "Capture.startTimeout";
		value = prop.getProperty(key, "65");
		out.append(formatOption(key, value, "Start capture timeout", null, "second"));

		key = "Capture.changeTimeout";
		value = prop.getProperty(key, "20");
		out.append(formatOption(key, value, "Change channel timeout", null, "second"));

		// Preview and Surf settings
		out.append("<tr><td colspan='3' align='left' style='border: 1px solid rgb(255, 255, 255);'>");
		out.append("<span class='areaTitle'>Preview and Surf Settings</span>\n");
		out.append("</td></tr>\n");      

		key = "Preview.deftype";
		value = prop.getProperty(key, "Preview");
		options2 = m_store.getPreviewTypes(captureEnginePath);
		options2.remove(0);

		if (options2.isEmpty())
		{
			Vector<String> keys2 = new Vector<String>();
			keys2.add("*UNDEFINED*");
			options2.add("(No Valid Preview Type Found)");
			out.append(formatOption(key, keys2, options2, value, "Default local preview command", null));
		}
		else
		{
			out.append(formatOption(key, options2, options2, value, "Default local preview command", "/servlet/SystemDataRes?action=26&Capture.engine.path=" + Formatter.encodeURL(captureEnginePath, "UTF-8")));
		}

		key = "Preview.remote.deftype";
		value = prop.getProperty(key, "Preview");
		options2 = m_store.getPreviewRemoteTypes(captureEnginePath);
		options2.remove(0);

		if (options2.isEmpty())
		{
			Vector<String> keys2 = new Vector<String>();
			keys2.add("*UNDEFINED*");
			options2.add("(No Valid Preview Type Found)");
			out.append(formatOption(key, keys2, options2, value, "Default remote preview command", null));
		}
		else
		{
			out.append(formatOption(key, options2, options2, value, "Default remote preview command", "/servlet/SystemDataRes?action=35&Capture.engine.path=" + Formatter.encodeURL(captureEnginePath, "UTF-8")));
		}

		key = "Surf.deftype";
		value = prop.getProperty(key, "Surf");
		options2 = m_store.getSurfTypes(captureEnginePath);
		options2.remove(0);

		if (options2.isEmpty())
		{
			Vector<String> keys2 = new Vector<String>();
			keys2.add("*UNDEFINED*");
			options2.add("(No Valid Surf Type Found)");
			out.append(formatOption(key, keys2, options2, value, "Default local surf command", null));
		}
		else
		{
			out.append(formatOption(key, options2, options2, value, "Default local surf command", "/servlet/SystemDataRes?action=31&Capture.engine.path=" + Formatter.encodeURL(captureEnginePath, "UTF-8")));
		}

		key = "Surf.remote.deftype";
		value = prop.getProperty(key, "Surf");
		options2 = m_store.getSurfRemoteTypes(captureEnginePath);
		options2.remove(0);

		if (options2.isEmpty())
		{
			Vector<String> keys2 = new Vector<String>();
			keys2.add("*UNDEFINED*");
			options2.add("(No Valid Surf Type Found)");
			out.append(formatOption(key, keys2, options2, value, "Default remote surf command", null));
		}
		else
		{
			out.append(formatOption(key, options2, options2, value, "Default remote surf command", "/servlet/SystemDataRes?action=36&Capture.engine.path=" + Formatter.encodeURL(captureEnginePath, "UTF-8")));
		}

		key = "Surf.remote.file";
		value = prop.getProperty(key, "Play");
		options2 = m_store.getPlayFileRemoteTypes(captureEnginePath);

		Vector<String> keys2 = new Vector<String>();
		keys2.add("*");
		keys2.addAll(options2);
		options2.add(0, "(Network path)");
		out.append(formatOption(key, keys2, options2, value, "Remote file play command", "/servlet/SystemDataRes?action=46&Capture.engine.path=" + Formatter.encodeURL(captureEnginePath, "UTF-8")));

		key = "Preview.disposition";
		value = prop.getProperty(key, "inline");
		options2 = new Vector<String>();
		options2.add("attachment");
		options2.add("inline");
		out.append(formatOption(key, options2, options2, value, "Preview disposition", null));

		key = "download.unsecure";
		value = prop.getProperty(key, "No");
		options2 = new Vector<String>();
		options2.add("No");
		options2.add("Yes");
		out.append(formatOption(key, options2, options2, value, "Allow unsecure download", null));

		m_store.setStreamPorts(true);
		key = "Stream.port";
		value = prop.getProperty(key, "50000-55000");
		out.append(formatOption(key, value, "Default stream ports", null, null));

		key = "video.width";
		value = prop.getProperty(key, "720");
		out.append(formatOption(key, value, "Default surf video width", null, "pixel"));

		key = "video.height";
		value = prop.getProperty(key, "405");
		out.append(formatOption(key, value, "Default surf video height", null, "pixel"));

		key = "surf.fileView";
		value = prop.getProperty(key, "Structured List");
		options2 = new Vector<String>();
		options2.add("Flat List");
		options2.add("Structured List");
		out.append(formatOption(key, options2, options2, value, "Default surf file browser view", null));

		key = "filebrowser.surfmasks";
		value = prop.getProperty(key, ".mpg,.mpeg,.bin,.mpv,.mpa,.ts,.tp,.dvr-ms,.rec,.pva,.avi,.mp4,.mkv");
		out.append(formatOption(key, value, "Surf file browser masks", null, null));

		key = "timeshift.keepforMinutes";
		value = prop.getProperty(key, "0");
		out.append(formatOption(key, value, "Keep time-shift file for", null, "minute"));

		// schedule settings
		out.append("<tr><td colspan='3' align='left' style='border: 1px solid rgb(255, 255, 255);'>");
		out.append("<span class='areaTitle'>Schedule Settings</span>\n");
		out.append("</td></tr>\n");      

		key = "Schedule.buffer.start";
		value = prop.getProperty(key, "4");
		out.append(formatOption(key, value, "Start buffer", null, "minute"));

		key = "Schedule.buffer.end";
		value = prop.getProperty(key, "5");
		out.append(formatOption(key, value, "End buffer", null, "minute"));

		key = "Schedule.buffer.EPG";
		value = prop.getProperty(key, "5");
		out.append(formatOption(key, value, "EPG buffer", null, "minute"));

		key = "Schedule.trackEpg";
		value = prop.getProperty(key, "Yes");
		options2 = new Vector<String>();
		options2.add("No");
		options2.add("Yes");
		out.append(formatOption(key, options2, options2, value, "Track EPG", null));

		key = "Schedule.autoAddRefresh";
		value = prop.getProperty(key, "Yes");
		options2 = new Vector<String>();
		options2.add("No");
		options2.add("Favorites Only");
		options2.add("Yes");
		out.append(formatOption(key, options2, options2, value, "Automatic Auto-Add scan", null));

		key = "Schedule.overlap";
		value = prop.getProperty(key, "1");
		options = new HashMap<String, String>();
		options.put("0", "No Overlap");
		options.put("1", "Allow Overlap");
		out.append(formatOption(key, options, value, "Overlap conflicts in Auto-Add", null));

		key = "Schedule.wake.system";
		value = prop.getProperty(key, "45");
		out.append(formatOption(key, value, "System wake-up allowance", null, "second"));

		// EPG settings
		out.append("<tr><td colspan='3' align='left' style='border: 1px solid rgb(255, 255, 255);'>");
		out.append("<span class='areaTitle'>EPG Settings</span>\n");
		out.append("</td></tr>\n");

		key = "EPG.compress";
		value = prop.getProperty(key, "Yes");
		options2 = new Vector<String>();
		options2.add("No");
		options2.add("Yes");
		out.append(formatOption(key, options2, options2, value, "Compress data", null));

		key = "EPG.displayDescription";
		value = prop.getProperty(key, "All");
		options2 = new Vector<String>();
		options2.add("All");
		options2.add("Balloon Only");
		out.append(formatOption(key, options2, options2, value, "Display program description", null));

		key = "EPG.balloonDelay";
		value = prop.getProperty(key, "0");
		out.append(formatOption(key, value, "Balloon delay", null, "millisecond"));

		key = "EPG.channelLength";
		value = prop.getProperty(key, "100");
		out.append(formatOption(key, value, "Channel length", null, "pixel"));

		key = "EPG.hourLength";
		value = prop.getProperty(key, "180");
		out.append(formatOption(key, value, "Hour length", null, "pixel"));

		key = "EPG.daysPerPage";
		value = prop.getProperty(key, "1");
		out.append(formatOption(key, value, "Default days per page", null, "day"));

		key = "EPG.channelsPerPage";
		value = prop.getProperty(key, "50");
		out.append(formatOption(key, value, "Default channels per page", null, "channel"));

		key = "EPG.oldestItem";
		value = prop.getProperty(key, "72");
		out.append(formatOption(key, value, "Keep past items for", null, "hour"));

		key = "EPG.leftClick";
		value = prop.getProperty(key, "Show Detail");
		options2 = new Vector<String>();
		options2.add("No Action");
		options2.add("Add Schedule");
		options2.add("New Schedule");
		options2.add("Show Detail");
		options2.add("Show Menu");
		out.append(formatOption(key, options2, options2, value, "Left-click action", null));

		key = "EPG.rightClick";
		value = prop.getProperty(key, "Add Schedule");
		out.append(formatOption(key, options2, options2, value, "Right-click action", null));

		key = "EPG.webSearch";
		value = prop.getProperty(key, "IMDB->http://www.imdb.com/find?q={title}\nWikipedia->http://en.wikipedia.org/wiki/Special:Search?search={title}");
		out.append(formatOptionTextArea(key, value, "Web search", null));

		// Auto-delete settings
		out.append("<tr><td colspan='3' align='left' style='border: 1px solid rgb(255, 255, 255);'>");
		out.append("<span class='areaTitle'>Auto-Delete Settings</span>\n");
		out.append("</td></tr>\n");

		key = "AutoDel.SetByDefault";
		value = prop.getProperty(key, "No");
		options2 = new Vector<String>();
		options2.add("No");
		options2.add("Yes");
		out.append(formatOption(key, options2, options2, value, "Auto-delete recording by default", null));

		key = "AutoDel.FreeSpaceLimit";
		value = prop.getProperty(key, "-1");
		out.append(formatOption(key, value, "Auto-delete free space threshold", null, "Megabyte"));

		key = "AutoDel.KeepFor";
		value = prop.getProperty(key, "30");
		out.append(formatOption(key, value, "Days to keep auto-delete file", null, "day"));

		key = "log.autodelete.maxline";
		value = prop.getProperty(key, "100");
		out.append(formatOption(key, value, "Max lines in auto-delete log", null, "line"));

		// email settings
		out.append("<tr><td colspan='3' align='left' style='border: 1px solid rgb(255, 255, 255);'>");
		out.append("<span class='areaTitle'>Email Settings</span>\n");
		out.append("</td></tr>\n");

		options2 = new Vector<String>();
		options2.add("No");
		options2.add("Yes");
		key = "email.serverStarted";
		value = prop.getProperty(key, "No");
		out.append(formatOption(key, options2, options2, value, "Send email on server started", null));

		key = "email.epgLoaded";
		value = prop.getProperty(key, "No");
		out.append(formatOption(key, options2, options2, value, "Send email on EPG loaded", null));

		key = "email.captureStart";
		value = prop.getProperty(key, "No");
		out.append(formatOption(key, options2, options2, value, "Send email on starting capture", null));

		key = "email.captureWarning";
		value = prop.getProperty(key, "No");
		out.append(formatOption(key, options2, options2, value, "Send email on capture warning", null));

		key = "email.captureError";
		value = prop.getProperty(key, "No");
		out.append(formatOption(key, options2, options2, value, "Send email on capture error", null));

		key = "email.captureFinished";
		value = prop.getProperty(key, "No");
		out.append(formatOption(key, options2, options2, value, "Send email on capture finished", null));

		key = "email.LowSpaceWarning";
		value = prop.getProperty(key, "-1");
		out.append(formatOption(key, value, "Low space warning threshold", null, "Megabyte"));

		key = "email.from";
		value = prop.getProperty(key, "");
		out.append(formatOption(key, value, "From", null, null));

		key = "email.from.name";
		value = prop.getProperty(key, "DVScheduler");
		out.append(formatOption(key, value, "Name", null, null));

		key = "email.server";
		value = prop.getProperty(key, "");
		out.append(formatOption(key, value, "Email server", null, null));

		key = "email.server.port";
		value = prop.getProperty(key, "25");
		out.append(formatOption(key, value, "Email server port", null, null));

		key = "email.connection.security";
		value = prop.getProperty(key, "None");
		options2 = new Vector<String>();
		options2.add("None");
		options2.add("SSL");
		options2.add("STARTTLS");
		out.append(formatOption(key, options2, options2, value, "Email connection security", null));

		key = "email.server.user";
		value = prop.getProperty(key, "");
		out.append(formatOption(key, value, "Email server user", null, null));

		key = "email.server.password";
		value = prop.getProperty(key, "");
		out.append(formatOptionPassword(key, value, "Email server password", null, null));

		key = "email.to";
		value = prop.getProperty(key, "");
		out.append(formatOption(key, value, "To", null, null));

		// Security settings
		out.append("<tr><td colspan='3' align='left' style='border: 1px solid rgb(255, 255, 255);'>");
		out.append("<span class='areaTitle'>Security Settings</span>\n");
		out.append("</td></tr>\n");

		out.append("<tr><td colspan='3' align='left'><div style='width:600px'>Usernames, passwords, web GUI protocol (HTTP, HTTPS), and other security settings currently can only be changed by editing \"users.list\" in folder \"data\" of where DV Scheduler is installed.</div></td><td>");

		// all other settings
		out.append("<tr><td colspan='3' align='left' style='border: 1px solid rgb(255, 255, 255);'>");
		out.append("<span class='areaTitle'>Other Settings</span>\n");
		out.append("</td></tr>\n");

		key = "HTTP.compress";
		value = prop.getProperty(key, "Yes");
		options2 = new Vector<String>();
		options2.add("No");
		options2.add("Yes");
		out.append(formatOption(key, options2, options2, value, "Compress pages", null));

		key = "format.time";
		value = prop.getProperty(key, "24");
		options = new HashMap<String, String>();
		options.put("12", "12 hour");
		options.put("24", "24 hour");
		out.append(formatOption(key, options, value, "Time format", null));

		key = "channel.logo";
		value = prop.getProperty(key, "1");
		options2 = new Vector<String>();
		options2.add("Text");
		options2.add("Icon");
		options2.add("Icon and Text");
		options3 = new Vector<String>();
		options3.add("0");
		options3.add("1");
		options3.add("2");
		out.append(formatOption(key, options3, options2, value, "Show channel logo", null));

		key = "channel.useLogo";
		value = prop.getProperty(key, "2");
		options2 = new Vector<String>();
		options2.add("None");
		options2.add("EPG");
		options2.add("EPG, Preview, Surf");
		options3 = new Vector<String>();
		options3.add("0");
		options3.add("1");
		options3.add("2");
		out.append(formatOption(key, options3, options2, value, "Show channel logo in", null));

		key = "channel.logoWidth";
		value = prop.getProperty(key, "64");
		out.append(formatOption(key, value, "Channel logo width", null, "pixel"));

		key = "filebrowser.masks";
		value = prop.getProperty(key, ".log,.mpg,.mpeg,.bin,.mpv,.mpa,.ts,.tp,.dvr-ms,.rec,.pva,.avi,.mp4,.mkv,.xml,.srt");
		out.append(formatOption(key, value, "File browser masks", null, null));

		key = "filebrowser.DirsAtTop";
		value = prop.getProperty(key, "1");
		options = new HashMap<String, String>();
		options.put("0", "At the bottom");
		options.put("1", "At the top");
		out.append(formatOption(key, options, value, "Show directories in file browser", null));

		key = "log.task.maxline";
		value = prop.getProperty(key, "100");
		out.append(formatOption(key, value, "Max lines in task log", null, "line"));

		m_store.checkUserKeywords();
		key = "user.keywords";
		value = prop.getProperty(key, "$$vlcexe->C:\\Program Files\\VideoLAN\\VLC\\vlc.exe");
		out.append(formatOptionTextArea(key, value, "User keywords", null));

		PageTemplate template = new PageTemplate(m_headers, m_urlData, "serverpropertie.html", true);

		if (!m_store.isSecurity())
		{
			template.replace("onSubmit='return checkID();'", "");
			template.replace("$style", "style='visibility:hidden'");
		}

		template.replace("$properties", out.toString());

		return template.getPageBytes();
	}

	public static String htmlDropMenuSort(HashMap<String, String> values, String name, String selected)
	{
		String data = "<SELECT id='" + name + "' NAME='" + name + "'>\n";
		data += "<OPTION VALUE='*UNDEFINED*'>(Please select one):</OPTION>\n";

		String[] keys = (String[])values.keySet().toArray(new String[0]);
		Arrays.sort(keys);
		for(int x = 0; x < keys.length; x++)
		{
			String marker = "";
			if(keys[x].equals(selected))
				marker = " selected";

			String value = (String)values.get(keys[x]);
			data += "<OPTION VALUE='" + keys[x] + "'" + marker + ">" + value + "</OPTION>\n";
		}

		data += "</SELECT>\n";
		return data;
	}

	public static String htmlDropMenu(Vector<String> keys, Vector<String> values, String name, String selected)
	{
		String data = "<SELECT id='" + name + "' NAME='" + name + "'>\n";
		data += "<OPTION VALUE='*UNDEFINED*'>(Please select one):</OPTION>\n";

		for(int x = 0; x < values.size(); x++)
		{
			String marker = "";
			if(keys.get(x).equals(selected))
				marker = " selected";

			data += "<OPTION VALUE='" + keys.get(x) + "'" + marker + ">" + values.get(x) + "</OPTION>\n";
		}

		data += "</SELECT>\n";
		return data;
	}

	public static String htmlDropMenu(Vector<String> values, String name, String selected)
	{
		return htmlDropMenu(values, values, name, selected);
	}

	private byte[] xmlShowSystemInfo() throws Exception
	{
		//
		// Creation of an XML document
		//
		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		DocumentBuilder db = dbf.newDocumentBuilder();
		DOMImplementation di = db.getDOMImplementation();

		Document doc = di.createDocument("", "systemInfo", null);
		Element root = doc.getDocumentElement();

		root.setAttribute("version", m_store.getVersion());
		root.setAttribute("timeStartedStr", dtf.format(DVScheduler.m_start));
		Date now = new Date();
		root.setAttribute("timeNowStr", dtf.format(now));
		root.setAttribute("upTimeStr", getTimeDifference( (System.nanoTime() - DVScheduler.m_startNano) / 1000000));
		root.setAttribute("sessionCapture", Long.toString(m_store.getSessionCapture()));
		root.setAttribute("sessionCaptureTimeStr", getTimeDifference(m_store.getSessionCaptureTime()));
		root.setAttribute("totalCapture", Long.toString(m_store.getTotalCapture()));
		root.setAttribute("totalCaptureTimeStr", getTimeDifference(m_store.getTotalCaptureTime()));

		Runtime r = Runtime.getRuntime();
		long total = r.totalMemory();
		long free = r.freeMemory();
		long freePercentage =  (long)(((double)free / (double)total) * 100);
		root.setAttribute("freeMemoryPercent", Long.toString(freePercentage));

		root.setAttribute("countChannel", Integer.toString(m_store.numberOfChannels()));
		root.setAttribute("countGroup", Integer.toString(m_store.getGroupSize()));
		root.setAttribute("countUser", Integer.toString(m_store.numberUsers()));
		root.setAttribute("countTrustedIp", Integer.toString(m_store.getTrustedIpSize()));
		root.setAttribute("countTrustedIpRange", Integer.toString(m_store.getTrustedIpRangeSize()));

		CaptureDeviceList devList = CaptureDeviceList.getInstance();
		root.setAttribute("countDevice", Integer.toString(devList.getDeviceCount()));
		root.setAttribute("countDeviceRunning", Integer.toString(devList.getRunningDeviceCount()));

		File cap = null;
		String fullPath = null;
		cap = new File(m_store.getProperty("path.httproot", "http"));
		fullPath = cap.getAbsolutePath();
		root.setAttribute("pathHttpd", fullPath);

		cap = new File(m_store.getProperty("path.data", "data"));
		fullPath = cap.getAbsolutePath();
		root.setAttribute("pathData", fullPath);

		cap = new File(DataStore.m_saveFolder);
		fullPath = cap.getAbsolutePath();
		root.setAttribute("pathUserData", fullPath);

		FileManagementDataRes.listFilesDirectories("/", null, root, doc, false, false);

		//
		// Send output back 
		//
		XSL transformer = new XSL(doc, "systemInfo.xsl", m_headers, m_urlData);
		return transformer.transform();
	}

	// Input timeDifference in millisecond.
	public static String getTimeDifference(long timeDifference)
	{
		timeDifference /= 1000;
		long day = timeDifference/(3600*24);
		long hour = (timeDifference/3600) % 24;
		long minute = (timeDifference/60) % 60;
		long second = timeDifference % 60;
		String sTimeDifference = null;
		if (day > 1)
		{
			sTimeDifference = String.format("%d days, %02d:%02d:%02d", 
					day, hour, minute, second);
		}
		else if (day > 0)
		{
			sTimeDifference = String.format("1 day, %02d:%02d:%02d", 
					hour, minute, second);
		}
		else
		{
			sTimeDifference = String.format("%02d:%02d:%02d", 
					hour, minute, second);
		}

		return sTimeDifference;
	}

	private byte[] showEngineHelpCapture(String helpFile) throws Exception
	{
		String captureEnginePath = m_urlData.getParameter("Capture.engine.path");

		if (captureEnginePath == null)
			captureEnginePath = m_store.getProperty("Capture.engine.path", "util");

		PageTemplate template = new PageTemplate(m_headers, m_urlData, "infoHelp.html");

		template.replaceFile("$info", (m_store.getCaptureTypes(captureEnginePath).size() <= 1) ?
				m_store.getHttpFile(m_headers.get("User-Agent"), "/docs/popup/Capture.deftype.html") : 
					captureEnginePath + File.separator + helpFile);

		return template.getPageBytes();
	}

	private byte[] showEngineHelpPreview(String helpFile) throws Exception
	{
		String captureEnginePath = m_urlData.getParameter("Capture.engine.path");

		if (captureEnginePath == null)
			captureEnginePath = m_store.getProperty("Capture.engine.path", "util");

		PageTemplate template = new PageTemplate(m_headers, m_urlData, "infoHelp.html");

		template.replaceFile("$info", (m_store.getPreviewTypes(captureEnginePath).size() <= 1) ?
				m_store.getHttpFile(m_headers.get("User-Agent"), "/docs/popup/Preview.deftype.html") : 
					captureEnginePath + File.separator + helpFile);

		return template.getPageBytes();
	}

	private byte[] showEngineHelpPreviewRemote(String helpFile) throws Exception
	{
		String captureEnginePath = m_urlData.getParameter("Capture.engine.path");

		if (captureEnginePath == null)
			captureEnginePath = m_store.getProperty("Capture.engine.path", "util");

		PageTemplate template = new PageTemplate(m_headers, m_urlData, "infoHelp.html");

		template.replaceFile("$info", (m_store.getPreviewRemoteTypes(captureEnginePath).size() <= 1) ?
				m_store.getHttpFile(m_headers.get("User-Agent"), "/docs/popup/Preview.remote.deftype.html") : 
					captureEnginePath + File.separator + helpFile);

		return template.getPageBytes();
	}

	private byte[] showEngineHelpSurf(String helpFile) throws Exception
	{
		String captureEnginePath = m_urlData.getParameter("Capture.engine.path");

		if (captureEnginePath == null)
			captureEnginePath = m_store.getProperty("Capture.engine.path", "util");

		PageTemplate template = new PageTemplate(m_headers, m_urlData, "infoHelp.html");

		template.replaceFile("$info", (m_store.getSurfTypes(captureEnginePath).size() <= 1) ?
				m_store.getHttpFile(m_headers.get("User-Agent"), "/docs/popup/Surf.deftype.html") : 
					captureEnginePath + File.separator + helpFile);

		return template.getPageBytes();
	}

	private byte[] showEngineHelpSurfRemote(String helpFile) throws Exception
	{
		String captureEnginePath = m_urlData.getParameter("Capture.engine.path");

		if (captureEnginePath == null)
			captureEnginePath = m_store.getProperty("Capture.engine.path", "util");

		PageTemplate template = new PageTemplate(m_headers, m_urlData, "infoHelp.html");

		template.replaceFile("$info", (m_store.getSurfRemoteTypes(captureEnginePath).size() <= 1) ?
				m_store.getHttpFile(m_headers.get("User-Agent"), "/docs/popup/Surf.remote.deftype.html") : 
					captureEnginePath + File.separator + helpFile);

		return template.getPageBytes();
	}

	private byte[] showEngineHelpRemoteFilePlay(String helpFile) throws Exception
	{
		String captureEnginePath = m_urlData.getParameter("Capture.engine.path");

		if (captureEnginePath == null)
			captureEnginePath = m_store.getProperty("Capture.engine.path", "util");

		PageTemplate template = new PageTemplate(m_headers, m_urlData, "infoHelp.html");

		template.replaceFile("$info", (m_store.getPlayFileRemoteTypes(captureEnginePath).size() <= 0) ?
				m_store.getHttpFile(m_headers.get("User-Agent"), "/docs/popup/Surf.remote.file.html") : 
					captureEnginePath + File.separator + helpFile);

		return template.getPageBytes();
	}

	private byte[] addCustomDevice() throws Exception
	{
		int number = -1;
		try
		{
			number = Integer.parseInt(m_urlData.getParameter("number"));
		}
		catch (Exception e) {}
		String networkType = m_urlData.getParameter("networkType");
		if (networkType == null)
			networkType = "";
		String name = m_urlData.getParameter("name");
		if (name == null)
			name = "";
		String uniqueName = m_urlData.getParameter("uniqueName");
		if (uniqueName == null)
			uniqueName = "";
		int tuningMethod = -1;
		try
		{
			tuningMethod = Integer.parseInt(m_urlData.getParameter("tuningMethod"));
		}
		catch (Exception e) {}
		String userData = m_urlData.getParameter("userData");
		if (userData == null)
			userData = "";
		/*
		else
			userData = userData.trim();
		 */
		int index = -1;
		String update = m_urlData.getParameter("update");
		if (update != null && update.equals("Update"))
		{
			try
			{
				index = Integer.parseInt(m_urlData.getParameter("index"));
			}
			catch(Exception e){}
		}

		CaptureDeviceList devList = CaptureDeviceList.getInstance();

		if (!name.isEmpty() && m_store.isNetworkTypeValid(networkType) /*&& devList.getRunningDeviceCount() == 0*/)
		{
			if ( (index > -1) && (index < devList.getDeviceCount()) )
			{
				CaptureDevice cap = devList.getDevice(index);
				cap.setName(name);
				cap.setUniqueName(uniqueName);
				cap.setNumber(number);
				cap.setNetworkType(networkType);
				if ( (tuningMethod == 1) || (tuningMethod == 2) )
					cap.setTuningMethod(tuningMethod);
				cap.setUserData(userData);
			}
			else
			{
				CaptureDevice cap = new CaptureDevice(name, number, uniqueName, networkType);
				if ( (tuningMethod == 1) || (tuningMethod == 2) )
					cap.setTuningMethod(tuningMethod);
				cap.setUserData(userData);
				devList.addDevice(cap);
			}

			devList.saveDeviceList();
		}

		return getServletRedir("?action=SystemGetTunerList").getBytes("UTF-8");
	}

	protected void runCommand(String commandID) throws Exception
	{
		Map<String, TaskCommand> tasks = m_store.getTaskList();
		TaskCommand taskCommand = tasks.get(commandID);

		if(taskCommand != null)
		{
			String command = taskCommand.getCommand();
			boolean autoRem = taskCommand.getAutoRemove();

			if ( taskCommand.isConditional() )
			{
				TaskItem taskItem = new TaskItem(taskCommand, command, null);
				ThreadLock.getInstance().getLock();
				try
				{
					DVScheduler.log("Queuing : " + command);
					m_store.m_waitingTaskList.add(taskItem);
				}
				finally
				{
					ThreadLock.getInstance().releaseLock();
				}
			}
			else
			{
				ThreadLock.getInstance().getLock();
				try
				{
					DVScheduler.log("Running : " + command);

					CommandWaitThread comThread = new CommandWaitThread(command, taskCommand.getDelay());
					Thread comWait = new Thread(Thread.currentThread().getThreadGroup(), comThread, comThread.getClass().getName());
					comWait.start();
					String key = new Long(new Date().getTime()).toString() + "-" + new Long(m_store.m_rand.nextLong()).toString();
					TaskItemThread taskItem = new TaskItemThread(key, comThread, command, autoRem);
					taskItem.m_allowSuspend = taskCommand.isAllowSuspend();
					Thread taskThread = new Thread(Thread.currentThread().getThreadGroup(), taskItem, taskItem.getClass().getName());
					taskThread.start();
					m_store.m_runningTaskList.put(key, taskItem);
				}
				finally
				{
					ThreadLock.getInstance().releaseLock();
				}
			}
		}
	}

	protected void suspendComputer() throws Exception
	{
		runCommand("Suspend Computer");
		m_outStream.write(getRedirUrlRedir(null).getBytes("UTF-8"));
		return;
	}

	protected void hibernateComputer() throws Exception
	{
		runCommand("Hibernate Computer");
		m_outStream.write(getRedirUrlRedir(null).getBytes("UTF-8"));
		return;
	}

	protected void shutdownComputer() throws Exception
	{
		runCommand("Shutdown Computer");
		m_outStream.write(getRedirUrlRedir(null).getBytes("UTF-8"));
		return;
	}

	private byte[] deleteFile() throws Exception
	{
		String id = m_urlData.getParameter("id");

		HashMap<String, KeepForDetails> items = m_store.getAutoDelList();

		KeepForDetails item = items.get(id);
		if (item != null)
		{
			new File(item.getFileName()).delete();
			items.remove(id);
		}

		return getServletRedir("?action=06").getBytes("UTF-8");
	}

	private byte[] editAutoDelItem() throws Exception
	{
		String id = m_urlData.getParameter("id");

		HashMap<String, KeepForDetails> items = m_store.getAutoDelList();

		KeepForDetails item = items.get(id);
		int keepForMinutes = m_urlData.getParameterInt("day", 30) * 24 * 60 + m_urlData.getParameterInt("minute", 0);
		item.setKeepForMinutes(keepForMinutes);

		return getServletRedir("?action=06").getBytes("UTF-8");
	}

	private byte[] nameNumberDevices() throws Exception
	{
		CaptureDeviceList devices = CaptureDeviceList.getInstance();

		Set<String> deviceNames = new HashSet<String>();
		Set<Integer> deviceNumbers = new HashSet<Integer>();
		int maxNumber = -1;
		for (int i=0; i<devices.getDeviceCount(); i++)
		{
			CaptureDevice dev = devices.getDevice(i);
			if (dev.getNumber() > maxNumber)
				maxNumber = dev.getNumber();
		}

		String name = null;
		for (int i=0; i<devices.getDeviceCount(); i++)
		{
			CaptureDevice dev = devices.getDevice(i);

			name = dev.getName();
			if (name.isEmpty() || deviceNames.contains(name))
			{
				int count = 0;
				String name2 = null;
				for (int j=0; j<100000; j++)
				{
					name2 = (name.isEmpty() ? "Device" : name) + "-" + ++count;
					if (!deviceNames.contains(name2))
					{
						dev.setName(name2);
						break;
					}
				}
			}

			if (dev.getNumber() < 0 || deviceNumbers.contains(dev.getNumber()))
				dev.setNumber(++maxNumber);

			deviceNames.add(name);
			deviceNumbers.add(dev.getNumber());
		}

		return getServletRedir("?action=SystemGetTunerList").getBytes("UTF-8");
	}

	protected byte[] runCommand() throws Exception
	{
		String commandID = m_urlData.getParameter("command");

		runCommand(commandID);

		return getRedir("/servlet/TaskManagementDataRes").getBytes("UTF-8");
	}

	private byte[] setAutoDelOverride() throws Exception
	{
		boolean bAutoDelOverride2 = "1".equals(m_urlData.getParameter("autoDelOverride"));

		int days2 = 0;
		try
		{
			days2 = Integer.parseInt(m_urlData.getParameter("autoDelDay"));
		}
		catch(Exception e){}

		int minutes2 = 0;
		try
		{
			minutes2 = Integer.parseInt(m_urlData.getParameter("autoDelMinute"));
		}
		catch(Exception e){}

		int minutes = m_store.getPropertyInt("AutoDel.OverrideMinutes", 0);
		int days = minutes / 24 / 60;
		minutes = minutes % (24 * 60);
		if ( (bAutoDelOverride2 != m_store.isAutoDelOverride()) || (days2 != days) || (minutes2 != minutes) )
		{
			ThreadLock.getInstance().getLock();
			try
			{
				DVScheduler.log("Changing auto-delete override : " + bAutoDelOverride2 + "," + days2 + "," + minutes2);
				m_store.setProperty("AutoDel.Override", bAutoDelOverride2 ? "1" : "0");
				m_store.setPropertyInt("AutoDel.OverrideMinutes", minutes2 + days2 * 60 * 24);
			}
			finally
			{
				ThreadLock.getInstance().releaseLock();
			}
		}

		return getServletRedir("?action=06").getBytes("UTF-8");
	}

	private byte[] removeAllDevices() throws Exception
	{
		try
		{
			CaptureDeviceList devList = CaptureDeviceList.getInstance();
			devList.removeAllDevices();
			devList.saveDeviceList();
		}
		catch(Exception e)
		{}

		return getServletRedir("?action=SystemGetTunerList").getBytes("UTF-8");
	}

	private byte[] addAllAvailableDevices() throws Exception
	{
		try
		{
			Vector<CaptureDevice> tunersList = m_store.getTunerList(true);

			CaptureDeviceList devList = CaptureDeviceList.getInstance();
			for(int x = 0; x < tunersList.size(); x++)
			{
				CaptureDevice dev = (CaptureDevice)tunersList.get(x);
				boolean found = false;
				for(int y = 0; y < devList.getDeviceCount(); y++)
				{
					CaptureDevice cd = (CaptureDevice)devList.getDevice(y);
					//if (cd.getID() == dev.getID() && cd.getName().equals(dev.getName()))
					if (!cd.getUniqueName().isEmpty() && cd.getUniqueName().equals(dev.getUniqueName()))
					{
						found = true;
						break;
					}
				}
				if(!found)
				{
					devList.addDevice(dev);
				}
			}
			devList.saveDeviceList();
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}

		return getServletRedir("?action=SystemGetTunerList").getBytes("UTF-8");
	}

	private byte[] updateDeviceDefaultData() throws Exception
	{
		String data = m_urlData.getParameter("defaultData", "");
		CaptureDeviceList devList = CaptureDeviceList.getInstance();
		devList.setDefaultData(data);
		devList.saveDeviceList();

		return getServletRedir("?action=SystemGetTunerList").getBytes("UTF-8");
	}
}
