// util.cpp : Defines the entry point for the DLL application.
//

#include <windows.h>
#include "log.h"
#include "TimerFunctions.h"
#include <jni.h>
#include "DllWrapper.h"

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
			{
				openLogFile("util-");
				log("Process Attached : util.dll\n");

				setupWakeupThread();

				break;
			}
		case DLL_PROCESS_DETACH:
			{
				log("Process Detached : util.dll\n");
				closeLogFile();
				
				break;
			}
		case DLL_THREAD_ATTACH:
			break;
		case DLL_THREAD_DETACH:
			break;
			
    }
    return TRUE;
}

JNIEXPORT jint JNICALL Java_DllWrapper_setWakeUpTime
  (JNIEnv *, jobject, jint year, jint month, jint day, jint hour, jint min, jint sec)
{
	return setWakeupTime(year, month, day, hour,  min, sec);
}

JNIEXPORT jlong JNICALL Java_DllWrapper_getFreeSpace
  (JNIEnv *env, jobject, jstring loc)
{
	const char *locationFile = env->GetStringUTFChars(loc, NULL);
	
	__int64 bytesFree = 0;
	
	try
	{
		BOOL bResult = GetDiskFreeSpaceEx(
			locationFile, 
			NULL,
			NULL,
			(PULARGE_INTEGER)&bytesFree);

		if (!bResult)
			bytesFree = -1;
	}
	catch(...)
	{
		bytesFree = -1;
	}
	
	env->ReleaseStringUTFChars(loc, locationFile);
	return (jlong)bytesFree;
}

JNIEXPORT jint JNICALL Java_DllWrapper_getCurrentProcessId
  (JNIEnv *, jobject)
{
	return GetCurrentProcessId();
}
